<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.html.core.*"%>
<%@ page import="java.util.*"%>
<%@ page import="com.hp.mx.database.GlobalSettings"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="loginPage" class="com.hp.mx.portal.ui.MxLoginPage" scope="session"/>

<%
   MxHtmlUtil.jspInit(request, response);
   MxHtmlUtil.unfixSessionId(request, response);

   loginBean.setLocaleForcibly(request);
   loginPage.setLocale(loginBean.getLocale());

   ResourceBundle authRB = ResourceBundle.getBundle("mxglobal", loginBean.getLocale());

   String secureURL= "https://" + request.getServerName() +
          ":" + GlobalSettings.getProperty("Login.secure-port", "50000");

   if ( ! request.isSecure() )
   {
      secureURL += request.getRequestURI();

      if ( request.getQueryString() != null )
         secureURL += "?" + request.getQueryString();

      out.println("<script>document.location.replace('" + secureURL + "')</script>");
      return;
   }

   // If the remoteUser exists there is no need to authenticate, forward to portal
   if ( request.getRemoteUser() != null )
   {
      out.println("<script>document.location.replace('" + secureURL + "')</script>");
      return;
   }

   String logonButtonText = authRB.getString("login.logon-secure");
   String username = authRB.getString("login.username");
   String password = authRB.getString("login.password");
   String domain = authRB.getString("login.domain");

   boolean bIsErrorPage = (request.getRequestURI().indexOf("error.jsp") >= 0);
%>

<html>
    <head>
        <title>HP Systems Insight Manager</title>

        <link type='text/css' rel='stylesheet' href='/mxhtml/css/default.css'>
        <link type='text/css' rel='stylesheet' href='/mxhtml/css/blue_theme.css'>
        <script language='javascript' type='text/javascript'>
            <jsp:include page="loginscript.jsp" />
        </script>
    </head>

<body class="signInBody" onLoad='logon_onLoad()' onUnload='closeWindow()'>

<table class="signInTable" border=0 cellpadding=0 cellspacing=0>
    <tr>
        <td class="hpLogo"><img src="/mxhtml/images/signin_logo.gif" border="0"></td>
        <td rowspan="3" class="signInFiller1">&nbsp;</td>
        <td rowspan="3"><img src="/mxhtml/images/signin_image.jpg" border=0></td>
    </tr>
    <tr>
        <td class="signInFiller2">&nbsp;</td>
    </tr>
    <tr>
        <td class="signInTitle"><h1>Systems Insight Manager</h1></td>
    </tr>
    <tr>
        <td colspan="3" class="signInFiller3"></td>
    </tr>
</table>

<!-- Support to add custom prompt to login page -->
<jsp:include page="prompt" />

<form method="POST" action="j_security_check" onSubmit="return myOnSubmit()">
    <input type="hidden" name="<%=MxLoginPage.DOM_J_USERNAME%>" id="<%=MxLoginPage.DOM_J_USERNAME%>">
    <input type="hidden" name="<%=MxLoginPage.DOM_J_PASSWORD%>" id="<%=MxLoginPage.DOM_J_PASSWORD%>">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
<% if (bIsErrorPage)
   { %>
        <tr>
            <td>&nbsp;</td>
            <td colspan="2"><div class="signInFailure">
                <%=authRB.getString("error.invalid-credentials")%>
            </div></td>
        </tr>
<% } %>
        <tr>
            <td>&nbsp;</td>
            <td class="signInText"><%=username%></td>
            <td class="signInInput">
                <input type="text" name="<%=MxLoginPage.DOM_USERNAME%>" id="<%=MxLoginPage.DOM_USERNAME%>" onKeyup="resetPageRefreshTimer()" maxlength='<%=MxLoginPage.MAXLENGTH_USERNAME%>'>
            </td>
        </tr>
        <tr>
            <td>&nbsp;</td>
            <td class="signInText"><%=password%></td>
            <td class="signInInput">
                <input type="password" name="<%=MxLoginPage.DOM_PASSWORD%>" id="<%=MxLoginPage.DOM_PASSWORD%>" onKeyup="resetPageRefreshTimer()" maxlength='<%=MxLoginPage.MAXLENGTH_PASSWORD%>'>
            </td>
        </tr>
<% if (loginBean.showDomainName())
   { %>
        <tr>
            <td>&nbsp;</td>
            <td class="signInText"><%=domain%></td>
            <td class="signInInput">
                <input type="text" name="<%=MxLoginPage.DOM_DOMAIN%>" id="<%=MxLoginPage.DOM_DOMAIN%>" onKeyup="resetPageRefreshTimer()" maxlength='<%=MxLoginPage.MAXLENGTH_DOMAIN%>'>
            </td>
        </tr>
<% } %>
        <tr id="<%=MxLoginPage.ID_ZONE_FIELD%>" style="display:none">
            <td>&nbsp;</td>
            <td class="signInText"><%=authRB.getString("login.time-zone")%></td>
            <td class="signInInput">
                <% MxLoginPage.dumpTimeZoneSelector(out, loginBean.getLocale()); %>
            </td>
        </tr>
        <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td width="387">
                <div style="padding-top:10px;">
                    <div class="bWrapperUp bEmphasized" style="float:left;margin-left:1px">
                        <div><div><input id="<%=MxLoginPage.DOM_LOGIN%>" type="submit" class="hpButton" style="width:83px" value="<%=logonButtonText%>"></div></div>
                    </div>
                </div>
            </td>
        </tr>
    </table>
</form>

<% loginPage.dumpWarningBlocks(out, request); %>

<jsp:include page="loginhelp.jsp" />

</body>
</html>
