
<%@ page info="HP Systems Insight Manager"
    import="com.hp.mx.database.*,
    com.hp.mx.core.nodemanager.*,
        java.sql.Statement,
    java.sql.Connection,
    java.sql.ResultSet,
    java.sql.DatabaseMetaData,
    java.sql.SQLException"
    errorPage="handleJspError.jsp"
%>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
%>

<HTML>
<HEAD>



<%!
    String displayObject (Object obj)
    {
        String val = "";
        if (obj != null)
            val = obj.toString().trim();
        if (val.length() == 0)
            val = "&nbsp;";
        return val;
    }

    String displayStatus (Object obj)
    {

        int status = ((Integer)obj).intValue();
        String val = "";
        if (status == DeviceStatusType.UNKNOWN.getStatusValue())
            val = "<img src='../img/c1/st0.gif'  width=13 height=13 border=0 alt='Unknown'> Unknown";
        else if (status == DeviceStatusType.NORMAL.getStatusValue())
            val = "<img src='../img/c1/st1.gif'  width=13 height=13 border=0 alt='Normal'> Normal";
        else if (status == DeviceStatusType.MINOR.getStatusValue())
            val = "<img src='../img/c1/st3.gif'  width=13 height=13 border=0 alt='Minor'> Minor";
        else if (status == DeviceStatusType.MAJOR.getStatusValue())
            val = "<img src='../img/c1/st4.gif'  width=13 height=13 border=0 alt='Major'> Major";
        else if (status == DeviceStatusType.CRITICAL.getStatusValue())
            val = "<img src='../img/c1/st5.gif'  width=13 height=13 border=0 alt='Critical'> Critical";
        return val;
    }

%>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>
<script>
    document.styleSheets[0].addRule("TD", "{font-family:verdana; font-size:8pt}");
</script>
</HEAD>
<BODY>



<%
    Connection myConnection = null;
    Statement p = null;
    ResultSet  rSet = null;
    try
    {
        // Begin Database setup
        myConnection = DatabaseManager.getDefaultDatabase().getConnection("JSP Page: htmldevicelist.jsp");

        // Define the default device query (all devices)
        String baseDeviceQuery ="SELECT  devices.OverallStatus, devices.Name, devices.ProductTypeStr, IPAddress.IPAddress, IPXAddress.IPXAddress, devices.DeviceKey, NoticeId, devices.ProductName ";
        baseDeviceQuery += " FROM devices  JOIN notices ON devices.deviceKey = notices.deviceKey and notices.NoticeType = 1 ";
        baseDeviceQuery += "LEFT OUTER JOIN DB_deviceInfoEx ON devices.deviceKey = DB_deviceInfoEx.deviceKey LEFT OUTER JOIN IPAddress ON devices.deviceKey = IPAddress.deviceKey and IPAddress.ipIndex = 0 ";
        baseDeviceQuery += "LEFT OUTER JOIN IPXAddress ON devices.deviceKey = IPXAddress.deviceKey and IPXAddress.ipxIndex = 0 LEFT OUTER JOIN associated_device_data ON devices.deviceKey = associated_device_data.deviceKey  ";
        baseDeviceQuery += "LEFT OUTER JOIN deviceProtocolInfo ON devices.deviceKey = deviceProtocolInfo.deviceKey ";
        baseDeviceQuery += "LEFT OUTER JOIN DeviceStatusValue ON devices.deviceKey = DeviceStatusValue.deviceKey and DeviceStatusValue.StatusSourceId= 6 ";

        baseDeviceQuery += "ORDER BY OverallStatus DESC ";
        //String baseDeviceQuerySort = "ORDER BY OverallStatus DESC ";
//        String theSqlQuery = request.getParameter("txtSqlQuery");
        String theSqlQuery = baseDeviceQuery;
        if (theSqlQuery != null)
        {
            // Replacx carriage returns with spaces to generate proper HTML after POST
            theSqlQuery = theSqlQuery.replace('\n', ' ');
            theSqlQuery = theSqlQuery.replace('\r', ' ');
    %>
    <%= theSqlQuery %>

<BR>

    <div class=XePageTitle align="center">SQL QUERY RESULTS</div>
    <%
            // Continue accessing the database
            int dvcCount = 0;
            String bgColor = "#FFFFFF";

            p = myConnection.createStatement();
            rSet = p.executeQuery(theSqlQuery);

            // Display the result set in a table
            out.println("<table width='100%' border='1' cellspacing='0' cellpadding='2' bordercolor='Black'>");

            // First, display the column headers
            out.println("<TR style='color:white; background:#006699'>");
            out.println("<TD>STATUS</TD>");
            out.println("<TD>DEVICE NAME</TD>");
            out.println("<TD>DEVICE TYPE</TD>");
            out.println("<TD>DEVICE ADDRESSES</TD>");
            out.println("<TD>PRODUCT NAME</TD>");
            out.println("</TR>");

            // Next, display the results
            while (rSet.next())
            {
                if ((dvcCount %2) == 0)
                    bgColor = "#CCCCCC";
                else
                    bgColor = "#FFFFFF";

                // Get the data from the row (must be in column order)

                Object status = rSet.getObject("OverallStatus");
                Object dvcName = rSet.getString("Name");
                Object prodType = rSet.getString("ProductTypeStr");
                Object ipAddress = rSet.getObject("IPAddress");
                Object dvcKey = rSet.getObject("DeviceKey");
                Object dvcNoticeId = rSet.getObject("NoticeId");
                Object prodName = rSet.getString("ProductName");
                System.out.println(prodName);


                // Disply the data from the row (not necessarily in column order)
                out.println("<TR bgColor='" + bgColor + "'>");
                out.println("<td>" + displayStatus(status) + "</td>");
                out.println("<TD>"+ displayObject(dvcName) + "</TD>");
                out.println("<TD>" + prodType + "</TD>");
                out.println("<TD>" + displayObject(ipAddress) + "</TD>");
                out.println("<TD>" + displayObject(prodName) + "</TD>");
                out.println("</TR>");
                dvcCount++;
            }
            out.println("</TABLE>");
            out.println("<BR><BR>ROW COUNT: " + dvcCount);

        }
    }
    catch (Exception ex)
    {
        out.println("<span class=errorText>Exception occurred while trying to access the database..Bummer!</span><BR>");
        out.println(ex +"<BR>" + ex.getCause());
    }
    finally
    {
        try
        {
            // Database cleanup
            if (rSet != null)
                rSet.close();
            if (p != null)
                p.close();
        }
        catch (Exception ex)
        {
        }
        DatabaseManager.getDefaultDatabase().releaseConnection(myConnection);
    }

%>



</BODY>
</html>
