<%@ page import="com.hp.mx.security.*,
com.hp.mx.portal.session.*,
                 java.util.*"
%>
<%@ page import="com.hp.mx.core.protocol.snmp.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }

    String devIp = "";
    if (request.getParameter( "sysAddress" ) != null)
    {
        devIp = request.getParameter( "sysAddress" );
    }
    String comStr = "public";
    if (request.getParameter( "comStr" ) != null)
    {
        comStr = request.getParameter( "comStr" );
    }
    String oidStr = "1.3.6.1.2.1";
    if (request.getParameter( "oidStr" ) != null)
    {
        oidStr = request.getParameter( "oidStr" );
    }


%>

<HTML>
<HEAD>


<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>
</head>
<BODY>
    <form name="snmpForm" action="snmpgetNext.jsp" method="post">
    This will make a SNMP GET NEXT request until the current tree is exhausted.<br><br>
    <table>
    <tr><td>Host IP</td><td> <input type="text" value="<%=devIp%>"  name="sysAddress"></td></tr>
    <tr><td>Community String </td><td> <input type="text" value="<%=comStr%>" name="comStr" ></td></tr>
    <tr><td>SNMP OID </td><td> <input type="text" value="<%=oidStr %>" name="oidStr" size=60></td></tr>
    <tr><td> <input type="checkbox"  name="wantNames" size=60></td><td>Get Descriptive Name </td></tr>

    </table>
    <br>
        <input type="submit"  value="RUN">
    </FORM>
<%
if (request.getMethod().equalsIgnoreCase("POST") )
{
    if (devIp != null && devIp.length() > 0)
    {
        if (comStr == null || comStr.length() == 0)
        {
            out.println("need community string ");
        }
        else if (oidStr == null || oidStr.length() == 0)
        {
            out.println("need OID string ");
        }
        else
        {
%>
        Getting Data...<br>
            <table width="100%" border="1">
            <tr>
            <td width="15%">OID</td><td width="15%">Name</td><td width="70%">Value </td>
            </tr>
<%
            out.flush();
            // lets try...
            boolean error = false;
            SnmpRequest curReq = new SnmpRequest();
            curReq.setDeviceAddress(devIp);
            curReq.addSnmpGetVarbind(oidStr);
            curReq.setCommunityName(comStr);
            curReq.setNumberOfRetries("1");
            curReq.setTimeout("4");

            String lastOid = oidStr;
            MibVariable mibVar = new MibVariable();
            int cnt = 0;
            int lastPos = 2;

            while (error == false)
            {
                curReq.setDeviceAddress(devIp);
                curReq.setCommunityName(comStr);
                curReq.setNumberOfRetries("1");
                curReq.setTimeout("4");

                try
                {
                curReq.SnmpGetNext();
                SnmpResponse resp = curReq.getResponseVarbinds();
                SnmpResponseVarBind oneVb = resp.getFirst();
                if (resp.getIsError() == true || oneVb == null || oneVb.isError() == true)
                {
                    out.println("<tr><td colspan=3>Error ");
                    out.print(lastOid);
                    out.print(" resp= ");
                    out.print(oneVb);
                    out.println("</td></tr>");
                    error = true;
                }
                else
                {
                    out.print("<tr><td width=\"15%\">");
                    out.print(oneVb.getOid());
                    out.println("&nbsp&nbsp</td>");
                    out.print("<td width=\"15%\">");

                    if (request.getParameter("wantNames") != null)
                    {
                        // remove .0 - tables, hmmm
                        mibVar.setVarname("unknown");
                        int pos = 0;

                        String respOid = new String(oneVb.getOid());
                        // try to make best guess of the mib name.
                        if (lastPos < (respOid.length()-6))
                        {
                            pos = lastPos;
                        }
                        else
                        {
                            pos = 2;
                        }

                        mibVar.loadObjectInfoByOid(respOid.substring(0, respOid.length() - pos) );

                        if (mibVar.getVarname().equals("unknown") )
                        {
                            pos = 2;
                            mibVar.loadObjectInfoByOid(respOid.substring(0, respOid.length() - pos) );
                        }

                        // 6 == "1.3.6.1." len
                        if (mibVar.getVarname().equals("unknown")  )
                        {
                            pos++;

                            while (mibVar.getVarname().equals("unknown") && ( pos < (respOid.length()-6) && pos < 30))
                            {
                                mibVar.loadObjectInfoByOid(respOid.substring(0, respOid.length() - pos) );
                                pos++;
                            }
                        }

                        out.print(mibVar.getVarname());

                        if (mibVar.getVarname().equals("unknown") == false)
                        {
                            lastPos = pos;
                        }
                    }


                    out.println("&nbsp&nbsp</td>");
                    out.print("<td width=\"70%\">");
                    switch(oneVb.getIntType())
                    {
                        case SnmpRequest.SNMP_TYPE_INTEGER:
                        case SnmpRequest.SNMP_TYPE_COUNTER:
                        case SnmpRequest.SNMP_TYPE_GAUGE:
                        case SnmpRequest.SNMP_TYPE_TIMETICKS:
                            out.print(oneVb.getIntValue());
                            break;

                        case SnmpRequest.SNMP_TYPE_IPADDRESS:
                            out.print(oneVb.getIPAddrValue());
                            break;

                        case SnmpRequest.SNMP_TYPE_OBJECTID:
                            out.print(oneVb.getOidValue());
                            break;

                         default:
                            out.print(oneVb.getValue());
                            break;
                    }
                    out.println("</td>");
                    out.println("</tr>");

                    if (lastOid.equals(oneVb.getOid()))
                    {
                        out.println("<tr><td>Error loop</td></tr>");
                        error = true;
                    }
                    if (oneVb.getOid().indexOf(oidStr) != 0)
                    {
                        out.println("<tr><td>Done...</td></tr>");
                        error = true;
                    }
                    lastOid = oneVb.getOid();
                    curReq.clearSnmpReqInfo();
                    curReq.addSnmpGetVarbind(lastOid);

                }
                out.flush();
                cnt++;
                if (cnt % 20 == 0)
                { // restart table for UI output
                    %>
                    </table>
            <table width="100%" border="1">
            <tr>
            <td width="15%">OID</td><td width="15%">Name</td><td width="70%">Value </td>
            </tr>
                    <%

                }
                }
                catch (Exception ex)
                {
                     out.println("<tr><td>Exception</td></tr>");
                    error = true;
                }

            }

%>
</table>
<%
        }
    }
}
%>
</body>
