<%@ page import="com.hp.mx.html.table.GUIDOTable,
                 java.util.*,
                 com.hp.mx.core.nodemanager.MxNode,
                 com.hp.mx.core.persistence.databean.*,
                 com.hp.mx.core.persistence.util.storage.*,
                 com.hp.mx.utilities.ByteFormatter,
                 com.hp.mx.portal.ui.MxBean,
                 com.hp.mx.portal.res.MxResourceBean,
                 com.hp.mx.core.controllers.MxNodeController,
                 com.hp.mx.core.persistence.dataaccess.DataAccessException"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="resource" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="genSystemPage" class="com.hp.mx.portal.device.MxGenSystemPage"  scope="session" />
<jsp:useBean id="deviceUtilBean" class="com.hp.mx.portal.device.MxDeviceUtilBean" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<div class="systemPageGroup">
<%
    //out.print("/src/hpwebadmin/webapps/ROOT/mxportal/DevicePage/HostStorageVols.jsp<BR>");
    //out.print("Type = " + deviceBean.getSystemType() + "<BR>");
    //out.print("Sub-Type = " + deviceBean.getSystemSubtype() + "<BR>");

    /**
     * List of table columns and associated database fields:
     *
     * "Name" (storage volume friendly name)
     *      CIM_ComputerSystem (Host) -> CIM_PortController (HBA) -> CIM_NetworkPort (FC Port) ->
     *          CIM_SCSIProtocolController -> CIM_ProtocolControllerForUnit ->
     *          CIM_StorageVolume : ElementName
     *
     * "HBA Name"
     *      CIM_ComputerSystem (Host) -> CIM_PortController (HBA) : ElementName
     *
     * "Port"
     *      CIM_ComputerSystem (Host) -> CIM_PortController (HBA) -> CIM_NetworkPort (FC Port): ElementName
     *
     * "LUN Number"
     *      CIM_ComputerSystem (Host) -> CIM_PortController (HBA) -> CIM_NetworkPort (FC Port) ->
     *          CIM_SCSIProtocolController -> CIM_ProtocolControllerForUnit -> DeviceNumber
     *
     * "LUN Size" (calculated)
     *      CIM_ComputerSystem (Host) -> PortController (HBA) -> CIM_NetworkPort (FC Port) ->
     *          CIM_SCSIProtocolController -> CIM_ProtocolControllerForUnit ->
     *          CIM_StorageVolume : BlockSize * NumberOfBlocks
     *
     * "RAID Type" (calculated)
     *      CIM_ComputerSystem (Host) -> CIM_PortController (HBA) -> CIM_NetworkPort (FC Port) ->
     *          CIM_SCSIProtocolController -> CIM_ProtocolControllerForUnit ->
     *          CIM_StorageVolume :
     */
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // setup resources.
    resource.init(loginBean, "StorageRelatedDevicePages");

    genSystemPage.dumpDataCollectionLine(deviceBean, deviceBundle, loginBean, out);

    // get partial key for lookup
    int nodeID = deviceBean.getMxNode().getDeviceKey();

    Common.HostStitchedVolumesDescriptor volumeDescriptor = Common.getStitchedVolumesForHost(nodeID);

    Map stitchedVolumes = volumeDescriptor.getStitchedVolumes();
    Map raidLevels = volumeDescriptor.getRaidLevels();

    //out.print("Key from MxNode = " + nodeID + "<BR>");
    //out.print("Durable Name from MxNode = " + durableName + "<BR>");

    GUIDOTable gt = new GUIDOTable();
    MxResourceBean res = new MxResourceBean(loginBean.getLocale(), "com.hp.mx.html.table.resource.TableResources");
    gt.setResourceBundle(res.getBundle());
    ArrayList rows = new ArrayList();

    String headers[] = { resource.getString("columnHeader.lunName"),     // LUN Name
                         resource.getString("columnHeader.lunNum"),      // LUN Number
                         resource.getString("columnHeader.storageDevice"), // link to Storage Device
                         resource.getString("columnHeader.hba"),         // HBA Name
                         resource.getString("columnHeader.portWWN"),     // Port WWN
                         resource.getString("columnHeader.lunSize"),     // LUN Size
                         resource.getString("columnHeader.RAIDlevel") }; // RAID Level
    gt.setHeaders(headers);
    ByteFormatter bf = new ByteFormatter(loginBean.getLocale());

    try {
        Host host = new Host(nodeID);
        Iterator hbas = host.getHBAs().iterator();
        while (hbas.hasNext()) {
            HostBusAdapter hba = (HostBusAdapter) hbas.next();
            Iterator ports = hba.getPorts().iterator();
            while (ports.hasNext()) {
                FCPort port = (FCPort) ports.next();

                Iterator svs = port.getStorageVolumes().iterator();
                while (svs.hasNext()) {
                    String[] tableRow = new String[headers.length];
                    StorageVolume sv = (StorageVolume) svs.next();
                    int idx = 0;

                    // Storage Volume name
                    tableRow[idx++] = sv.getName();

                    // LUN number
                    tableRow[idx++] = sv.getDeviceNumber();

                    // Storage device
                    List remoteNodeIDs = (List) stitchedVolumes.get(sv.getCIMStorageVolume().getName());
                    if(remoteNodeIDs != null) {
                        String hyperlinks = Common.getDeviceHyperlinks(remoteNodeIDs, deviceUtilBean);
                        tableRow[idx++] = hyperlinks;
                    } else {
                        tableRow[idx++] = resource.getString("unknown");
                    }


                    // hba element name
                    tableRow[idx++] = hba.getName();

                    // Port WWN
                    tableRow[idx++] = port.getWWN();

                    // total size
                    tableRow[idx++] = bf.format(sv.getSize());

                    // RAID level
                    String raidLevel = null;
                    if((raidLevel = (String) raidLevels.get(sv.getCIMStorageVolume().getName())) != null) {
                        tableRow[idx++] = raidLevel;
                    } else {
                        tableRow[idx++] = resource.getString("unknown");
                    }


                    // add row to table
                    rows.add(tableRow);
                }
            }
        }

    } catch(DataAccessException dae) {
        Debug.trace("No Data Found for Host with NodeID = " + nodeID);
    } catch(RuntimeException re) {
        Debug.getDebugSubsystem().panic(re);
    } catch(Error e) {
        Debug.getDebugSubsystem().panic(e);
        throw e;
    } finally {
        gt.setRows(rows);
        out.print(gt.getHTML().toString());
    }

%>
</div>
