<%@ page import="com.hp.mx.html.table.GUIDOTable,
                 com.hp.mx.html.table.TreeTable,
                 com.hp.mx.html.table.AttributeValueTable,
                 com.hp.mx.portal.ui.MxBean,
                 com.hp.mx.core.nodemanager.MxNode,
                 com.hp.mx.core.persistence.util.storage.StorageDevice,
                 com.hp.mx.utilities.ByteFormatter,
                 org.jfree.data.general.DefaultPieDataset,
                 org.jfree.chart.ChartFactory,
                 org.jfree.chart.JFreeChart,
                 org.jfree.chart.ChartUtilities,
                 java.io.OutputStream,
                 org.jfree.chart.servlet.ServletUtilities,
                 org.jfree.chart.entity.StandardEntityCollection,
                 org.jfree.chart.ChartRenderingInfo,
                 org.jfree.chart.labels.StandardPieItemLabelGenerator,
                 org.jfree.chart.urls.StandardPieURLGenerator,
                 java.awt.*,
                 org.jfree.chart.plot.PiePlot,
                 java.io.PrintWriter,
                 org.jfree.chart.labels.PieSectionLabelGenerator,
                 org.jfree.data.general.PieDataset,
                 org.jfree.chart.title.TextTitle,
                 com.hp.mx.utilities.PieChartFormatter,
                 com.hp.mx.utilities.ByteFormatter,
                 com.hp.mx.portal.res.MxResourceBean,
                 java.util.*,
                 java.text.NumberFormat,
                 com.hp.mx.core.persistence.util.storage.Debug,
                 com.hp.mx.core.persistence.dataaccess.DataAccessException"
%>

<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="resource" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="genSystemPage" class="com.hp.mx.portal.device.MxGenSystemPage"  scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<div class="systemPageGroup">
<%
    /**
     * This panel will display capacity information for a given storage device.
     */

    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // setup resources.
    resource.init(loginBean, "StorageRelatedDevicePages");

    genSystemPage.dumpDataCollectionLine(deviceBean, deviceBundle, loginBean, out);


    String durableName = deviceBean.getMxNode().getDurableName();
    int nodeID = deviceBean.getMxNode().getDeviceKey();

    GUIDOTable gt = new TreeTable(loginBean.getLocale(), false);
    MxResourceBean res = new MxResourceBean(loginBean.getLocale(), "com.hp.mx.html.table.resource.TableResources");
    gt.setResourceBundle(res.getBundle());

    String headers[] = { resource.getString("columnHeader.metric"),        // summary description
                         resource.getString("columnHeader.size"),          // amount
                         resource.getString("columnHeader.percent") };     // percentage
    gt.setHeaders(headers);
    ByteFormatter bf = new ByteFormatter(loginBean.getLocale());
    StorageDevice sd = null;

    String filename = null;
    String graphURL = null;
    String pieChartCmd = "";
    boolean showPieChart = true;

    try {
        // build table and pie chart at the same time
        sd = new StorageDevice(nodeID, durableName);
        DefaultPieDataset pieDataset = new DefaultPieDataset();
        TextTitle rawTitle = null;
        TextTitle carvedSubTitle = null;
        Font font = null;
        NumberFormat percentformatter = NumberFormat.getPercentInstance(loginBean.getLocale());

        // RAW Capacity
        String[] tableRow = new String[headers.length];      // table with x columns
        tableRow[0] = resource.getString("metric.rawCapacity");
        Long val = new Long(sd.getRawCapacity());

        // avoid this case, which can crash the JVM
        if(val.longValue() == 0) {
            showPieChart = false;
        }

        if (val.longValue() < 0) {
            tableRow[1] = resource.getString("metric.notFound");
            tableRow[2] = resource.getString("metric.notFound");
            showPieChart = false;
        } else {
            //out.print("RAW = " + val + "<BR>");
            tableRow[1] = bf.format(val.longValue());
            tableRow[2] = percentformatter.format(1);     // always 100%
            font = new Font("SansSerif", Font.BOLD, 12);
            rawTitle = new TextTitle(resource.getString("metric.rawTitle") + " " +
                    bf.format(sd.getRawCapacity()), font);
        }
        ((TreeTable)gt).addRow(tableRow);

        ((TreeTable)gt).beginChildren();

        // NOT CARVED
        tableRow = new String[headers.length];      // table with x columns
        tableRow[0] = resource.getString("metric.unallocated");
        val = new Long(sd.getUnallocated());
        if (val.longValue() < 0) {
            tableRow[1] = resource.getString("metric.notFound");
            tableRow[2] = resource.getString("metric.notFound");
            showPieChart = false;
        } else {
            //out.print("UNALLOCATED = " + val + "<BR>");
            tableRow[1] = bf.format(val.longValue());
            tableRow[2] = percentformatter.format((double) sd.getUnallocated() / (double) sd.getRawCapacity());
            pieDataset.setValue(resource.getString("metric.unallocated"), sd.getUnallocated());
        }
        ((TreeTable)gt).addRow(tableRow);

        // CARVED
        tableRow = new String[headers.length];      // table with x columns
        tableRow[0] = resource.getString("metric.carved");
        val = new Long(sd.getCarved());
        if (val.longValue() < 0) {
            tableRow[1] = resource.getString("metric.notFound");
            tableRow[2] = resource.getString("metric.notFound");
            showPieChart = false;
        } else {
            //out.print("CARVED = " + val + "<BR>");
            tableRow[1] = bf.format(val.longValue());
            double dd = ((double) sd.getCarved()) / ((double) sd.getRawCapacity());
            tableRow[2] = percentformatter.format(dd);
            font = new Font("SansSerif", Font.BOLD, 12);
            carvedSubTitle = new TextTitle(resource.getString("metric.carvedSubTitle") + " " +
                    percentformatter.format(dd) + " (" + bf.format(sd.getCarved()) + ")", font);
        }
        ((TreeTable)gt).addRow(tableRow);

        ((TreeTable)gt).beginChildren();  // ((TreeTable)table).endChildren();

        // RAID OVERHEAD
        tableRow = new String[headers.length];      // table with x columns
        tableRow[0] = resource.getString("metric.overhead");
        val = new Long(sd.getOverhead());
        if (val.longValue() < 0) {
            tableRow[1] = resource.getString("metric.notFound");
            tableRow[2] = resource.getString("metric.notFound");
            showPieChart = false;
        } else {
            //out.print("RAID = " + val + "<BR>");
            tableRow[1] = bf.format(val.longValue());
            tableRow[2] = percentformatter.format((double) sd.getOverhead() / (double) sd.getRawCapacity());
            pieDataset.setValue(resource.getString("metric.overhead"), sd.getOverhead());
        }
        ((TreeTable)gt).addRow(tableRow);

        // PRESENTED
        tableRow = new String[headers.length];      // table with x columns
        tableRow[0] = resource.getString("metric.presented");
        val = new Long(sd.getPresented());
        if (val.longValue() < 0) {
            tableRow[1] = resource.getString("metric.notFound");
            tableRow[2] = resource.getString("metric.notFound");
            showPieChart = false;
        } else {
            //out.print("ASSIGNED = " + val + "<BR>");
            tableRow[1] = bf.format(val.longValue());
            tableRow[2] = percentformatter.format((double) sd.getPresented() / (double) sd.getRawCapacity());
            pieDataset.setValue(resource.getString("metric.presented"), sd.getPresented());
        }
        ((TreeTable)gt).addRow(tableRow);

        // UNPRESENTED
        tableRow = new String[headers.length];      // table with x columns
        tableRow[0] = resource.getString("metric.unpresented");
        val = new Long(sd.getUnpresented());
        if (val.longValue() < 0) {
            tableRow[1] = resource.getString("metric.notFound");
            tableRow[2] = resource.getString("metric.notFound");
            showPieChart = false;
        } else {
            //out.print("UNASSIGNED = " + val + "<BR>");
            tableRow[1] = bf.format(val.longValue());
            tableRow[2] = percentformatter.format((double) sd.getUnpresented() / (double) sd.getRawCapacity());
            pieDataset.setValue(resource.getString("metric.unpresented"), sd.getUnpresented());
        }
        ((TreeTable)gt).addRow(tableRow);

        ((TreeTable)gt).endChildren();
        ((TreeTable)gt).endChildren();

        if (showPieChart) {
            //  Create pie chart
            PieChartFormatter pcf = new PieChartFormatter(loginBean.getLocale());
            PiePlot plot = new PiePlot(pieDataset);
            plot.setInsets(new Insets(0, 5, 5, 5));
            plot.setLabelGenerator(pcf);
            plot.setToolTipGenerator(pcf);

            // assign colors
            for (int i=0; i<pieDataset.getItemCount(); i++) {
                plot.setSectionPaint(i, pcf.getSectionColor(i));
            }

            // explode the unallocated piece
            plot.setExplodePercent(pieDataset.getIndex(resource.getString("metric.unallocated")), .1);

            font = new Font("SansSerif", Font.PLAIN, 12);
            JFreeChart chart = new JFreeChart("", font, plot, true);
            chart.setTitle(rawTitle);
            Vector v = new Vector();
            v.add(carvedSubTitle);
            chart.setSubtitles(v);
            chart.setLegend(null);
            chart.setBackgroundPaint(java.awt.Color.white);

            //  Write the chart image to the temporary directory
            ChartRenderingInfo info = new ChartRenderingInfo(new StandardEntityCollection());
            filename = ServletUtilities.saveChartAsPNG(chart, 500, 400, info, session);

            //  Write the image map to the PrintWriter
            PrintWriter pw = new PrintWriter(out);
            ChartUtilities.writeImageMap(pw, filename, info);
            pw.flush();
            graphURL = request.getContextPath() + "/servlet/DisplayChart?filename=" + filename;
            pieChartCmd = "<BR><img src=\"" + graphURL + "\" width=500 height=400 border=0 usemap=\"#" + filename + "\">";
        }

    } catch(DataAccessException dae) {
        Debug.trace("No Data Found for Storage Device with NodeID = " + nodeID + "  Name = " + durableName);
    } catch(RuntimeException re) {
        Debug.getDebugSubsystem().panic(re);
    } catch(Error e) {
        Debug.getDebugSubsystem().panic(e);
        throw e;
    } finally {
        out.print(gt.getHTML().toString());
        out.print(pieChartCmd);
    }

%>
</div>
