<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.core.alertmanager.*" %>
<%@ page import="com.hp.mx.core.controllers.MxQueryController" %>
<%@ page import="com.hp.mx.core.client.MxQueryClient" %>
<%@ page import="com.hp.mx.core.nodemanager.*" %>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="bannerSettings" class="com.hp.mx.portal.custom.MxBannerSettings" scope="session" />

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Bean initialization
    bannerSettings.initialize(loginBean);
    MxDateAndTime dateAndTime = new MxDateAndTime(loginBean.getLocale(),loginBean.getTimeZone());
%>

<HTML>
<HEAD>
    <SCRIPT src="/AutoRefreshingSessionReset.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
</HEAD>

<BODY>

<SCRIPT>
var bTimeStampNeeded = <%=bannerSettings.anyStatusDisplayed()%>;
var bStatus1Needed = <%=bannerSettings.getShowStatus1()%>;
var bStatus2Needed = <%=bannerSettings.getShowStatus2()%>;
var bAlarmNeeded = <%=bannerSettings.getShowAlarm()%>;

if (((bTimeStampNeeded) && (parent.document.getElementById('lastUpdateTime') == null)) ||
    ((!bTimeStampNeeded) && (parent.document.getElementById('lastUpdateTime') != null)) ||
    ((bStatus1Needed) && (parent.document.getElementById('firstStatusCritical') == null)) ||
    ((!bStatus1Needed) && (parent.document.getElementById('firstStatusCritical') != null)) ||
    ((bStatus2Needed) && (parent.document.getElementById('secondStatusCritical') == null)) ||
    ((!bStatus2Needed) && (parent.document.getElementById('secondStatusCritical') != null)) ||
    ((bAlarmNeeded) && (parent.document.getElementById('alarm') == null)) ||
    ((!bAlarmNeeded) && (parent.document.getElementById('alarm') != null)))
    {
    MxPortalRefreshLeftSide();
    }

<% if (bannerSettings.anyStatusDisplayed()) {
%>
        if (parent.document.getElementById('lastUpdateTime'))
            parent.document.getElementById('lastUpdateTime').innerHTML ="<%=dateAndTime.getCurrentDateTimeStringSIMFormatWithSeconds()%>";
<%
MxQueryClient queryClient = null;
Map devvals = null;
Map evtvals = null;

int status1_CRITICAL = 0;
int status1_MAJOR = 0;
int status1_MINOR = 0;
int status1_NORMAL = 0;
String status1_CRITICAL_Label = "";
String status1_MAJOR_Label = "";
String status1_MINOR_Label = "";
String status1_NORMAL_Label = "";
Map  status1Vals = null;
Object critical1Value = null;
Object major1Value = null;
Object minor1Value = null;
Object normal1Value = null;

int status2_CRITICAL = 0;
int status2_MAJOR = 0;
int status2_MINOR = 0;
int status2_NORMAL = 0;
String status2_CRITICAL_Label = "";
String status2_MAJOR_Label = "";
String status2_MINOR_Label = "";
String status2_NORMAL_Label = "";
Map  status2Vals = null;
Object critical2Value = null;
Object major2Value = null;
Object minor2Value = null;
Object normal2Value = null;

boolean bAlarmTestHardware = false;
boolean bAlarmTestEvents = false;
int alarm_HW_CRITICAL = 0;
int alarm_HW_MAJOR = 0;
int alarm_EV_CRITICAL = 0;
int alarm_EV_MAJOR = 0;
String alarm_HW_CRITICAL_Label = "";
String alarm_HW_MAJOR_Label = "";
String alarm_EV_CRITICAL_Label = "";
String alarm_EV_MAJOR_Label = "";
Map alarm_HW_Vals = null;
Map alarm_EV_Vals = null;
Object critical_HW_Value = null;
Object major_HW_Value = null;
Object critical_EV_Value = null;
Object major_EV_Value = null;
String alarmTop = "' style='text-decoration:none;'><div style='margin:0px 2px 0px 2px; padding:2px; font-family:arial,sans-serif; font-size:10pt; font-weight:bold; cursor:pointer; color: ";
String alarmMiddle = "'>";
String alarmBottom = "</div></a>";
String criticalIcon = "";
String majorIcon = "";
String criticalColor = "#FF0000";
String majorColor = "#FF9427";
String criticalTextColor = "white";
String majorTextColor = "black";

String criticalEventCriteria = bannerSettings.getResourceString("banner.listTitle.criticalUncleared");
String majorEventCriteria = bannerSettings.getResourceString("banner.listTitle.majorUncleared");
String minorEventCriteria = bannerSettings.getResourceString("banner.listTitle.minorUncleared");
String normalEventCriteria = bannerSettings.getResourceString("banner.listTitle.normalUncleared");
String criticalHWCriteria = bannerSettings.getResourceString("banner.listTitle.criticalHardware");
String majorHWCriteria = bannerSettings.getResourceString("banner.listTitle.majorHardware");
String minorHWCriteria = bannerSettings.getResourceString("banner.listTitle.minorHardware");
String normalHWCriteria = bannerSettings.getResourceString("banner.listTitle.normalHardware");
String separator = bannerSettings.getResourceString("banner.listTitle.separator");
String toolTipEnd = bannerSettings.getResourceString("banner.listTitle.clickForDetails");

try
{
    queryClient =  loginBean.getQueryClient();

    if (bannerSettings.getShowAlarm()) {
        criticalIcon = "<img align='middle' SRC='" + MxStatusIcon.CRITICAL.getIconWithBorder() + "' border='0'>";
        majorIcon = "<img align='middle' SRC='" + MxStatusIcon.MAJOR.getIconWithBorder() + "' border='0'>";

        long alarmqueryId = Long.parseLong(bannerSettings.getAlarmList());
        int alarmqueryType = Integer.parseInt(bannerSettings.getAlarmType());
        if ((alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL) ||
            (alarmqueryType == bannerSettings.BANNER_ANY_MAJOR) ||
            (alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL_OR_MAJOR) ||
            (alarmqueryType == bannerSettings.BANNER_HARDWARE_CRITICAL) ||
            (alarmqueryType == bannerSettings.BANNER_HARDWARE_MAJOR) ||
            (alarmqueryType == bannerSettings.BANNER_HARDWARE_CRITICAL_OR_MAJOR)) {
            bAlarmTestHardware = true;
            alarm_HW_CRITICAL = DeviceStatusType.CRITICAL.getStatusNumValue();
            alarm_HW_MAJOR = DeviceStatusType.MAJOR.getStatusNumValue();
            alarm_HW_CRITICAL_Label = criticalHWCriteria;
            alarm_HW_MAJOR_Label = majorHWCriteria;
        }

        if ((alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL) ||
            (alarmqueryType == bannerSettings.BANNER_ANY_MAJOR) ||
            (alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL_OR_MAJOR) ||
            (alarmqueryType == bannerSettings.BANNER_EVENTS_CRITICAL) ||
            (alarmqueryType == bannerSettings.BANNER_EVENTS_MAJOR) ||
            (alarmqueryType == bannerSettings.BANNER_EVENTS_CRITICAL_OR_MAJOR)) {
            bAlarmTestEvents = true;
            alarm_EV_CRITICAL = AlertSeverity.CRITICAL.getNoticeSeverity();
            alarm_EV_MAJOR = AlertSeverity.MAJOR.getNoticeSeverity();
            alarm_EV_CRITICAL_Label = criticalEventCriteria;
            alarm_EV_MAJOR_Label = majorEventCriteria;
        }

        if (bAlarmTestHardware) {
            alarm_HW_Vals = queryClient.runBannerQuery(MxQueryController.BANNER_HARDWARE_STATUS_RESULTS, alarmqueryId);
            critical_HW_Value = alarm_HW_Vals.get(new Integer(alarm_HW_CRITICAL));
            if (critical_HW_Value == null)
                critical_HW_Value = "0";
            major_HW_Value = alarm_HW_Vals.get(new Integer(alarm_HW_MAJOR));
            if (major_HW_Value == null)
                major_HW_Value = "0";
        }

        if (bAlarmTestEvents) {
            alarm_EV_Vals = queryClient.runBannerQuery(MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS, alarmqueryId);
            critical_EV_Value = alarm_EV_Vals.get(new Integer(alarm_EV_CRITICAL));
            if (critical_EV_Value == null)
                critical_EV_Value = "0";
            major_EV_Value = alarm_EV_Vals.get(new Integer(alarm_EV_MAJOR));
            if (major_EV_Value == null)
                major_EV_Value = "0";
        }

       //event critical
        if (((alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL) ||
             (alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL_OR_MAJOR) ||
             (alarmqueryType == bannerSettings.BANNER_EVENTS_CRITICAL) ||
             (alarmqueryType == bannerSettings.BANNER_EVENTS_CRITICAL_OR_MAJOR)) &&
            (!critical_EV_Value.toString().equals("0"))) {
%>
        if (MxPortalIsPanelCollapsed("ID_STATUS"))
            MxPortalWindowAction("ID_STATUS", "expand");
<%
        String alarmSeverityString = "" + DeviceStatusType.CRITICAL.getStatusNumValue();
        String alarmSeverityLabel = criticalEventCriteria;
%>
        var alarmSeverity = "<%=alarmSeverityString%>";
        var alarmType = "<%=MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS%>";
        var alarmList = "<%=bannerSettings.getAlarmList()%>";
        var alarmListName = "<%=bannerSettings.getAlarmListName()%>";
        var alarmSeparator = "<%=separator%>";
        var alarmToolTipEnd = "<%=toolTipEnd%>";
        var alarmEVCriticalLabel = "<%=alarm_EV_CRITICAL_Label%>";

        var title = alarmListName + alarmSeparator + " " + alarmEVCriticalLabel;
        var javascriptString = "createList(" + alarmSeverity + "," + alarmType + "," + alarmList + ",\"" + title + "\")";
        var tooltip = title + alarmToolTipEnd;
        var hrefString = "<a onclick='" + javascriptString + "' title='" + tooltip;
        if (parent.document.getElementById('alarm'))
            parent.document.getElementById('alarm').innerHTML = hrefString + "<%=alarmTop%><%=criticalTextColor%>; background: <%=criticalColor%><%=alarmMiddle%><%=criticalIcon%>&nbsp;<%=MxHtmlUtil.encodeHtmlEntities(bannerSettings.getAlarmLabel())%><%=alarmBottom%>";
<%
        }
        //hardware critical
        else if (((alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL) ||
                  (alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL_OR_MAJOR) ||
                  (alarmqueryType == bannerSettings.BANNER_HARDWARE_CRITICAL) ||
                  (alarmqueryType == bannerSettings.BANNER_HARDWARE_CRITICAL_OR_MAJOR)) &&
                 (!critical_HW_Value.toString().equals("0"))) {
%>
        if (MxPortalIsPanelCollapsed("ID_STATUS"))
            MxPortalWindowAction("ID_STATUS", "expand");
<%
        String alarmSeverityString = "" + DeviceStatusType.CRITICAL.getStatusNumValue();
        String alarmSeverityLabel = criticalHWCriteria;
%>
        var alarmSeverity = "<%=alarmSeverityString%>";
        var alarmType = "<%=MxQueryController.BANNER_HARDWARE_STATUS_RESULTS%>";
        var alarmList = "<%=bannerSettings.getAlarmList()%>";
        var alarmListName = "<%=bannerSettings.getAlarmListName()%>";
        var alarmSeparator = "<%=separator%>";
        var alarmToolTipEnd = "<%=toolTipEnd%>";
        var alarmHWCriticalLabel = "<%=alarm_HW_CRITICAL_Label%>";

        var title = alarmListName + alarmSeparator + " " + alarmHWCriticalLabel;
        var javascriptString = "createList(" + alarmSeverity + "," + alarmType + "," + alarmList + ",\"" + title + "\")";
        var tooltip = title + alarmToolTipEnd;
        var hrefString = "<a onclick='" + javascriptString + "' title='" + tooltip;
        if (parent.document.getElementById('alarm'))
            parent.document.getElementById('alarm').innerHTML = hrefString + "<%=alarmTop%><%=criticalTextColor%>; background: <%=criticalColor%><%=alarmMiddle%><%=criticalIcon%>&nbsp;<%=MxHtmlUtil.encodeHtmlEntities(bannerSettings.getAlarmLabel())%><%=alarmBottom%>";
<%
        }
        //event major
        else if (((alarmqueryType == bannerSettings.BANNER_ANY_MAJOR) ||
                  (alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL_OR_MAJOR) ||
                  (alarmqueryType == bannerSettings.BANNER_EVENTS_MAJOR) ||
                  (alarmqueryType == bannerSettings.BANNER_EVENTS_CRITICAL_OR_MAJOR)) &&
                 (!major_EV_Value.toString().equals("0"))) {
%>
        if (MxPortalIsPanelCollapsed("ID_STATUS"))
            MxPortalWindowAction("ID_STATUS", "expand");
<%
        String alarmSeverityString = "" + DeviceStatusType.MAJOR.getStatusNumValue();
        String alarmSeverityLabel = majorEventCriteria;
%>
        var alarmSeverity = "<%=alarmSeverityString%>";
        var alarmType = "<%=MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS%>";
        var alarmList = "<%=bannerSettings.getAlarmList()%>";
        var alarmListName = "<%=bannerSettings.getAlarmListName()%>";
        var alarmSeparator = "<%=separator%>";
        var alarmToolTipEnd = "<%=toolTipEnd%>";
        var alarmEVMajorLabel = "<%=alarm_EV_MAJOR_Label%>";

        var title = alarmListName + alarmSeparator + " " + alarmEVMajorLabel;
        var javascriptString = "createList(" + alarmSeverity + "," + alarmType + "," + alarmList + ",\"" + title + "\")";
        var tooltip = title + alarmToolTipEnd;
        var hrefString = "<a onclick='" + javascriptString + "' title='" + tooltip;
        if (parent.document.getElementById('alarm'))
            parent.document.getElementById('alarm').innerHTML = hrefString + "<%=alarmTop%><%=majorTextColor%>; background: <%=majorColor%><%=alarmMiddle%><%=majorIcon%>&nbsp;<%=MxHtmlUtil.encodeHtmlEntities(bannerSettings.getAlarmLabel())%><%=alarmBottom%>";
<%
        }
        //hardware major
        else if (((alarmqueryType == bannerSettings.BANNER_ANY_MAJOR) ||
                  (alarmqueryType == bannerSettings.BANNER_ANY_CRITICAL_OR_MAJOR) ||
                  (alarmqueryType == bannerSettings.BANNER_HARDWARE_MAJOR) ||
                  (alarmqueryType == bannerSettings.BANNER_HARDWARE_CRITICAL_OR_MAJOR)) &&
                 (!major_HW_Value.toString().equals("0"))) {
%>
        if (MxPortalIsPanelCollapsed("ID_STATUS"))
            MxPortalWindowAction("ID_STATUS", "expand");
<%
        String alarmSeverityString = "" + DeviceStatusType.MAJOR.getStatusNumValue();
        String alarmSeverityLabel = majorHWCriteria;
%>
        var alarmSeverity = "<%=alarmSeverityString%>";
        var alarmType = "<%=MxQueryController.BANNER_HARDWARE_STATUS_RESULTS%>";
        var alarmList = "<%=bannerSettings.getAlarmList()%>";
        var alarmListName = "<%=bannerSettings.getAlarmListName()%>";
        var alarmSeparator = "<%=separator%>";
        var alarmToolTipEnd = "<%=toolTipEnd%>";
        var alarmHWMajorLabel = "<%=alarm_HW_MAJOR_Label%>";

        var title = alarmListName + alarmSeparator + " " + alarmHWMajorLabel;
        var javascriptString = "createList(" + alarmSeverity + "," + alarmType + "," + alarmList + ",\"" + title + "\")";
        var tooltip = title + alarmToolTipEnd;
        var hrefString = "<a onclick='" + javascriptString + "' title='" + tooltip;
        if (parent.document.getElementById('alarm'))
            parent.document.getElementById('alarm').innerHTML = hrefString + "<%=alarmTop%><%=majorTextColor%>; background: <%=majorColor%><%=alarmMiddle%><%=majorIcon%>&nbsp;<%=MxHtmlUtil.encodeHtmlEntities(bannerSettings.getAlarmLabel())%><%=alarmBottom%>";
<%
        }
        //nothing to be alarmed about
        else {
%>
        if (parent.document.getElementById('alarm'))
            parent.document.getElementById('alarm').innerHTML = "&nbsp;";
<%
        }
    }

    if (bannerSettings.getShowStatus1()) {
        long status1queryId = Long.parseLong(bannerSettings.getStatus1List());
        int status1queryType = Integer.parseInt(bannerSettings.getStatus1Type());

        if (status1queryType == MxQueryController.BANNER_HARDWARE_STATUS_RESULTS) {
            status1_CRITICAL = DeviceStatusType.CRITICAL.getStatusNumValue();
            status1_MAJOR = DeviceStatusType.MAJOR.getStatusNumValue();
            status1_MINOR = DeviceStatusType.MINOR.getStatusNumValue();
            status1_NORMAL = DeviceStatusType.NORMAL.getStatusNumValue();
            status1_CRITICAL_Label = criticalHWCriteria;
            status1_MAJOR_Label = majorHWCriteria;
            status1_MINOR_Label = minorHWCriteria;
            status1_NORMAL_Label = normalHWCriteria;
        } else if (status1queryType == MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS) {
            status1_CRITICAL = AlertSeverity.CRITICAL.getNoticeSeverity();
            status1_MAJOR = AlertSeverity.MAJOR.getNoticeSeverity();
            status1_MINOR = AlertSeverity.MINOR.getNoticeSeverity();
            status1_NORMAL = AlertSeverity.NORMAL.getNoticeSeverity();
            status1_CRITICAL_Label = criticalEventCriteria;
            status1_MAJOR_Label = majorEventCriteria;
            status1_MINOR_Label = minorEventCriteria;
            status1_NORMAL_Label = normalEventCriteria;
        }
        status1Vals =  queryClient.runBannerQuery(status1queryType, status1queryId);
        critical1Value = status1Vals.get(new Integer(status1_CRITICAL));
        if (critical1Value == null)
            critical1Value="0";
        major1Value = status1Vals.get(new Integer(status1_MAJOR));
        if (major1Value == null)
            major1Value="0";
        minor1Value = status1Vals.get(new Integer(status1_MINOR));
        if (minor1Value == null)
            minor1Value="0";
        normal1Value = status1Vals.get(new Integer(status1_NORMAL));
        if (normal1Value == null)
            normal1Value="0";
%>
        var status1Type = "<%=bannerSettings.getStatus1Type()%>";
        var status1List = "<%=bannerSettings.getStatus1List()%>";
        var status1ListName = "<%=bannerSettings.getStatus1ListName()%>";
        var status1Separator = "<%=separator%>";
        var status1ToolTipEnd = "<%=toolTipEnd%>";
        var status1Critical = "" + <%=status1_CRITICAL%>;
        var status1Major = "" + <%=status1_MAJOR%>;
        var status1Minor = "" + <%=status1_MINOR%>;
        var status1Normal = "" + <%=status1_NORMAL%>;
        var status1CriticalLabel = "<%=status1_CRITICAL_Label%>";
        var status1MajorLabel = "<%=status1_MAJOR_Label%>";
        var status1MinorLabel = "<%=status1_MINOR_Label%>";
        var status1NormalLabel = "<%=status1_NORMAL_Label%>";

        var title = status1ListName + status1Separator + " " + status1CriticalLabel;
        var javascriptString = "javascript:createList(" + status1Critical + "," + status1Type + "," + status1List + ",\"" + title + "\")";
        var tooltip = title + status1ToolTipEnd;
        var innerString = "<a class='header-status-counts' href='" + javascriptString + "' title='" + tooltip + "'> <%= critical1Value %> </a>";
        if (parent.document.getElementById('firstStatusCritical'))
            parent.document.getElementById('firstStatusCritical').innerHTML = innerString;

        var title = status1ListName + status1Separator + " " + status1MajorLabel;
        var javascriptString = "javascript:createList(" + status1Major + "," + status1Type + "," + status1List + ",\"" + title + "\")";
        var tooltip = title + status1ToolTipEnd;
        var innerString = "<a class='header-status-counts' href='" + javascriptString + "' title='" + tooltip + "'> <%= major1Value %> </a>";
        if (parent.document.getElementById('firstStatusMajor'))
            parent.document.getElementById('firstStatusMajor').innerHTML = innerString;

        var title = status1ListName + status1Separator + " " + status1MinorLabel;
        var javascriptString = "javascript:createList(" + status1Minor + "," + status1Type + "," + status1List + ",\"" + title + "\")";
        var tooltip = title + status1ToolTipEnd;
        var innerString = "<a class='header-status-counts' href='" + javascriptString + "' title='" + tooltip + "'> <%= minor1Value %> </a>";
        if (parent.document.getElementById('firstStatusMinor'))
            parent.document.getElementById('firstStatusMinor').innerHTML = innerString;

        var title = status1ListName + status1Separator + " " + status1NormalLabel;
        var javascriptString = "javascript:createList(" + status1Normal + "," + status1Type + "," + status1List + ",\"" + title + "\")";
        var tooltip = title + status1ToolTipEnd;
        var innerString = "<a class='header-status-counts' href='" + javascriptString + "' title='" + tooltip + "'> <%= normal1Value %> </a>";
        if (parent.document.getElementById('firstStatusNormal'))
            parent.document.getElementById('firstStatusNormal').innerHTML = innerString;
<%
    }

    if (bannerSettings.getShowStatus2()) {
        long status2queryId = Long.parseLong(bannerSettings.getStatus2List());
        int status2queryType = Integer.parseInt(bannerSettings.getStatus2Type());
        if (status2queryType == MxQueryController.BANNER_HARDWARE_STATUS_RESULTS) {
            status2_CRITICAL = DeviceStatusType.CRITICAL.getStatusNumValue();
            status2_MAJOR = DeviceStatusType.MAJOR.getStatusNumValue();
            status2_MINOR = DeviceStatusType.MINOR.getStatusNumValue();
            status2_NORMAL = DeviceStatusType.NORMAL.getStatusNumValue();
            status2_CRITICAL_Label = criticalHWCriteria;
            status2_MAJOR_Label = majorHWCriteria;
            status2_MINOR_Label = minorHWCriteria;
            status2_NORMAL_Label = normalHWCriteria;
        } else if (status2queryType == MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS) {
            status2_CRITICAL = AlertSeverity.CRITICAL.getNoticeSeverity();
            status2_MAJOR = AlertSeverity.MAJOR.getNoticeSeverity();
            status2_MINOR = AlertSeverity.MINOR.getNoticeSeverity();
            status2_NORMAL = AlertSeverity.NORMAL.getNoticeSeverity();
            status2_CRITICAL_Label = criticalEventCriteria;
            status2_MAJOR_Label = majorEventCriteria;
            status2_MINOR_Label = minorEventCriteria;
            status2_NORMAL_Label = normalEventCriteria;
        }

        status2Vals =  queryClient.runBannerQuery(status2queryType, status2queryId);
        critical2Value = status2Vals.get(new Integer(status2_CRITICAL));
        if (critical2Value == null)
            critical2Value="0";
        major2Value = status2Vals.get(new Integer(status2_MAJOR));
        if (major2Value == null)
            major2Value="0";
        minor2Value = status2Vals.get(new Integer(status2_MINOR));
        if (minor2Value == null)
            minor2Value="0";
        normal2Value = status2Vals.get(new Integer(status2_NORMAL));
        if (normal2Value == null)
            normal2Value="0";
%>
        var status2Type = "<%=bannerSettings.getStatus2Type()%>";
        var status2List = "<%=bannerSettings.getStatus2List()%>";
        var status2ListName = "<%=bannerSettings.getStatus2ListName()%>";
        var status2Separator = "<%=separator%>";
        var status2ToolTipEnd = "<%=toolTipEnd%>";
        var status2Critical = "" + <%=status2_CRITICAL%>;
        var status2Major = "" + <%=status2_MAJOR%>;
        var status2Minor = "" + <%=status2_MINOR%>;
        var status2Normal = "" + <%=status2_NORMAL%>;
        var status2CriticalLabel = "<%=status2_CRITICAL_Label%>";
        var status2MajorLabel = "<%=status2_MAJOR_Label%>";
        var status2MinorLabel = "<%=status2_MINOR_Label%>";
        var status2NormalLabel = "<%=status2_NORMAL_Label%>";

        var title = status2ListName + status2Separator + " " + status2CriticalLabel;
        var javascriptString = "javascript:createList(" + status2Critical + "," + status2Type + "," + status2List + ",\"" + title + "\")";
        var tooltip = title + status2ToolTipEnd;
        var innerString = "<a class='header-status-counts' href='" + javascriptString + "' title='" + tooltip + "'> <%= critical2Value %> </a>";
        if (parent.document.getElementById('secondStatusCritical'))
            parent.document.getElementById('secondStatusCritical').innerHTML = innerString;

        var title = status2ListName + status2Separator + " " + status2MajorLabel;
        var javascriptString = "javascript:createList(" + status2Major + "," + status2Type + "," + status2List + ",\"" + title + "\")";
        var tooltip = title + status2ToolTipEnd;
        var innerString = "<a class='header-status-counts' href='" + javascriptString + "' title='" + tooltip + "'> <%= major2Value %> </a>";
        if (parent.document.getElementById('secondStatusMajor'))
            parent.document.getElementById('secondStatusMajor').innerHTML = innerString;

        var title = status2ListName + status2Separator + " " + status2MinorLabel;
        var javascriptString = "javascript:createList(" + status2Minor + "," + status2Type + "," + status2List + ",\"" + title + "\")";
        var tooltip = title + status2ToolTipEnd;
        var innerString = "<a class='header-status-counts' href='" + javascriptString + "' title='" + tooltip + "'> <%= minor2Value %> </a>";
        if (parent.document.getElementById('secondStatusMinor'))
            parent.document.getElementById('secondStatusMinor').innerHTML = innerString;

        var title = status2ListName + status2Separator + " " + status2NormalLabel;
        var javascriptString = "javascript:createList(" + status2Normal + "," + status2Type + "," + status2List + ",\"" + title + "\")";
        var tooltip = title + status2ToolTipEnd;
        var innerString = "<a class='header-status-counts' href='" + javascriptString + "' title='" + tooltip + "'> <%= normal2Value %> </a>";
        if (parent.document.getElementById('secondStatusNormal'))
            parent.document.getElementById('secondStatusNormal').innerHTML = innerString;
<%
    }
}
catch (Exception ex)
{
ex.printStackTrace();
}

}
%>
</SCRIPT>
</BODY>
</HTML>
