<%@ page import="javax.swing.tree.*" %>
<%@ page import="java.util.EventListener" %>
<%@ page import="com.hp.mx.html.tree.MxTreeController" %>
<%@ page import="com.hp.mx.html.tree.MxTreeView" %>
<%@ page import="com.hp.mx.html.tree.MxTreeSelectionModel" %>
<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.tree.MxTreeDataModel" %>
<%@ page import="com.hp.mx.portal.tree.MxTreeInstance" %>
<%@ page import="com.hp.mx.portal.tree.TreeViewSelectionListener" %>
<%@ page import="com.hp.mx.html.tree.MxDefaultTreeExpansionModel" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="treeInstanceManager" class="com.hp.mx.portal.tree.MxTreeInstanceManager" scope="session" />
<jsp:useBean id="drillDown" class="com.hp.mx.portal.core.MxDrillDown" scope="session" />
<jsp:useBean id="rbTreeView" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Set the resource bundle
    rbTreeView.init(loginBean, "MxTreeView");

    // Instanciate the tree instance with the tree instance manager
    String timeStamp = request.getParameter("timeStamp");
    if (timeStamp == null)
        timeStamp = treeInstanceManager.initTreeInstance();

    // Get the tree instance with the resulting time stamp
    MxTreeInstance treeInstance = (MxTreeInstance) treeInstanceManager.getInstance(timeStamp);

    // Make the call to set selections or expansions if we're in the hidden iframe
    MxTreeController controller = treeInstance.getTreeController();
    boolean bMessages = controller.checkUrlForControllerMessages(request, out);

    // Get the selection model and the count to set the "Save As" or "Delete" buttons
    MxTreeSelectionModel selectionModel = treeInstance.getDefaultTreeSelectionModel();
    if (selectionModel.getSelectionCount() > 0)
    {
        out.write("<script type='text/javascript' language='JavaScript'>\n");
        out.write("  parent.enableSaveAsButton();\n");
        out.write("  parent.enableDeleteButton();\n");
        out.write("</script>\n");
    }
    else if (bMessages)
    {
        out.write("<script type='text/javascript' language='JavaScript'>\n");
        out.write("  parent.disableSaveAsButton();\n");
        out.write("  parent.disableDeleteButton();\n");
        out.write("</script>\n");
    }

    // See if this page is being reloaded in the hidden communication page.
    // If it is, just return without executing
    if (bMessages) return;

    // Get the beans in the treeInstanceObject
    MxTreeView treeView = treeInstance.getTreeViewBean();
    MxDefaultTreeExpansionModel expansionModel = treeInstance.getDefaultTreeExpansionModel();
    TreeViewSelectionListener treeViewSelectionListener = treeInstance.getTreeViewSelectionListener();
    MxTreeDataModel treeData = treeInstance.getTreeDataModel();

    // Get the query Id
    String queryId = request.getParameter("queryId");

    // Check the retain selections flag
    String szRetainSelection = request.getParameter("retainSelection");
    boolean bRetainSelection = false;
    if (szRetainSelection != null)
        bRetainSelection = true;

    // Check to see if tree is build properly
    boolean showTreeView = false;

    if (controller.isFirstTime() || (request.getParameter("refresh") == null && request.getParameter("loadForPrint") == null))
    {
        treeData.initDataTree(loginBean, queryId);
        treeData.getTree();

        if (treeData.getNumChildren() > 0)
        {
            showTreeView = true;
        }
        treeView.setId("ID_MY_TREE");
        treeView.setUrlHandler(request.getRequestURI() + "?timeStamp=" + timeStamp);
        treeView.setOnChange("treeViewOnChange");
        treeView.setStatusDrillDownHandler("loadStatusDrillDown");
        treeView.setSystemDrillDownHandler("loadSystemDrillDown");
        treeView.setContainerStatusDrillDownHandler("loadContainerDeviceStatusDrilldown");
        controller.setExpansionModel(expansionModel);
        controller.setTreeView(treeView);
        selectionModel.setExtendedSelectionMode(MxTreeSelectionModel.COMPLEX_MULTI_SELECTION);
        // Nimbus pages will use loginBean.getLocale() here:
        controller.setLocale(request.getLocale());
        controller.setSelectionModel(selectionModel);
        controller.setTreeModel(treeData.getTree());
        treeData.setSelectionModel(selectionModel);
        treeData.setExpansionModel(expansionModel);
        treeData.setTreeView(treeView);
        treeView.setEmptyString(rbTreeView.get("emptyTree"));
    }

    EventListener[] currentListeners = selectionModel.getTreeSelectionListeners();
    if (currentListeners.length == 0)
    {
        selectionModel.addTreeSelectionListener(treeViewSelectionListener);
        treeViewSelectionListener.initSelectionListener(loginBean);
    }

    if (request.getParameter("refresh") != null)
    {
        if (request.getParameter("clearSelections") != null)
            selectionModel.clearSelection();
        if (request.getParameter("clearExpansion") != null)
            expansionModel.clearExpansion();
    }
    else
    {
        expansionModel.clearExpansion();
        if (!bRetainSelection)
            selectionModel.clearSelection();
        else
            treeData.loadSelectionsFromGlobalSelections();
    }

    if (request.getParameter("expandAll") != null)
    {
        expansionModel.setAllExpanded(treeData.getTree(), true);
    }

    if (!bRetainSelection)
        treeViewSelectionListener.clearSelections();
%>

<HTML>
<HEAD>
<TITLE></TITLE>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

<%
        treeView.dumpHeadContent(out);
%>

<script language="JAVASCRIPT">

function changeView()
{
    var selectedView = document.getElementById("view").selectedIndex;
    var currentURL = document.URL;
    var splitURL = currentURL.split("?");
    var URL = "/ui/jsp/XeHdr.jsp?" + splitURL[1];
    if (selectedView != 2)
        document.location.replace(URL);
}

function treeViewOnChange()
{
    MxPortalManageMenuRefreshSelections();
}

function treeViewOnLoad()
{
    initButtons();
    resetHelpContext();
    if (parent.myOnResize != null)
        parent.myOnResize();
    setTimeout("updateTreeView()", 33000);
}

function resetHelpContext()
{
    MxPortalWorkspaceSetHelpTopic("monitor_system_nav_treeView");
}

function removeNextSpan()
{
    var oDivs = document.getElementsByTagName("DIV");
    var i = 0;

    while (oDivs[i] != null)
    {
        if ((oDivs[i].id) != null)
        {
            if ((oDivs[i].id).indexOf("NEXT") != -1)
            {
                (oDivs[i].parentNode).removeChild(oDivs[i]);
            }
        }
        i++;
    }
}

function setTreeCheckBoxes(szState)
{
    // Set the selection gifs
    var oImages = document.getElementsByTagName("IMG");
    var i = 0;
    var checkImg = "";
    var oCheckImg;
    var checkState = CHECK_0;
    if (szState == "disabled")
        checkState = CHECK_DISABLED;

    while (oImages[i] != null)
    {
        if ((oImages[i].src).indexOf("check") > 0)
        {
            oCheckImg = oImages[i];
            checkImg = oCheckImg.src;

            // Set it to the disabled state
            if (checkImg.indexOf(CHECK_0) > 0)
                oCheckImg.src = oCheckImg.src.replace(CHECK_0, checkState);
            else if (checkImg.indexOf(CHECK_BOTH) > 0)
                oCheckImg.src = oCheckImg.src.replace(CHECK_BOTH, checkState);
            else if (checkImg.indexOf(CHECK_CONTENT) > 0)
                oCheckImg.src = oCheckImg.src.replace(CHECK_CONTENT, checkState);
            else if (checkImg.indexOf(CHECK_DISABLED) > 0)
                oCheckImg.src = oCheckImg.src.replace(CHECK_DISABLED, checkState);
            else
                oCheckImg.src = oCheckImg.src.replace(CHECK_1, checkState);
        }
        i++;
    }

    if (szState == "disabled" || szState == "clear")
    {
        var oDiv = document.getElementById("ID_MY_TREE");
        var oNodes = oDiv.getElementsByTagName("SPAN");
        for (var i = 0; i < oNodes.length; i++)
        {
            var oNode = oNodes.item(i);
            if (oNode.className == "<%=MxTreeView.CSS_SELECTED_1%>" ||
                oNode.className == "<%=MxTreeView.CSS_BRANCH_SELECTED_1%>")
                oNode.className = "<%=MxTreeView.CSS_SELECTED_0%>";
        }
        submitClearSelectionsRequest(szState);
    }
}

function submitClearSelectionsRequest(state)
{
    var URL = "clearTreeSelections.jsp?timeStamp=" + "<%=timeStamp %>";
    if (state == "disabled")
        URL += "&disableChildren=true";
    document.getElementById("treeComm").src = URL;
}

function loadSystemDrillDown(sysId, sysName, defaultView)
{
    var URL = "../drilldown/MxDrillDown.jsp?deviceGUID=" + sysId + "&globalselection=true&drillDownType=" + "<%=drillDown.DEVICE_NAME_DRILL_DOWN %>";
    document.getElementById("treeComm").src = URL;
}

function loadStatusDrillDown(sysId, sysName, value)
{
    var URL = "../drilldown/MxDrillDown.jsp?deviceGUID=" + sysId + "&globalselection=true&drillDownType=" + "<%=drillDown.HW_STATUS_DRILL_DOWN %>";
    if (value != "0")
        document.getElementById("treeComm").src = URL;
}

function loadContainerDeviceStatusDrilldown(nodeId, deviceId, deviceName, severity)
{
    var URL = "loadContainerDrillDown.jsp?status=true&nodeId=" + nodeId + "&deviceId=" + deviceId  + "&deviceName=" + encodeURIComponent(deviceName) + "&severity=" + severity + "&timeStamp=" + "<%=timeStamp %>";
    document.getElementById("treeComm").src = URL;
}

function MxTreeUpdateStatusForNode(szNodeId, szStatusImageURL)
{
    document.getElementById("Status_" + szNodeId).src = szStatusImageURL;
}

function refreshTreeView(bClearSelections)
{
    var clearSelectionsParam = "&clearSelections=true";
    var url = "../../mxportal/home/MxTreeView.jsp?refresh=true&timeStamp=" + "<%=timeStamp %>";
    if (bClearSelections)
        url += "&clearSelections=true";
    document.location.replace(url);
}

function setEmptyString(bTreeHasChildren)
{
    var oEmptySpan = document.getElementById("emptySpan_ID_MY_TREE");
    if (!bTreeHasChildren)
    {
        oEmptySpan.style.display = "block";
        removeNextSpan();
    }
    else
    {
        oEmptySpan.style.display = "none";
    }
}

function updateTreeView()
{
    var url = "updateTreeView.jsp?timeStamp=" + "<%=timeStamp %>";
    document.getElementById("statusComm").src = url;
}

function updateDeviceStatus(nodeId, newStatusUrl)
{
    oNodeToUpdate = document.getElementById("Device_Status_" + nodeId);
    oWhitespaceSpan = document.getElementById("Status_Whitespace_" + nodeId);
    if (oWhitespaceSpan != null)
    {
        if (bIsHidden)
            oWhitespaceSpan.style.visibility = "none";
        else
            oWhitespaceSpan.style.visibility = "inline";
    }
    if (oNodeToUpdate != null)
        oNodeToUpdate.src = newStatusUrl;
}

function updateOverallStatus(nodeId, newStatusUrl)
{
    oNodeToUpdate = document.getElementById("Overall_Status_" + nodeId);
    if (oNodeToUpdate != null)
        oNodeToUpdate.src = newStatusUrl;
}

function addNode(parentId, nodeId, nextSiblingId, previousSiblingId, oNodeDiv, oBranchDiv, nodeStyle, nodeClass)
{
    // Make sure the node isn't already there
    if (document.getElementById(nodeId) != null ||
        document.getElementById("MXTREE_" + nodeId) != null ||
        document.getElementById("OUTER_DIV_" + nodeId) != null)
    {
        // If the node is already present, but it is now a branch
        // instead of a leaf, we need to replace it
        if (oBranchDiv != null && document.getElementById("MXTREE_" + nodeId) == null)
        {
            if (document.getElementById("OUTER_DIV_" + nodeId) != null)
            {
                var nodeToDelete = "OUTER_DIV_" + nodeId;
                deleteNode(nodeToDelete, parentId);
            }
            else if (document.getElementById(nodeId) != null)
            {
                deleteNode(nodeId, parentId);
            }
        }
        else
        {
            return;
        }
    }

    // See if this is a branch node
    var bBranch = oBranchDiv != null;

    // Get the parent node
    var oParent = document.getElementById("MXTREE_" + parentId);

    if (oParent == null)
    {
        if (parentId == "")
            oParent = document.getElementById("ID_MY_TREE");
        else
            return;
    }

    // Get the previousSibling node
    var oPreviousSibling = document.getElementById("MXTREE_" + previousSiblingId);

    if (oPreviousSibling == null)
        oPreviousSibling = document.getElementById("OUTER_DIV_" + previousSiblingId);

    if (oPreviousSibling == null)
        oPreviousSibling = document.getElementById(previousSiblingId);

    // Get the nextSibling node
    var oNextSibling = document.getElementById("OUTER_DIV_" + nextSiblingId);

    if (oNextSibling == null)
        oNextSibling = document.getElementById("MXTREE_" + nextSiblingId);

    if (oNextSibling != null)
        oNextSibling = document.getElementById(nextSiblingId);

    // Create a new div object, and set it's innerHtml to that of the new node
    var oNewDiv = document.createElement("DIV");
    oNewDiv.innerHTML = oNodeDiv.innerHTML;

    // Now set it's outer html properties
    if (nodeStyle != "")
    {
        oNewDiv.setAttribute("style", nodeStyle);
    }

    if (nodeClass != "")
    {
        oNewDiv.className = nodeClass;
    }
    oNewDiv.id = nodeId;

    // Create a new div object for the branch div, if this is a branch,
    // and set it's innerHtml to that of the new node
    if (bBranch)
    {
        var oNewBranchDiv = document.createElement("DIV");
        oNewBranchDiv.innerHTML = oBranchDiv.innerHTML;

        // Now set it's outer html properties
        oNewBranchDiv.setAttribute("style", "white-space:nowrap");
        oNewBranchDiv.className = "mxtree-hide";
        oNewBranchDiv.id = "MXTREE_" + nodeId;
    }

    // Add the new node to the parent node
    if (nextSiblingId == "MXTREE_FIRST_CHILD")
    {
        if (bBranch)
            oParent.insertBefore(oNewBranchDiv, oParent.firstChild);
        oParent.insertBefore(oNewDiv, oParent.firstChild);
    }
    else if (oPreviousSibling != null)
    {
        // Try inserting after the previous sibling
        var oSiblingToInsertBefore = oPreviousSibling.nextSibling;
        if (oSiblingToInsertBefore != null)
        {
            oParent.insertBefore(oNewDiv, oSiblingToInsertBefore);
            if (bBranch)
                oParent.insertBefore(oNewBranchDiv, oSiblingToInsertBefore)
        }
        else
        {
            oParent.appendChild(oNewDiv);
            if (bBranch)
                oParent.appendChild(oNewBranchDiv);
        }
    }
    else if (oNextSibling != null)
    {
        oParent.insertBefore(oNewDiv, oNextSibling);
        if (bBranch)
            oParent.insertBefore(oNewBranchDiv, oNextSibling);
    }
}

function deleteNode(nodeId, parentId)
{
    var oSpanToDelete = document.getElementById("ALL_LBL_" + nodeId);

    // If the span is not found, return
    if (oSpanToDelete == null)
        return;

    var oNodeToDelete = getFirstParentOfType(oSpanToDelete, "DIV");
    var oChildTreeToDelete = document.getElementById("MXTREE_" + nodeId);
    var oParent = document.getElementById("MXTREE_" + parentId);

    if (oParent == null)
        oParent = document.getElementById("ID_MY_TREE");

    // Remove the node
    if (oParent.contains(oNodeToDelete))
        oParent.removeChild(oNodeToDelete);
}

function initButtons()
{
    enablePrintButton();
    disableSaveAsButton();
    disableDeleteButton();
}

function enablePrintButton()
{
    parent.ourButtonManager.enableButtonById("ID_PRINT_BUTTON");
}

function disablePrintButton()
{
    parent.ourButtonManager.disableButtonById("ID_PRINT_BUTTON");
}

function enableSaveAsButton()
{
    parent.ourButtonManager.enableButtonById("ID_SAVE_AS_BUTTON");
}

function disableSaveAsButton()
{
    parent.ourButtonManager.disableButtonById("ID_SAVE_AS_BUTTON");
}

function enableDeleteButton()
{
    parent.ourButtonManager.enableButtonById("ID_DELETE_BUTTON");
}

function disableDeleteButton()
{
    parent.ourButtonManager.disableButtonById("ID_DELETE_BUTTON");
}

function loadTreePrintWindow()
{
    var url = "../../../mxportal/home/MxTreeViewPrint.jsp?title=" + encodeURIComponent(MxPortalWorkspaceGetTitleHtml()) + "&timeStamp=" + "<%=timeStamp %>" + "&loadForPrint=true";
    window.open(url,
                "treeWindow",
                ",height=320,width=300,scrollbars=yes,resizable=yes,status=no,toolbar=yes,menubar=yes,location=no");
}

function unloadTreeInstance()
{
    document.getElementById("treeComm").contentWindow.document.location.replace("<%= MxOptions.URL_BASE %>/home/removeTreeViewInstance.jsp?timeStamp=<%= timeStamp %>");
}
</script>

</HEAD>

<BODY style='border:none' onload='treeViewOnLoad();' onUnload='unloadTreeInstance();'>
<table>
<tr>
<td id='treeCell' valign="top">
<%
    if (true)
    {
        treeView.dumpExpansionButtons(out);
        out.println("<br>");
        treeView.dumpTree(out);
    }
    else
        out.println(treeView.getEmptyString());
%>
</td>
</tr>
</table>

<IFRAME ID="treeComm" NAME="treeComm" SRC="MxBlank.html" WIDTH="0" HEIGHT="0" FRAMEBORDER=0></IFRAME>
<IFRAME ID="statusComm" NAME="statusComm" SRC="MxBlank.html" WIDTH="0" HEIGHT="0" FRAMEBORDER=0></IFRAME>

</BODY>
</HTML>
