<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="customColumn" class="com.hp.mx.portal.custom.MxCustomColumn" scope="session"/>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>
<%@ page import="java.util.ResourceBundle"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String queryID = request.getParameter("queryID");

    // initialize the bean
    customColumn.initialize(loginBean, Integer.parseInt(queryID));

    ResourceBundle rb      = customColumn.getRB();
    boolean        forward = false;

    if (request.getParameter("forward") == null)
    {
        forward = true;
    }

    MxButtons buttons = new MxButtons();
    //OK BUTTON - Close the CustomView and update and display current NodeView
    buttons.addMxTag(new MxDefaultTag("okButton", rb.getString("OK_BUTTON"), "applyListColumns()"));
    //CANCEL BUTTON - Close the CustomView and display current NodeView
    buttons.addMxTag(new MxDefaultTag("cancelButton", rb.getString("CANCEL_BUTTON"), "closeCustomColumns()"));

    MxButtons leftRightButtons = new MxButtons();
    leftRightButtons.setSecondary();
    //MOVE LEFT button
    leftRightButtons.addMxTag(new MxDefaultTag("moveLeft", "<<", "selMoveSideways(document.getElementById('selOrdered'),document.getElementById('selAvailable'))"));
    //MOVE RIGHT button
    leftRightButtons.addMxTag(new MxDefaultTag("moveRight", ">>", "selMoveSideways(document.getElementById('selAvailable'),document.getElementById('selOrdered'))"));
    leftRightButtons.setVerticalAligned(true);

    MxButtons upDownButtons = new MxButtons();
    upDownButtons.setSecondary();
    //MOVE UP button
    MxDefaultTag tag = new MxDefaultTag("moveUp", rb.getString("BUTTON_UP"), "selMoveUp()");
    tag.setAttr(MxTag.NO_RESIZE, "true");
    upDownButtons.addMxTag(tag);
    //MOVE DOWN button
    tag = new MxDefaultTag("moveDown", rb.getString("BUTTON_DOWN"), "selMoveDown()");
    tag.setAttr(MxTag.NO_RESIZE, "true");
    upDownButtons.addMxTag(tag);
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/customColumn.js'></script>
        <script language='javascript'>
            MxPortalWorkspaceSetSubtitleHtml('<%=rb.getString("DESCRIPTION")%>:&nbsp;<%=rb.getString("CUSTOM_DESCRIPTION")%>');
            // error messages
            var errorNoDisplayedColumns = '<%=rb.getString("ERROR_NO_COLUMNS")%>';
            // set the help topic html file
            MxPortalWorkspaceSetHelpTopic('<%=customColumn.getHelpID()%>');
            ///////////////////////////////////
            // createColumnWorkspace()
            ///////////////////////////////////
            function createColumnWorkspace()
            {
                MxPortalWorkspaceCreateUrl('<%=rb.getString("CUSTOMIZE_TITLE")%> <%=customColumn.getQueryName()%>',
                                           '<%=MxOptions.URL_BASE%>/home/customColumn.jsp?<%=request.getQueryString()%>&forward=1');
            }
            ///////////////////////////////////
            // createXeHdrWorkspace()
            ///////////////////////////////////
            function createXeHdrWorkspace()
            {
                MxPortalWorkspaceCreateUrl('<%=customColumn.getQueryName()%>', '<%=customColumn.getXeHdrURL()%>');
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body>

        <script language='javascript' type='text/javascript'>
<%
    if (forward == true)
    {
%>
        createColumnWorkspace();
<%
    }
%>
        </script>
<%
    if (forward == false)
    {
%>
        <table id='mainTable' border='0' cellpadding='0' cellspacing='0'>
            <tr>
                <td valign='middle'><%=rb.getString("AVAIL_COLS")%></td>
                <td valign='top'>&nbsp;</td>
                <td valign='middle'><%=rb.getString("DISP_COLS")%></td>
            </tr>
            <tr>
                <td valign='middle' align='center'>
                    <select size='10' id='selAvailable' style='width:280px' multiple
                            onClick='clearSelection(document.getElementById("selOrdered")), checkOrderedGray()'
                            onchange='checkAvailableGray()'>
<%
    // get the available columns to display, removing any that are already displayed
    customColumn.listAvailableColumns(out);
%>
                    </select>
                </td>
                <!-- MOVE LEFT AND RIGHT -->
                <td valign='middle' align='center'>
                    <div style="width:50px">
<%
    leftRightButtons.dumpButtons(out);
%>
                    </div>
                </td>
                <td valign='middle' align='center'>
                    <select size='10' id='selOrdered' style='width:280px' multiple
                            onchange='checkOrderedGray()'
                            onClick='clearSelection(document.getElementById("selAvailable")), checkAvailableGray()'>
<%
    // get the columns that are currently showing for this user
    customColumn.listUserColumns(out);
%>
                    </select>
                </td>
            </tr>
            <tr>
                <td>
                    <table border='0' cellpadding='0' cellspacing='0' style='width:100%; margin-top:3px'>
                        <tr>
                            <td nowrap>&nbsp;<%=rb.getString("SORT_BY")%>:
                                <select size='1' id='sortByColumn' onChange='checkSortDirection(this)'>
<%
    // dump out current displayed choices
    customColumn.listUserColumnsWithSortColumnSelected(out);
%>
                                </select>
                            </td>
                            <td nowrap>
                                <input type='radio' id='sortUp' name='sortDir' checked><%=rb.getString("ASCENDING")%><br>
                                <input type='radio' id='sortDown' name='sortDir'><%=rb.getString("DESCENDING")%>
                            </td>
                        </tr>
                        <tr>
                            <td colspan='2' nowrap>
                                <input type='checkbox' id='applyToAll'>&nbsp;<%=customColumn.getApplyToText()%>
                            </td>
                        </tr>
                    </table>
                </td>
                <td>&nbsp;</td>
                <td valign="top" align="right">
                    <div style='margin-top:10px'>
<%
    upDownButtons.dumpButtons(out);
%>
                    </div>
                </td>
            </tr>
        </table>

        <br/>

        <div>
<%
    buttons.dumpButtons(out);
%>
        </div>

        <script language='javascript' type='text/javascript'>
            // set the correct sort radio button
            var radio = null;

            if (<%=customColumn.isSortUp()%> == true)
            {
                radio = document.getElementById('sortUp');
            }
            else
            {
                radio = document.getElementById('sortDown');
            }

            radio.checked = true;

            checkAvailableGray();
            checkOrderedGray();
            ourButtonManager.disableButtonById('applyButton');
        </script>
<%
    } // end --> if (forward == false)
%>
        <!-- hidden <iframe> for 'applyColumns.jsp' -->
        <iframe id='applyColumns' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
<%
    // this list is used as the alphabetical base
    customColumn.dumpAllAvailableColumns(out);
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
