
function MxCollection()
{
    var m_lsize = 0;

    this.add = _add;
    this.addUnique = _addUnique;
    this.remove = _remove;
    this.removeAt = _removeAt;
    this.isEmpty = _isEmpty;
    this.size = _size;
    this.clear = _clear;
    this.clone = _clone;
    this.indexOf = _indexOf;
    this.contains = _contains;

    function _add(item)
    {
        if (item == null) return;

        m_lsize++;
        this[(m_lsize - 1)] = item;
    }

    function _addUnique(item)
    {
        if (this.indexOf(item) < 0)
            this.add(item);
    }

    function _removeAt(index)
    {
        if (index < 0 || index > this.length - 1) return;
        this[index] = null;

        for (var i = index; i <= m_lsize; i++)
            this[i] = this[i + 1];

        m_lsize--;
    }

    function _remove(item)
    {
        var i = this.indexOf(item);
        if (i >= 0) this.removeAt(i);
    }

    function _isEmpty() { return m_lsize == 0; }

    function _size() { return m_lsize; }

    function _clear()
    {
        for (var i = 0; i < m_lsize; i++)
            this[i] = null;

        m_lsize = 0;
    }

    function _clone()
    {
        var c = new MxCollection();

        for (var i = 0; i < m_lsize; i++)
            c.add(this[i]);

        return c;
    }

    function _indexOf(item)
    {
        for (var i = 0; i < m_lsize; i++)
            if (this[i] == item) return i;

        return -1;
    }

    function _contains(item)
    {
        return (this.indexOf(item) >= 0);
    }
}
