//======================================================================
//
// Java Script Functions used in the navigation area.
// Mostly from old IM7 code
//
//======================================================================
var selectedMenuItem = null;
var globalColorNormal = "#006699";
var globalColorHiLite = "black";

var SELECTED_BG_COLOR = "#66CCFF";

//======================================================================
// highlight an menu item
//======================================================================
function hiliteMenu(event)
{
    var el = getEventSrc(event);
    el.style.color = globalColorHiLite;
}

//======================================================================
// un-highlight an menu item
//======================================================================
function unhiliteMenu(event)
{
    var el = getEventSrc(event);
    el.style.color = globalColorNormal;
}

//======================================================================
// select an menu item
//======================================================================
function selectItem(event)
{
    var el = getEventSrc(event);
    if (null != selectedMenuItem)
    {
        selectedMenuItem.style.background='none'
    }

    selectedMenuItem = el;
    expandMenuItem(el);
}

//======================================================================
//======================================================================
function expandMenuItem(el)
{
    while (el != null)
    {
        if (el.tagName == "LI")
            if (el.getElementsByTagName("IMG").item(0) != null &&
                    el.getElementsByTagName("IMG").item(0).src.indexOf("menu_open.gif") != -1)
            {
                el.getElementsByTagName("IMG").item(0).src = EXPAND_IMG;
            }

        // tagName=UL
        if (el.className == "mfolder-show" ||
            el.className == "mfolder-hide")
        {

            el.className = "mfolder-show";
            el.style.display = "block";
        }

        el = el.parentNode;
    }
}

//======================================================================
// Function to be called from the onClick event.
// Menu item will be selected, and expanded/collapsed.
//======================================================================
function folderSelectToggle(event, szId, nShow)
{
    // Make sure clicked inside an LI. This test allows rich HTML inside lists.
    var clickedElem = getEventSrc(event);
    var elemLI = checkParent(clickedElem, "LI");
    if (elemLI == null)
        return;

    // If an LI doesn't have UL, it is an individual element, return.
    if (elemLI.getElementsByTagName("UL").length == 0 )
    {
       return;
    }

    // Found the UL inside the LI,
    var elemUL = elemLI.getElementsByTagName("UL")[0];
    var bShow = (elemUL.className == 'mfolder-hide');
    if (nShow == 1) bShow = true;
    if (nShow == 2) bShow = false;

    elemUL.className = bShow ? 'mfolder-show' : 'mfolder-hide';

    // Expand or Collapse nested list
    // Assumes expansion icon is first element after the LI item.
    if (bShow == true)
    {
        elemUL.style.display = "block";
        elemLI.getElementsByTagName("IMG")[0].src = EXPAND_IMG;
    }
    else
    {
        elemUL.style.display = "";
        elemLI.getElementsByTagName("IMG")[0].src = COLLAPSE_IMG;
    }
    event.cancelBubble = true;

    if (bShow == true)
        URL = "/mxportal/monitor/DoToggleExpansionForMonitor.jsp?htmltagid=" + szId + "&bshow=true";
    else
        URL = "/mxportal/monitor/DoToggleExpansionForMonitor.jsp?htmltagid=" + szId + "&bshow=false";

    document.getElementById("monitorCommSpace").contentWindow.document.location.replace(URL);
}

//======================================================================
//
//======================================================================
function monitor_toggleMenuItem(el, nShow)
{
    var bShow;
    if (nShow == "1") bShow = true;
    if (nShow == "2") bShow = false;
    var oImg;

    while (el != null)
    {
        if (el.tagName == "LI")
        {
            oImg = el.getElementsByTagName("IMG").item(0);
            if (oImg != null)
            {
                if (bShow)
                {
                    if (oImg.src.indexOf("menu_open.gif") != -1)
                        oImg.src = IMG_DIR + "/menu_close.gif";
                }
                else
                {
                    if (oImg.src.indexOf("menu_close.gif") != -1)
                        oImg.src = IMG_DIR + "/menu_open.gif";
                }
            }
        }

        if (el.className == "mfolder-show" ||
            el.className == "mfolder-hide")
        {
            if (bShow)
            {
                el.className = "mfolder-show";
                el.style.display = "block";
            }
            else
            {
                el.className = "mfolder-hide";
                el.style.display = "";
            }
        }

        el = el.parentNode;
    }
}

//======================================================================
// Function to expand or collapse all menu items
// nShow = 1, expand all
// nShow = 2, collapse all
//======================================================================
function showAllMonitorMenuItems(nShow)
{
    var oDiv = document.getElementById("MONITOR_BOTTOM_PART");
    var oLis = oDiv.getElementsByTagName("Li");
    var szList= "";

    for (var i = 0; i < oLis.length; i++)
    {
        var oLi = oLis.item(i);
        monitor_toggleMenuItem(oLi, nShow)
        if ((oLi.id.indexOf("folder") != -1) ||
                (oLi.id.indexOf("MyFavorites") != -1))
        {
            if (szList != "")
                szList += ",";

            szList += oLi.id;
        }
    }

    if (nShow == 1)
    {
        URL = "/mxportal/monitor/DoToggleExpansionForMonitor.jsp?htmltagid=" +
                szList + "&bshow=true";
    }
    else
    {
        URL = "/mxportal/monitor/DoToggleExpansionForMonitor.jsp?htmltagid=all"+
                "&bshow=false";
    }

    document.getElementById("monitorCommSpace").contentWindow.document.location.replace(URL);

}
