
<%
/*-------------------------------------------------------------------------
---- Copyright 2002 Compaq Information Technologies Group, L.P.
---------------------------------------------------------------------------
----
----    DataCollection.jsp - for generating Report on this device
----
----    Author:  Donnie Wahlquist
----
----    $ProjectName: j:/maple/coreWap.pj $
----    $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/reporting/DataCollection.jsp,v 1.18 2005/06/14 17:54:21 paynev Exp $
----------------------------------------------------------------------------*/
%>

<%@ page import="
    com.hp.mx.portal.help.*,
    com.hp.mx.portal.ui.*,
    com.hp.mx.utilities.*,
    com.hp.mx.core.querymanager.*,
    com.hp.mx.database.*,
    com.hp.mx.core.client.MxQueryClient,
    com.hp.mx.core.nodemanager.*,
    com.hp.mx.core.controllers.*,
    com.hp.mx.core.taskmanager.*,
    com.hp.mx.core.querymanager.*,
    com.hp.mx.core.querymanager.criteria.CriteriaDataObjectFactory,
    com.hp.mx.core.tools.reporting.*,
    com.hp.mx.core.controllers.MxGroupController,
    com.hp.mx.core.tools.reporting.format.formatIfc,
    com.hp.mx.core.reportmanager.*,
    com.hp.mx.core.client.MxReportClient,
    com.hp.mx.security.*,
    com.hp.mx.core.subjects.usermanager.MxUser,
    com.hp.mx.core.querymanager.criteria.DeviceNameDataObject,
    com.hp.mx.core.querymanager.criteria.DeviceObject,
    com.hp.mx.portal.applet.querywizard.criteria.InstanceDefinitionObject,
    com.hp.mx.portal.applet.utilities.XeJspUtil,
    com.hp.mx.utilities.*,
    com.hp.mx.utilities.DebugOutput,
    com.hp.mx.utilities.DebugSubsystem,
    com.hp.mx.core.subjects.MxSubjectPrivilege,
    java.util.*,
    java.sql.*,
    java.net.URLEncoder"


%>

<jsp:useBean id="XEUtil" scope="session" class="com.hp.mx.portal.applet.utilities.XeJspUtil"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="ReportsManage" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />


<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // setup resources.
    ReportsManage.init(loginBean, "ReportsManage");



    // RESET all global variables that are declared in the declaration block
    // lower in this file.  This makes sure that they are re-established each
    // time the page is visited, and not just set once for a session.
    MxNode d = null;


    /////////////////////////////////////////////////////////
    //  Get the "devId" parameter (DeviceKey) and then
    //  show Report of all info for that device.
    /////////////////////////////////////////////////////////

    try
    {
        Integer deviceId  = new Integer(1);
        String devIdStr  =  request.getParameter("devId");
        if (devIdStr != null )
        {
            deviceId  = new Integer(devIdStr);
        }

        d = MxNodeController.getDefaultControllerNoEx().getNodeByKey(deviceId);

        if (d == null || d.isDeviceDeleted() == true)
        {
            %>
            <%@ include file="pageDeviceRemoved.jsp" %>
            <%
            return;
        }

        // next, try and get a CriteriaFactory
        MxQueryClient queryClient = loginBean.getQueryClient();
        CriteriaDataObjectFactory myFactory = queryClient.getCriteriaFactory();
        // next, get a DeviceNameDataObject from the CriteriaDataObjectFactory
        DeviceNameDataObject myDeviceNameCriteria = (DeviceNameDataObject)myFactory.getObject("CriteriaByName");

        MxUser thisUser = loginBean.getMxUser();

        DeviceObject devObj = new DeviceObject(d.getDeviceName(), deviceId.intValue(), "");

        Vector nameVect = new Vector();
        nameVect.addElement(devObj);
        myDeviceNameCriteria.setSavedObjects(nameVect);
        boolean isIncludeVector = true;     // Always TRUE for this Action
        String strCriteriaId = "0";    // Arbitrary since dynamic queries cannot be edited or used in task creation
        String reportTitle = InvalidCharCheck.transformHTML(ReportsManage.getString("DATA_COLLECTION_REPORT_LABEL") + " " + d.getDeviceName());
        // Max length for report name is 150 chars. So the Label + System List name should only be 150 max.
        if (reportTitle.length() > 145)
           reportTitle = reportTitle.substring(0, 145) + "...";

        InstanceDefinitionObject ido = new InstanceDefinitionObject(reportTitle, strCriteriaId, isIncludeVector, myDeviceNameCriteria);
        Vector critVect = new Vector();
        critVect.addElement(ido);

        Query newDynamicQuery = new Query(reportTitle, View.DEVICE_VIEWS);
        newDynamicQuery.setDynamic(true);
        newDynamicQuery.addCriteriaObject(myDeviceNameCriteria, loginBean.getLocale());
        int vid = queryClient.addQuery(newDynamicQuery, loginBean.getLocale());

        // Create Reporting object.
        //ReportAPIs report = new ReportAPIs();

        // Get "itemsList" of all fields in reporting tables containing data about this device.
        int userPrivilege=0;
        MxReportClient reportClient =  loginBean.getReportClient();
        if (thisUser.hasPrivilege(MxSubjectPrivilege.REPORT_VIEW_SECURED_DATA_PRIVILEGE))
            userPrivilege = MxSubjectPrivilege.REPORT_VIEW_SECURED_DATA_PRIVILEGE.getPrivilegeCode();
        else if (thisUser.hasPrivilege(MxSubjectPrivilege.REPORT_MODIFICATION_PRIVILEGE))
            userPrivilege = MxSubjectPrivilege.REPORT_MODIFICATION_PRIVILEGE.getPrivilegeCode();

        String list = reportClient.getItemListForDevice(deviceId.intValue(), userPrivilege);

        reportTitle = URLEncoder.encode(reportTitle, "UTF-8");

        if ( ! list.equals("") )
        {
            String url = "ReportsResult.jsp" +
                         "?t=" + reportTitle +
                         "&rId=" + "-1" +
                         "&rName=" + reportTitle +
                         "&qID=" + vid +
                         "&qG=" + vid +
                         "&qT=" + reportConstant.QUERYTYPE_ID +
                         "&itms=" + list +
                         "&itmT=" + reportConstant.TYPE_ITEMID_INT +
                         "&rF=" + formatIfc.JSPFORMAT +
                         "&vO=0";

            // System.out.println("\n*** URL=" + url + "\n\n");
            out.println("<script>");
            out.println("   location.replace('" + url + "')" );
            out.println("</script>");
        }
        else
        {
            out.println(ReportsManage.getString("DATA_COLLECTION_REPORT_NO_DATA"));
        }
    }
    catch (Exception e)
    {
        out.println("Exception displaying the data collection link\n\n" + e);
    }

%>
