<%@ page import="javax.swing.tree.TreeModel" %>
<%@ page import="javax.swing.tree.TreeNode" %>
<%@ page import="javax.swing.tree.DefaultTreeModel" %>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.tree.*" %>

<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="eventSearchUI" class="com.hp.mx.portal.search.MxEventSearchUI" scope="session" />
<jsp:useBean id="aoEventSearchUI" class="com.hp.mx.portal.search.MxActionOnEventSearchUI" scope="session" />

<jsp:useBean id="excludeETTreeView" class="com.hp.mx.html.tree.MxTreeView" scope="session" />
<jsp:useBean id="excludeETExpansionModel" class="com.hp.mx.html.tree.MxDefaultTreeExpansionModel" scope="session" />
<jsp:useBean id="excludeETTreeController" class="com.hp.mx.html.tree.MxTreeController" scope="session" />
<jsp:useBean id="excludeETSelectionModel" class="com.hp.mx.html.tree.MxTreeSelectionModel" scope="session" />
<jsp:useBean id="rbsearch" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    //This line is required by Tomcat for il8n support
    MxBean.jspInit(request, response);

    // This aborts the page if the session is invalid
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Initialize the resource bean
    rbsearch.init(loginBean, "MxSearch");

    if (excludeETTreeController.checkUrlForControllerMessages(request, out))
    {
       return;
    }

    TreeModel myTreeModel;
    String szInframe = request.getParameter("inframe");

    if (excludeETTreeController.isFirstTime())
    {
        excludeETTreeView.setId("ID_ET_EXCLUDE_TREE");
        excludeETTreeView.setUrlHandler(request.getRequestURI());

        // Nimbus pages will use loginBean.getLocale() here:
        excludeETTreeController.setLocale(request.getLocale());

        TreeNode etRoot = null;

        if (szInframe != null && (szInframe.equals("events") || szInframe.equals("systems")))
            etRoot = aoEventSearchUI.getEventTypeTree();
        else
            etRoot = eventSearchUI.getEventTypeTree();

        myTreeModel = new DefaultTreeModel(etRoot);
        excludeETTreeController.setTreeModel(myTreeModel);
        excludeETTreeController.setExpansionModel(excludeETExpansionModel);
        excludeETTreeController.setSelectionModel(excludeETSelectionModel);
        excludeETSelectionModel.setExtendedSelectionMode(MxTreeSelectionModel.MULTI_CONTAINER_SELECTION);
        excludeETTreeController.setTreeView(excludeETTreeView);
    }

    if (szInframe != null && szInframe.equals("events"))
    {
        aoEventSearchUI.setSelectionTreeModel("exclude", excludeETSelectionModel);
        aoEventSearchUI.setExpansionTreeModel("exclude", excludeETExpansionModel);
    }
    else
    {
        eventSearchUI.setSelectionTreeModel("exclude", excludeETSelectionModel);
        eventSearchUI.setExpansionTreeModel("exclude", excludeETExpansionModel);
    }
    myTreeModel = excludeETTreeController.getTreeModel();

    excludeETSelectionModel.clearSelection();
    excludeETExpansionModel.clearExpansion();

    if (request.getParameter("edit") != null)
        if (szInframe != null && szInframe.equals("events"))
            aoEventSearchUI.setEventTypeTreeSelections(myTreeModel, false);
        else
            eventSearchUI.setEventTypeTreeSelections(myTreeModel, false);
%>

<HTML>
<HEAD>
<TITLE></TITLE>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/search/css/MxSearch.css'>

<script type='text/javascript' language='JavaScript'>

function LoadPage()
{
    resizeSelf(22);
}

function resizeSelf(offset)
{
    var oSelf = parent.document.getElementById("ID_EVENT_TYPE_EXCLUDE_FRAME");
    var h = document.getElementById("ID_TREE_DIV").offsetHeight;
    oSelf.style.height = h + offset;
    if (parent.resizeFrame != null)
        parent.resizeFrame(30);
}

function toggleETTree()
{
    var oTreeBody = document.getElementById("ID_ET_EXCLUDE_TREE");
    var oToggleImg = document.getElementById("ID_TREE_EXPANDER");
    var oTreeDiv = document.getElementById("ID_TREE_DIV");
    if (oTreeBody.className == "mxtree-body")
    {
        oTreeBody.className = "mxtree-hide";
        oTreeDiv.className = "tree-border-none";
        oToggleImg.src = "/mxportal/images/win_expand.gif";
        oToggleImg.title = "<%=rbsearch.getString("maximize")%>";
        resizeSelf(22);
    }
    else
    {
        oTreeBody.className = "mxtree-body";
        oTreeDiv.className = "tree-border";
        oToggleImg.src = "/mxportal/images/win_shrink.gif";
        oToggleImg.title = "<%=rbsearch.getString("minimize")%>";
        resizeSelf(22);
    }
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% excludeETTreeView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</HEAD>

<BODY onload="LoadPage()" topmargin="0" bottommargin="0" rightmargin="0" leftmargin="0">

<%
   if (myTreeModel != null)
   {
       out.println("<div id='etHeader' style='height:15px' class='window-title-row'>");
       out.println("    <div style='float:left;padding-top:1px;padding-left:4px'>" + rbsearch.getString("eventTypes") + "</div>");
       out.println("    <div style='float:right;padding-top:2px'><img id='ID_TREE_EXPANDER' onclick='javascript:toggleETTree();' border=0 src='/mxportal/images/win_shrink.gif' title='" + rbsearch.getString("minimize") + "'></div>");
       out.println("    <div style='clear:both'></div>");
       out.println("</div>");

       out.println("<div id='ID_TREE_DIV' class='tree-border' overflow='auto' height='300px'>");
       excludeETTreeView.dumpTree(out);
       out.println("</div>");
   }
%>

<% MxHtmlUtil.dumpBodyEnd(out); %>
</BODY>
</HTML>
