<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="java.util.*,
                 com.hp.mx.database.*,
                 com.hp.mx.portal.help.*"
%>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.html.table.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="discTemplate" class="com.hp.mx.portal.discovery.AutoDiscoveryTemplateBean" scope="session" />
<jsp:useBean id="discTempSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="discTempTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="discTempController" class="com.hp.mx.html.table.MxTableController" scope="session" />

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
        return;
    }

    // Bean setup
    discTemplate.initialize(loginBean, discTempSelectionModel);
    discTemplate.clearAllErrorMessages();

    if (discTempController.checkUrlForControllerMessages(request, out)) return;


    if (discTempController.isFirstTime())
    {
        discTempSelectionModel.setSelectionMode(MxTableSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        discTempTableView.setId("ID_DISCTEMP_TABLE");
        discTempTableView.setOnSelectionChange("mySelectionChanged");
        discTempTableView.setUrlHandler(request.getRequestURI());
        discTempController.setTableModelWithSorting(discTemplate.getTableModel() );
        discTempController.setSelectionModel(discTempSelectionModel);
        discTempController.setTableView(discTempTableView);
    }

    discTemplate.setFileList();

    boolean fromDiscovery = true; // always true now

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    buttons.addMxTag(new MxDefaultTag("btnNew", discTemplate.getResourceString("template.page.button.new"), "newTemplate()"));

    MxTag btnEditTag = new MxDefaultTag("btnEdit", discTemplate.getResourceString("template.page.button.edit"), "showTemplateDetails()");
    btnEditTag.setAttr(MxTag.DISABLED, "true");
    buttons.addMxTag(btnEditTag);

    MxTag btnDeleteTag = new MxDefaultTag("btnDelete", discTemplate.getResourceString("template.page.button.delete"), "delTemplate()");
    btnDeleteTag.setAttr(MxTag.DISABLED, "true");
    buttons.addMxTag(btnDeleteTag);

    buttons.setVerticalAligned(true);

%>
<html>
    <head>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js"></script>
        <script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/utilities.js" ></script>
        <script language='JavaScript' type='text/javascript'>

        MxPortalWorkspaceSetHelpTopic("admin_discovery_template");

        /**
         * iRow: For performance reasons, this will be MxTableSortingModel.ID_SELECTOR
         * if all items are selected or deselected at once (rather than sending
         * events for all items in the table).
         *
         * bSelected: current selection state (true = selected)
         */
        function mySelectionChanged(szIdTable, iRow, bSelected)
        {

            checkButtonStates();
            var iFrame = document.getElementById("templateDetails");
            if (iFrame != null)
            {
                iFrame.contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/home/MxBlank.html");
            }

            MxPortalWorkspaceSetHelpTopic("admin_discovery_template");
        }

        function checkButtonStates()
        {
            // new button is always enabled.
            // default state on page load is disabled, so only enable if something is selected.
            var aSel = MxTableGetSelections("ID_DISCTEMP_TABLE");
            if (aSel.length == 1)
                ourButtonManager.enableButtonById('btnEdit');
            else
                ourButtonManager.disableButtonById('btnEdit');

            if (aSel.length >  0)
                ourButtonManager.enableButtonById('btnDelete');
            else
                ourButtonManager.disableButtonById('btnDelete');
        }


        /////////////////////////////////////////////////
        // newTemplate()
        /////////////////////////////////////////////////
        function newTemplate()
        {
            var iFrame = document.getElementById("templateDetails");
            if (iFrame != null)
            {
                iFrame.contentWindow.document.location.replace("AutoDiscoveryTemplateDetails.jsp?newTemplate=true");
            }
        }


        /////////////////////////////////////////////////
        // showTemplateDetails()
        /////////////////////////////////////////////////
        function showTemplateDetails()
        {
            var aSel = MxTableGetSelections("ID_DISCTEMP_TABLE");
            if (aSel.length != 1)
            {
                alert("<%= discTemplate.getResourceString("template.page.error.noFileSelection") %>");
                return;
            }

            var iFrame = document.getElementById("templateDetails");
            if (iFrame != null)
            {
                iFrame.contentWindow.document.location.replace("AutoDiscoveryTemplateDetails.jsp?editTemplate=true");
            }

        }


        /////////////////////////////////////////////////
        // remove template
        /////////////////////////////////////////////////
        function delTemplate()
        {
            var aSel = MxTableGetSelections("ID_DISCTEMP_TABLE");
            if (aSel.length == 0)
            {
                alert("<%= discTemplate.getResourceString("template.page.error.noFileSelection") %>");
                return;
            }
            var proceed = true;
            if (aSel.length == 1)
            {
                proceed = confirm ("<%= discTemplate.getResourceString("template.page.msg.confirm.delete") %>")
            }
            else
            {
                proceed = confirm ("<%= discTemplate.getResourceString("template.page.msg.confirm.delete2") %>")
            }

            if (proceed)
            {
                var iFrame = document.getElementById("templateDetails");
                if (iFrame != null)
                {
                    iFrame.contentWindow.document.location.replace("AutoDiscoveryTemplateDetails.jsp?delTemplate=true");
                }
            }
        }

        function init()
        {
            <%
            // Tell the user that the hosts file systems were added successfully
            if (request.getParameter("addSucceeded") != null)
               out.println("alert(\"" + discTemplate.getResourceString("template.page.msg.add.success") + "\");");
            %>

            checkButtonStates();
            setTimeout("myOnResize()", 500);
            setDisplayHeightAndWidth();
        }

        function setDisplayHeightAndWidth()
        {
            var pageHeight  = document.body.scrollHeight;
            var pageWidth  = document.body.scrollWidth;
            parent.setFrmDisplayHeight(pageHeight);
        }

        function setFrmDisplayHeight(pageHeight)
        {
            document.getElementById('templateDetails').style.height =  pageHeight;
            setDisplayHeightAndWidth();
        }

        function cleanup()
        {
        }

        function myOnResize()
        {
            resize_w();
        }

        function resize_w()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(0, 0) - 200);
            MxTableSetWidth("ID_DISCTEMP_TABLE", w);
        }

        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% MxButton.dumpHeadContent(out); %>
<% discTempTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body  onLoad="init()" onUnload="cleanup()" onResize="myOnResize()">
    <hr>
    <div class='subwindow-header'>
         <%= discTemplate.getResourceString("template.page.title") %>
    </div>
    <p><%= discTemplate.getResourceString("template.page.description") %></p>

    <%
        discTemplate.displayErrorMessagesInHtml(out);
        discTemplate.clearAllErrorMessages();
    %>

    <table width="100%" cellspacing="0" cellpadding="2">
       <tr valign="top">
            <td>
                <% discTempTableView.dumpWholeTable(out); %>
            </td>
            <td valign=top>
            <div style="margin-top:15px;width:130px">
                <% buttons.dumpButtons(out); %>
            </div>
            </td>
        </tr>
    </table>

    <iframe id="templateDetails" style="width:100%; height:650; position:relative; visibility:visible"
            scrolling="no" marginwidth="0" frameborder="0" src="<%=MxOptions.URL_BASE%>/home/MxBlank.html"></iframe>

<% MxHtmlUtil.dumpBodyEnd(out); %>

  </body>
</html>
