<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>

<!--  REQUIRED: This bean is used (later) to verify that this page is allowed to run -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<!--  DO NOT COPY: These are example beans -->
<jsp:useBean id="daBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="selectionBean" class="com.hp.mx.portal.core.MxObjSelections" scope="session"/>
<%!
    /** **********************************************************************
     * The debug object
     ************************************************************************ */
    public DebugSubsystem daDebug = DebugOutput.getDebugSubsystem("DeviceAttributesBean");
    // REQ: Set necessary HTTP header attributes (for localization and page caching)

%>
<%
    // This next call MUST come before the < jsp:setProperty > tag
    MxBean.jspInit(request, response);
%>
<jsp:useBean id="daBean" class="com.hp.mx.portal.device.DeviceAttributesBean" scope="page">
    <jsp:setProperty name="daBean" property="*" />
</jsp:useBean>
<%

    // REQ: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
 <% }

    boolean isPost = request.getMethod().equals("POST");
    // Initialize beans
    daBundle.init(loginBean, "DeviceAttributes");
    deviceBundle.init(loginBean, "MxDeviceBundle");
    boolean initSuccess = daBean.initialize(loginBean, Integer.parseInt(request.getParameter("devId")), isPost);

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag verboseBtnTag = new MxDefaultTag("verboseButton", daBundle.getString("attrib.button.ok"), "");
    verboseBtnTag.setAttr(MxTag.TYPE, "submit");
    MxTag btnCancelTag = new MxDefaultTag("btnCancel", daBundle.getString("attrib.button.cancel"), "backToSystemPage()");

    buttons.addMxTag(verboseBtnTag);
    buttons.addMxTag(btnCancelTag);

    MxTag btnRestoreNameTag = new MxDefaultTag("btnRestoreName", daBundle.getString("attrib.button.restoreName"), "restoreDisplayName()");

%>

<html>
<head>
    <title><%= daBundle.getString("attrib.pageTitle")%></title>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>
    <script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/utilities.js" ></script>
    <script language="JavaScript" type="text/javascript">

        function myOnLoad()
        {
            MxPortalWorkspaceSetHelpTopic("useTools_systemPage_link_editSysPropLink");
            MxPortalWorkspaceSetSubtitleHtml("<jsp:getProperty name="daBean" property="deviceName" />");
        }

        function myOnResize()
        {
            resize_w();
            resize_h();
        }

        function resize_w()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
        }

        function resize_h()
        {
            var h_total = Math.max(0, MxBrowserGetBodyHeight(0, 0));
        }

        function backToSystemPage()
        {
            MxPortalWorkspaceCreateUrlEx("<%=deviceBundle.get("SYSTEM_PAGE")%>", "<jsp:getProperty name="daBean" property="displayName" />", "../DevicePage/devicepage.jsp?nodeId=<%=daBean.getNodeGuid()%>&selection=ID_LINKS");
        }

        function restoreDisplayName()
        {
            var el = document.getElementById("displayName");
            if (el != null)
            {
                el.value = "<%=  daBean.getDefaultSystemName() %>";
            }
        }

        function autoSelectCb(id)
        {
            var cb = document.getElementById(id);
            if (cb != null)
            {
                cb.checked = true;
            }
        }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<body class="tools-body" onLoad="myOnLoad()" onResize="myOnResize()">
<div class="body-proxy" id="ID_BODY_PROXY">

    <%
    // DISPLAY BEAN AND JSP PROPERTIES
    if (daDebug.check(20))
    {
        daBean.displayBeanPropsHtml(out);
        out.println("<BR>");
        daBean.displayJspParamsHtml(request, out);
        //daDebug.displayJspParamsToConsole(request);
    }

    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (isPost)
    {
        daDebug.log(5, "[DeviceAttributes.jsp] PROCESSING HTTP POST");
        daBean.clearAllErrorMessages();

        // Device subtypes (an indexed property) need to be set by hand
        for (int i = 0; i < daBean.NUM_SUBTYPES; i++)
        {
            String paramName = "systemSubtype" + i;
            daBean.setSystemSubtype(request.getParameter(paramName), i);
        }

        boolean success = daBean.saveSystemAttributes();

        if (success)
        {
            // Fix for rQm #264465 - "remove node"/"add node" will update the global selection object
            // with the updated node information
            selectionBean.removeNodeByKey(Integer.parseInt(request.getParameter("devId")));
            selectionBean.addNodeByKey(Integer.parseInt(request.getParameter("devId")));

            // Update menu for any potential OS changes
            %><script language="JavaScript" type="text/javascript">MxPortalManageMenuRefresh();</script><%

            if (daBean.isDisplayNameChanged())
            {
                %><script language="JavaScript" type="text/javascript">alert('<%= daBean.getDisplayNameChangeWarning() %>');</script><%
            }
            %><script language="JavaScript" type="text/javascript">backToSystemPage();</script><%
            return;
        }
    }
    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////
    daDebug.log(5, "[DeviceAttributes.jsp] PROCESSING HTTP GET (Page displaying normally)");

    // Display any error messages
    if (daBean.hasErrorMessages())
    {
        // Display plurally-correct label
        if (daBean.getErrorMessageList().size() == 1)
        {
            %><div class="errorTextBold"><%= daBundle.getString("error.label.single")%>:</div><%
        }
        else
        {
            %><div class="errorTextBold"><%= daBundle.getString("error.label.multiple")%>:</div><%
        }

        // Finally, display the error message(s)
        daBean.displayErrorMessagesInHtml(out);
    }

    if (initSuccess)
    {
    %>

    <% // STATIC SYSTEM ATTRIBUTES %>


    <% // Preferred Name %>
    <form action="DeviceAttributes.jsp?devId=<%= request.getParameter("devId") %>" method="post" name="dvcAttribsForm" id="dvcAttribsForm">
    <table cellspacing="0" cellpadding="2" border="0">
    <tr>
        <td nowrap colspan="3"><b><%= daBundle.getString("attrib.sectionHeader.Identification")%></b></td>
    </tr>
    <tr>
        <td nowrap>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.preferredName")%>:</td>
        <td>
            <input type="text" maxlength="255" name="displayName" id="displayName" value="<jsp:getProperty name="daBean" property="displayName" />" SIZE="40" onKeyDown="autoSelectCb('nameLock')">
        </td>
        <td>
            <% MxButton.dumpButton(btnRestoreNameTag, out); %>
        </td>
    </tr>
    <tr>
        <td nowrap></td>
        <td nowrap colspan="2"><input type="checkbox" id="nameLock" name="nameLock" <%= daBean.isNameLock() ? "checked" : "" %>><label for="nameLock"><%= daBundle.getString("cbNameLock")%></label></td>
    </tr>
    <tr>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.serialNumber")%>:</td>
        <td colspan="2"><input type="text" maxlength="80" name="serialNumber" value="<jsp:getProperty name="daBean" property="serialNumber" />" SIZE="40" onKeyDown="autoSelectCb('attributeLock')" <%= daBean.getSerialNumSetByDiscovery() ? "disabled" : "" %>></td>
    </tr>
    </table>

    <% // All the other Attributes %>
    <table cellspacing="0" cellpadding="2">
    <tr>
        <td nowrap colspan="2">&nbsp;</td>
    </tr>
    <tr>
        <td nowrap colspan="2"><b><%= daBundle.getString("attrib.sectionHeader.ProductDescription")%></b></td>
    </tr>
    <tr>
        <% // TYPE %>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.systemType")%>:</td>
        <td>
            <select name="systemType" onChange="autoSelectCb('attributeLock')">
                <% daBean.displaySystemTypeTags(out); %>
            </select>
        </td>
    </tr>
    <%
        for (int i = 0; i < daBean.NUM_SUBTYPES; i++)
        {
    %>
    <tr>
        <% // SUBTYPE %>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.systemSubtype")%> <%= (i + 1) %>:</td>
        <td>
            <select name="systemSubtype<%= i %>" onChange="autoSelectCb('attributeLock')">
                <% daBean.displaySystemSubTypeTags(out, i); %>
            </select>
        </td>
    </tr>
    <%
        }
    %>
    <tr>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.productModel")%>:</td>
        <td><input type="text" maxlength="255" name="productModel" value="<jsp:getProperty name="daBean" property="productModel" />" SIZE="40" onKeyDown="autoSelectCb('attributeLock')"></td>
    </tr>
    <tr>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.hwDescription")%>:</td>
        <td><input type="text" maxlength="255" name="hwDescription" value="<jsp:getProperty name="daBean" property="hwDescription" />" SIZE="40" onKeyDown="autoSelectCb('attributeLock')"></td>
    </tr>
    <tr>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.osDescription")%>:</td>
        <td><input type="text" maxlength="255" name="osDescription" value="<jsp:getProperty name="daBean" property="osDescription" />" SIZE="40" onKeyDown="autoSelectCb('attributeLock')"></td>
    </tr>
    <tr>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.osType")%>:</td>
        <td>
            <select name="osType" onChange="autoSelectCb('attributeLock')">
                <% daBean.displayOSTypeTags(out); %>
            </select>
        </td>
    </tr>
    <tr>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.osversion")%>:</td>
        <td><input type="text" maxlength="80" name="osVersion" value="<jsp:getProperty name="daBean" property="osVersion" />" SIZE="40" onKeyDown="autoSelectCb('attributeLock')"></td>
    </tr>
    <tr>
        <td nowrap colspan="2">&nbsp;</td>
    </tr>
    <tr>
        <td nowrap colspan="2"><b><%= daBundle.getString("attrib.sectionHeader.ContactInformation")%></b></td>
    </tr>
    <tr>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.contact")%>:</td>
        <td><input type="text" maxlength="255" name="contact" value="<jsp:getProperty name="daBean" property="contact" />" SIZE="40" onKeyDown="autoSelectCb('attributeLock')"></td>
    </tr>
    <tr>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.location")%>:</td>
        <td><input type="text" maxlength="255" name="location" value="<jsp:getProperty name="daBean" property="location" />" SIZE="40" onKeyDown="autoSelectCb('attributeLock')"></td>
    </tr>
    <tr>
        <td nowrap colspan="2"></td>
    </tr>
    <tr>
        <td nowrap colspan="2"><b><%= daBundle.getString("attrib.sectionHeader.AssetInformation")%></b></td>
    </tr>
    <tr>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;<%= daBundle.getString("attrib.assetNumber")%>:</td>
        <td><input type="text" maxlength="255" name="assetNumber" value="<jsp:getProperty name="daBean" property="assetNumber" />" SIZE="40" onKeyDown="autoSelectCb('attributeLock')"></td>
    </tr>
    </table>
    <br>
    <input type="checkbox" id="attributeLock" name="attributeLock" <%= daBean.isAttributeLock() ? "checked" : "" %>><label for="attributeLock"><%= daBundle.getString("cbDiscoveryLock")%></label>


    <!-- OK BUTTON -->
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
    </form>

<%
    }
%>
</div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
