<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>

<% MxBean.jspInit(request, response); %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="daBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="daBean" class="com.hp.mx.portal.device.DeviceAttributesBean" scope="page">
    <jsp:setProperty name="daBean" property="*" />
</jsp:useBean>
<%!
    /** **********************************************************************
     * The debug object
     ************************************************************************ */
    public DebugSubsystem daDebug = DebugOutput.getDebugSubsystem("DeviceAttributesBean");
%>

<%
    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
 <% }

    // Initialize beans
    boolean initSuccess = daBean.initialize(loginBean, Integer.parseInt(request.getParameter("devId")), request.getMethod().equals("POST"));
    daBundle.init(loginBean, "DeviceAttributes");
    deviceBundle.init(loginBean, "MxDeviceBundle");


    MxDateAndTime curTime = new MxDateAndTime(loginBean.getLocale(), loginBean.getTimeZone());

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag okButtonTag = new MxDefaultTag("btnOK", daBundle.getString("suspend.button.ok"), "" );
    okButtonTag.setAttr(MxTag.TYPE, "submit");
    okButtonTag.setAttr(MxTag.DISABLED, "true");
    buttons.addMxTag(okButtonTag);

    buttons.addMxTag(new MxDefaultTag("btnCancel", daBundle.getString("suspend.button.cancel"), "backToSystemPage()" ));

%>

<html>
<head>
    <title><%= daBundle.getString("suspend.pageTitle")%></title>
    <% MxPortalRender.dumpHeadContent(out); %>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>
    <script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/utilities.js" ></script>
    <script language="JavaScript" type="text/javascript">

        function myOnLoad()
        {
            MxPortalWorkspaceSetHelpTopic("useTools_systemPage_link_suspendResume");
            MxPortalWorkspaceSetSubtitleHtml("<%= daBean.getDeviceName() %>");
        }

        function myOnResize()
        {
            resize_w();
            resize_h();
        }

        function resize_w()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
        }

        function resize_h()
        {
            var h_total = Math.max(0, MxBrowserGetBodyHeight(0, 0));
        }

        function backToSystemPage()
        {
            MxPortalWorkspaceCreateUrlEx("<%=deviceBundle.get("SYSTEM_PAGE")%>", "<%= daBean.getDeviceName() %>", "../DevicePage/devicepage.jsp?nodeId=<%=daBean.getNodeGuid()%>&selection=ID_LINKS");
        }

        function enableButtons(flag)
        {
            if (flag)
            {
                enableElement('snoozeTime');
            }
            else
            {
                disableElement('snoozeTime');
            }

            ourButtonManager.enableButtonById("btnOK")
        }

    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<body class="tools-body" onLoad="myOnLoad()" onResize="myOnResize()">
<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        daDebug.log(5, "[DeviceSuspend.jsp] PROCESSING HTTP POST");
        daBean.clearAllErrorMessages();
        boolean success = daBean.saveSnoozeSettings(request);

        if (success)
        {
            %><script language="JavaScript" type="text/javascript">backToSystemPage();</script><%
            return;
        }
    }

    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////

    // Display any error messages
    if (daBean.hasErrorMessages())
    {
        // Display plurally-correct label
        if (daBean.getErrorMessageList().size() == 1)
        {
            %><div class="errorTextBold"><%= daBundle.getString("error.label.single")%>:</div><%
        }
        else
        {
            %><div class="errorTextBold"><%= daBundle.getString("error.label.multiple")%>:</div><%
        }

        // Finally, display the error message(s)
        daBean.displayErrorMessagesInHtml(out);
    }

    if (initSuccess)
    {
    %>

<div class="body-proxy" id="ID_BODY_PROXY">

    <!-- SNOOZE SETTINGS -->
    <p><%= daBundle.getString("suspend.instructions")%></p>
    <p><b><%= daBean.getSnoozeMessage() %></b></p>
    <form action="DeviceSuspend.jsp?devId=<%= request.getParameter("devId") %>" method="post" name="dvcAttribsForm" id="dvcAttribsForm">

    <input type="radio" name="rbSnooze" value="<%= daBean.SNOOZE_OFF %>" id="rbSnoozeNever" value="1" onClick="enableButtons(false)" <%= (daBean.getSnoozeSetting().equals(daBean.SNOOZE_NEVER)) ? "disabled" : "" %>><label for="rbSnoozeNever"><%= daBundle.getString("suspend.time.label.none")%></label><br>
    <input type="radio" name="rbSnooze" value="<%= daBean.SNOOZE_ON %>" id="rbSnoozeSometimes" value="2" onClick="enableButtons(true)" <%= (daBean.getSnoozeSetting().equals(daBean.SNOOZE_NEVER)) ? "disabled" : "" %>><label for="rbSnoozeSometimes"><%= daBundle.getString("suspend.time.label.temporary")%></label>
    <select name="snoozeTime" id="snoozeTime" size="1" disabled>
        <option value="5"><%= daBundle.getString("suspend.time.5min")%></option>
        <option value="15"><%= daBundle.getString("suspend.time.15min")%></option>
        <option value="60"><%= daBundle.getString("suspend.time.1hour")%></option>
        <option value="1440"><%= daBundle.getString("suspend.time.1day")%></option>
    </select>
    <br>
    <input type="radio" name="rbSnooze" value="<%= daBean.SNOOZE_PERMANENT %>" id="rbSnoozeAlways" value="3" onClick="enableButtons(false)"  <%= (daBean.getSnoozeSetting().equals(daBean.SNOOZE_NEVER)) ? "disabled" : "" %>><label for="rbSnoozeAlways"><%= daBundle.getString("suspend.time.label.indefinitely")%></label><br>

    <!-- OK BUTTON -->
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
    </form>
</div>
<%
    }
%>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
