<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel" %>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID" %>
<%@ page import="com.hp.mx.core.objectmodel.MxGUID" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="groupUI" class="com.hp.mx.portal.settings.MxGroupUI" scope="session" />
<jsp:useBean id="nodeGroupTableModel" class="com.hp.mx.portal.settings.MxNodeGroupTableModel" scope="session" />
<jsp:useBean id="nodeGroupTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="nodeGroupTableController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="nodeGroupSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="authTabModel" class="com.hp.mx.portal.settings.MxAuthTabModel" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_GROUP_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    rbsettings.init(loginBean, "MxSettings");
    authTabModel.load(rbsettings);
    authTabModel.setMxTagSelectionId(authTabModel.MX_GROUPS_ID);
%>
<%
    if ( nodeGroupTableController.isFirstTime() )
    {
        nodeGroupTableView.setId("ID_NODE_GROUP_TABLE");
        nodeGroupTableView.setOnSelectionChange("mySelectionChanged");
        nodeGroupTableView.setUrlHandler(request.getRequestURI());
        nodeGroupTableView.setHeight("150px");
        nodeGroupTableView.setWidth("600px");
        nodeGroupTableController.setTableModelWithSorting(nodeGroupTableModel);
        nodeGroupTableController.setSelectionModel(nodeGroupSelectionModel);
        nodeGroupTableController.setTableView(nodeGroupTableView);
    }
    if ( nodeGroupTableController.checkUrlForControllerMessages(request, out) )
    {
        return;
    }
    nodeGroupTableModel.setShowMembers(false);
    nodeGroupTableModel.loadAllNodeGroups(loginBean,rbsettings);
    MxTableSortingModel sortable = nodeGroupTableController.getSortingModelOrNull();
    if (null != sortable)
    {
        // Sort on the group name (first column)
        sortable.sortTable(0,true);
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("addButton", rbsettings.getString("button.add"), "LoadWindow('Add', 'ID_NODE_GROUP_TABLE')"));
    buttons.addMxTag(new MxDefaultTag("editButton", rbsettings.getString("button.edit"), "LoadWindow('Edit', 'ID_NODE_GROUP_TABLE')"));
    buttons.addMxTag(new MxDefaultTag("deleteButton", rbsettings.getString("button.delete"), "LoadWindow('Delete', 'ID_NODE_GROUP_TABLE')"));
    buttons.addMxTag(new MxDefaultTag("reportButton", rbsettings.getString("button.report"), "LoadWindow('Report', 'ID_NODE_GROUP_TABLE')"));
    buttons.setVerticalAligned(true);

%>
<html>

<head>
<title>Required Field</title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JavaScript" type="text/javascript">

function LoadWindow(ButtonPushed, groupTableId)
{
    if(ButtonPushed == "Add")
    {
        document.getElementById("GroupWkSpace").contentWindow.document.location.replace("AddGroup.jsp");
    }
    if(ButtonPushed == "Edit")
    {
        document.getElementById("GroupWkSpace").contentWindow.document.location.replace("EditGroup.jsp");
    }
    if(ButtonPushed == "Delete")
    {
        // Pop up a confirmation box first
        if(confirm("<%=rbsettings.getString("group.delete")%>"))
        {
            document.deleteForm.submit();
        }
    }
    if(ButtonPushed == "Report")
    {
        // reload the page to refresh the current list to match the report list.
        document.location.href="GroupStart.jsp?report=true";
    }
}

function mySelectionChanged(szIdTable, szId, bSelected)
{
    var aSelCount = MxTableGetSelectionCount(szIdTable);

    // Set the buttons: Note that refresh and report are always enabled, so we don't touch them
    if (aSelCount == 0)
    {
        ourButtonManager.disableButtonById('editButton');
        ourButtonManager.disableButtonById('deleteButton');
    }
    else if (aSelCount == 1)
    {
        ourButtonManager.enableButtonById('editButton');
        ourButtonManager.enableButtonById('deleteButton');
    }
    else if (aSelCount > 1)
    {
        ourButtonManager.disableButtonById('editButton');
        ourButtonManager.enableButtonById('deleteButton');
    }

    // Context of the subwindow no longer matches the selection.  Clear it.
    document.getElementById("GroupWkSpace").contentWindow.document.location.replace("Blank.html");
    MxPortalWorkspaceSetHelpTopic("admin_auth_group");

}

function initButtons()
{
    ourButtonManager.disableButtonById('editButton');
    ourButtonManager.disableButtonById('deleteButton');
}

</script>
<script language="JavaScript" type="text/javascript">

function myOnLoad()
{
    var reportFlag = "<%=request.getParameter("report")%>";
    if (reportFlag == "true")
    {
        MxPortalWorkspaceSetHelpTopic("admin_auth_reportGroup");
    }
    else
    {
        MxPortalWorkspaceSetHelpTopic("admin_auth_group");
    }
    initButtons();
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% authTabModel.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% nodeGroupTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body id="ID_BODY_PROXY" onLoad="myOnLoad()">

<% authTabModel.dumpTabs(out); %>

  <div id="TOP_PART" style="margin-top:15px">
    <table width="100%" border="0" cellpadding="5">
      <tr>
        <td width="70%" valign="top" align="left">
          <% nodeGroupTableView.dumpTableVisiblePart(out); %>
        </td>
        <td width="30%" valign="top" align="left">
            <div style="margin-top:10px;width:130px">
              <% buttons.dumpButtons(out); %>
            </div>
        </td>
      </tr>
    </table>
  </div>

<IFRAME ID="GroupWkSpace" NAME="GroupSpace" SRC="Blank.html" WIDTH=100% HEIGHT=800 SCROLLING=AUTO FRAMEBORDER=0></IFRAME>

<form method="POST" action="GroupServer.jsp" target="GroupSpace" name="deleteForm">
    <input type="hidden" name="command" value="delete">
    <input type="hidden" name="names">
</form>
<% nodeGroupTableView.dumpTableHiddenPart(out); %>

<%  String applyFlag  = request.getParameter("apply");
    String reportFlag = request.getParameter("report");
    if(applyFlag != null && applyFlag.equals("true"))
    { %>
        <script language="JAVASCRIPT">
            document.getElementById("GroupWkSpace").src = "AddGroup.jsp?apply=true";
        </script>
<%  }
    else if(reportFlag != null && reportFlag.equals("true"))
    {
%>
        <script language="JAVASCRIPT">
            // document.getElementById("GroupWkSpace").src = "ReportGroup.jsp";
            reportWindow = window.open("ReportGroup.jsp?printable=yes", "groupReportWindow", "menubar=1, titlebar=1, toolbar=1, scrollbars=1, resizable=1");
            reportWindow.focus();
        </script>
<%  }
%>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
