<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="userUI" class="com.hp.mx.portal.settings.MxUserUI" scope="session" />
<jsp:useBean id="userTableModel" class="com.hp.mx.portal.settings.MxUserTableModel" scope="session" />
<jsp:useBean id="userTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="userTableController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="userSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="authTabModel" class="com.hp.mx.portal.settings.MxAuthTabModel" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    rbsettings.init(loginBean, "MxSettings");
    authTabModel.load(rbsettings);
    authTabModel.setMxTagSelectionId(authTabModel.MX_USERS_ID);
%>
<%
    if ( userTableController.isFirstTime() )
    {
        userTableView.setId("ID_USER_TABLE");
        userTableView.setOnSelectionChange("mySelectionChanged");
        userTableView.setUrlHandler(request.getRequestURI());
        userTableView.setWidth("600");
        //userTableView.setHeight("300");
        userTableController.setTableModelWithSorting(userTableModel);
        userTableController.setSelectionModel(userSelectionModel);
        userTableController.setTableView(userTableView);
    }
    if ( userTableController.checkUrlForControllerMessages(request, out) )
    {
        return;
    }
    userTableModel.setShowPagerInfo(userUI.showPagerInfo());
    userTableModel.loadAllUsers(loginBean,rbsettings);
    MxTableSortingModel sortable = userTableController.getSortingModelOrNull();
    if (null != sortable)
    {
        // Sort on the user name (first column)
        sortable.sortTable(0,true);
    }

    // Calculate Table Height
    int MAX_NUM_ROWS_TO_SHOW = 15;
    int PIXELS_PER_ROW = 20;
    int rowCount = userTableModel.getRowCount();
    boolean bSetTableHeight = rowCount > MAX_NUM_ROWS_TO_SHOW;

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("addButton", rbsettings.getString("button.add"), "LoadWindow('Add', 'ID_USER_TABLE')"));
    buttons.addMxTag(new MxDefaultTag("addGroupButton", rbsettings.getString("button.addgroup"), "LoadWindow('AddGroup', 'ID_USER_TABLE')"));
    buttons.addMxTag(new MxDefaultTag("editButton", rbsettings.getString("button.edit"), "LoadWindow('Edit', 'ID_USER_TABLE')"));
    buttons.addMxTag(new MxDefaultTag("deleteButton", rbsettings.getString("button.delete"), "LoadWindow('Delete', 'ID_USER_TABLE')"));
    buttons.addMxTag(new MxDefaultTag("reportButton", rbsettings.getString("button.report"), "LoadWindow('Report', 'ID_USER_TABLE')"));
    buttons.setVerticalAligned(true);

%>
<html>

<head>
<title>Required Field</title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JavaScript" type="text/javascript">

function LoadWindow(ButtonPushed, userTableId)
{
    if(ButtonPushed == "Add")
    {
        document.getElementById("UserWkSpace").contentWindow.document.location.replace("AddUser.jsp");
    }
    if(ButtonPushed == "AddGroup")
    {
        document.getElementById("UserWkSpace").contentWindow.document.location.replace("AddUser.jsp?usergroup=true");
    }
    if(ButtonPushed == "Edit")
    {
        document.getElementById("UserWkSpace").contentWindow.document.location.replace("EditUser.jsp?command=edit");
    }
    if(ButtonPushed == "Delete")
    {
        // Pop up a confirmation box first
        if(confirm("<%=rbsettings.getString("user.delete")%>"))
        {
            // The command field for the delete form is already set.
            document.deleteForm.submit();
        }
    }
    if(ButtonPushed == "Report")
    {
        // reload the page to refresh the current list to match the report list.
        document.location.href="UserStart.jsp?report=true";
    }
}

function mySelectionChanged(szIdTable, szId, bSelected)
{
    var aSelCount = MxTableGetSelectionCount(szIdTable);

    // Set the buttons: Note that refresh and report are always enabled, so we don't touch them
    if (aSelCount == 0)
    {
        ourButtonManager.disableButtonById('editButton');
        ourButtonManager.disableButtonById('deleteButton');
    }

    if (aSelCount == 1)
    {
        ourButtonManager.enableButtonById('editButton');
        ourButtonManager.enableButtonById('deleteButton');
    }

    if (aSelCount > 1)
    {
        ourButtonManager.disableButtonById('editButton');
        ourButtonManager.enableButtonById('deleteButton');
    }

    // Context of the subwindow no longer matches the selection.  Clear it.
    document.getElementById("UserWkSpace").contentWindow.document.location.replace("Blank.html");
    MxPortalWorkspaceSetHelpTopic("admin_auth_user");
}

function initButtons()
{
    ourButtonManager.disableButtonById('editButton');
    ourButtonManager.disableButtonById('deleteButton');
}

</script>
<script language="JavaScript" type="text/javascript">

function myOnLoad()
{
    MxTableSetWidth("ID_USER_TABLE", 600);
    <%
    if (bSetTableHeight)
    {
    %>
    MxTableSetHeight("ID_USER_TABLE", <%= MAX_NUM_ROWS_TO_SHOW * PIXELS_PER_ROW %>);
    <%
    }
    %>

    var reportFlag = "<%=request.getParameter("report")%>";
    if (reportFlag == "true")
    {
        MxPortalWorkspaceSetHelpTopic("admin_auth_reportUser");
    }
    else
    {
        MxPortalWorkspaceSetHelpTopic("admin_auth_user");
    }
    initButtons();
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% authTabModel.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% userTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body id="ID_BODY_PROXY" onLoad="myOnLoad()">

<% authTabModel.dumpTabs(out); %>

<div id="TOP_PART" style="margin-top:15px">

    <table width="100%" border="0" cellpadding="5">
      <tr>
        <td width="70%" valign="top" align="left">
          <% userTableView.dumpTableVisiblePart(out); %>
        </td>
        <td width="30%" valign="top" align="left">
           <div style="margin-top:10px;width:130px">
            <% buttons.dumpButtons(out); %>
           </div>
        </td>
      </tr>
    </table>

</div>

<% userTableView.dumpTableHiddenPart(out); %>

<IFRAME ID="UserWkSpace" NAME="UserSpace" SRC="Blank.html" WIDTH=100% HEIGHT=1100 SCROLLING=AUTO FRAMEBORDER=0></IFRAME>

<!-- Similar deleteForm in UserServer.jsp bypasses the confirmation check -->
<form method="POST" action="UserServer.jsp" target="UserSpace" name="deleteForm">
    <input type="hidden" name="command" value="delete">
</form>

<%  String applyFlag  = request.getParameter("apply");
    String reportFlag = request.getParameter("report");

    String userGroupFlag = request.getParameter("usergroup");
    String userGroupParam = "";
    if ((userGroupFlag != null) && (userGroupFlag.equalsIgnoreCase("true")))
    {
        userGroupParam = "usergroup=true&";
    }

    if(applyFlag != null && applyFlag.equals("true"))
    { %>
        <script language="JAVASCRIPT">
            document.getElementById("UserWkSpace").src = "AddUser.jsp?<%=userGroupParam%>apply=true";
        </script>
<%  }
    else if(reportFlag != null && reportFlag.equals("true"))
    {
%>
        <script language="JAVASCRIPT">
            // document.getElementById("UserWkSpace").src = "ReportUser.jsp";
            reportWindow = window.open("ReportUser.jsp?printable=yes", "userReportWindow", "menubar=1, titlebar=1, toolbar=1, scrollbars=1, resizable=1");
            reportWindow.focus();
        </script>
<%  }
%>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
