//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/js/SysTypMgr.js,v $
//$Revision: 1.6 $
//$Date: 2005/01/12 20:45:07 $

// define global constants - prefix with SysTypMgrJS to avoid name conflicts

var SysTypMgrJS = new Object();

SysTypMgrJS.IMG_SPG_GIF = "img/spg.gif";

// define functions
function checkName(devName)
{

    devName = devName.replace(/^\s*/, '').replace(/\s*$/, ''); // trim string

    if ( 0 == devName.length )
    {
        alert('<%=stmBean.getResString("MSG_MISSING_PDCT_NAME")%>');
        return false;
    }

    if ( 127 < devName.length )
    {
        alert('<%=stmBean.getResString("MSG_PDCT_NAME_TOO_LONG")%>');
        return false;
    }

    return true;
}

function checkPriority(priority)
{

    var nPriority;

    var regExp = new RegExp("[^0-9^]"); //matches anything that is not a number

    if ( regExp.test( priority ) )
    {
        alert('<%=stmBean.getResString("MSG_PRIORITY_INVALID")%>');
        return false;
    }

    nPriority = new Number(parseInt(priority));

    if (isNaN(nPriority))
    {
        alert('<%=stmBean.getResString("MSG_PRIORITY_INVALID")%>');
        return false;
    }

    if (nPriority < 1)
    {
        alert('<%=stmBean.getResString("MSG_PRIORITY_INVALID")%>');
        return false;
    }

    if (nPriority > 65536)
    {
        alert('<%=stmBean.getResString("MSG_PRIORITY_TOO_LARGE")%>');
        return false;
    }

    return true;
}

function checkSysOID(sysOID)
{

     sysOID = sysOID.replace(/^\s*/, '').replace(/\s*$/, ''); // trim string

     if ( 0 == sysOID.length )
     {
        alert('<%=stmBean.getResString("MSG_MISSING_SYSOID")%>');
        return false;
     }

    if ( 149 < sysOID.length )
    {
        alert('<%=stmBean.getResString("MSG_SYSOID_TOO_LONG")%>');
        return false;
    }

    var regExp = new RegExp("[^.^0-9^]"); //matches anything that is not a dot or a number

    if ( regExp.test( sysOID ) )
    {
        alert('<%=stmBean.getResString("MSG_SYSOID_BAD_FORMAT")%>');
        return false;
    }

    return true;
}

function checkOID(oid)
{

    oid = oid.replace(/^\s*/, '').replace(/\s*$/, ''); // trim string

    if ( 0 == oid.length )
     {
        return true;
     }

    if ( 149 < oid.length )
    {
        alert('<%=stmBean.getResString("MSG_OID_TOO_LONG")%>');
        return false;
    }

    var regExp = new RegExp("[^.^0-9^]"); //matches anything that is not a dot or a number

    if ( regExp.test( oid ) )
    {
        alert('<%=stmBean.getResString("MSG_OID_BAD_FORMAT")%>');
        return false;
    }

    return true;
}

function checkIPAddress(ipAddress)
{
    var num;
    var temp;
    var dotCount = 0;
    var pos;

    // replace leading and trailing characters with 'x' and force a failure
    // we don't want to accept ip addresses with leading/trailing spaces

//    ipAddress = ipAddress.replace(/^\s*/, 'x').replace(/\s*$/, 'x');

    if ( 0 == ipAddress.length )
    {
        alert('<%=stmBean.getResString("MSG_MISSING_IP")%>');
        return false;
    }

    var regExp = new RegExp("[^.^0-9^]"); //matches anything that is not a dot or a number

    if ( regExp.test( ipAddress ) )
    {
        alert('<%=stmBean.getResString("MSG_INVALID_IP")%>');
        return false;
    }

    temp = ipAddress;

    while (-1 != (pos = temp.indexOf(".")))
    {
        num = temp.substring(0, pos);
        dotCount++;
        temp = temp.substr(pos+1);

        if (3 < dotCount)
        {
            alert('<%=stmBean.getResString("MSG_INVALID_IP")%>');
            return false;
        }

        if (isNaN (num = parseInt(num)))
        {
            alert('<%=stmBean.getResString("MSG_INVALID_IP")%>');
            return false;
        }

        if ((1 == dotCount) && (0 == num))
        {
            alert('<%=stmBean.getResString("MSG_INVALID_IP")%>');
            return false;
        }

        if ((0 > num) || (255 < num))
        {
            alert('<%=stmBean.getResString("MSG_INVALID_IP")%>');
            return false;
        }
    }

    if (3 != dotCount)
    {
        alert('<%=stmBean.getResString("MSG_INVALID_IP")%>');
        return false;
    }

    num = temp;

    if (isNaN (num = parseInt(num)))
    {
        alert('<%=stmBean.getResString("MSG_INVALID_IP")%>');
        return false;
    }

    if ((0 > num) || (255 < num))
    {
        alert('<%=stmBean.getResString("MSG_INVALID_IP")%>');
        return false;
    }

    return true;
}

function checkURL(url)
{

    if ( 127 < url.length )
    {
        alert('<%=stmBean.getResString("MSG_URL_TOO_LONG")%>');
        return false;
    }

    return true;
}

function launchURL(sURL)
{

    sURL = sURL.replace(/^\s*/, '').replace(/\s*$/, ''); // trim string

     //is there a string of substance here?
    if ( 0 == sURL.length )
    {
        alert('<%=stmBean.getResString("MSG_MISSING_URL")%>');
        return false;
    }

    if ( 127 < sURL.length )
    {
        alert('<%=stmBean.getResString("MSG_URL_TOO_LONG")%>');
        return false;
    }

    var testURL;
    sURL = sURL.toLowerCase() ;
    if ( -1 == sURL.indexOf("http://") )
    {
        sURL = "http://" + sURL;
    }

    if ( -1 != sURL.indexOf("$ipaddress") )
    {
        testURL = sURL.replace("$ipaddress","127.0.0.1");
    }
    else if ( -1 != sURL.indexOf("$hostname") )
    {
        testURL = sURL.replace("$hostname","127.0.0.1");
    }
    else if ( -1 != sURL.indexOf("$address") )
    {
        testURL = sURL.replace("$address","127.0.0.1");
    }
    else
    {
        testURL = sURL ;
    }

     if ( window.open(testURL) != null )
     {
        return true;
     }

    alert('<%=stmBean.getResString("MSG_URL_ERR")%>');
    return false;

}

function checkSNMPRule()
{
    return true;
}

///////////////////////////////////////////////////////////////////////////////

function clearForm()
{
    document.frmDTMSNMPAdd.reset();

    document.frmDTMSNMPAdd.idDevType.selectedIndex = 0;
    document.frmDTMSNMPAdd.idDevName.value = "";
    document.frmDTMSNMPAdd.idRulePriority.value = "";
    document.frmDTMSNMPAdd.idURL.value = "";

    document.frmDTMSNMPAdd.idSysOID.value = "";
    //document.frmDTMSNMPAdd.idOIDName.value = "";
    document.frmDTMSNMPAdd.idOID.value = "";
    document.frmDTMSNMPAdd.idOIDVal.value = "";
    document.frmDTMSNMPAdd.idOIDDataType.selectedIndex = 0;
    document.frmDTMSNMPAdd.idCompareRule.selectedIndex = 0;

    return true;
}

function getSysOID()
{
    document.forms[0].idPageName.value = "dtmSNMPGetOIDResponse";
    document.forms[0].idReqType.value = "getSysOID";
    document.forms[0].idSubType.value = "sysOID";

    document.frmDTMSNMPAdd.submit();
    return true;
}

function getOIDResponse()
{

    var sysOid = document.frmDTMSNMPAdd.idSysOID.value;
    var oid = document.frmDTMSNMPAdd.idOID.value;

    if (!checkSysOID(sysOid))
    {
        document.frmDTMSNMPAdd.idSysOID.focus();
        return false;
    }

    if (!checkOID(oid))
    {
        document.frmDTMSNMPAdd.idOID.focus();
        return false;
    }

    document.forms[0].idPageName.value = "dtmSNMPGetOIDResponse";
    document.forms[0].idReqType.value = "getMibOID";
    document.forms[0].idSubType.value = "mibOID";

    document.frmDTMSNMPAdd.submit();
    return true;

}

function getOID()
{

    var sysOid = document.frmDTMSNMPAdd.idSysOID.value;
    var oid = document.frmDTMSNMPAdd.idOID.value;

    if (!checkSysOID(sysOid))
    {
        document.frmDTMSNMPAdd.idSysOID.focus();
        return false;
    }

    document.forms[0].idPageName.value = "dtmSNMPGetOID";
    document.forms[0].idReqType.value = "getOID";
    document.forms[0].idSubType.value = "";

    document.frmDTMSNMPAdd.submit();
    return true;

}


function cancelAdd()
{

    alert('<%=stmBean.getResString("MSG_ADD_CANCELLED")%>');

    document.forms[0].idPageName.value = "dtmMain";
    document.forms[0].idReqType.value = "init";
    document.forms[0].idSubType.value = "";

    document.frmDTMSNMPAdd.submit();
    return true;

}
//
//$Log: SysTypMgr.js,v $
//Revision 1.6  2005/01/12 20:45:07  farley
//detab
//
//Revision 1.5  2004/01/27 15:34:30  kumar
//fixed ISSUE0000245681 - STM should accept standard characters of the
//foreign alphabet (German).
//
//Revision 1.4  2003/05/16 15:24:47  kumar
//re-add
//
//Revision 1.2  2003/04/22 20:30:39  kumar
//work in progress
//
//Revision 1.1  2003/04/21 23:30:55  kumar
//work in progress
//
//
