<%@ page info="Manul Discovery - Hosts Files Details"%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.database.*" %>
<%@ page import="com.hp.mx.portal.help.*"%>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.html.table.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="mdHostsBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="mdHostsBean" class="com.hp.mx.portal.discovery.ManualDiscoveryHostsBean" scope="session" />
<jsp:useBean id="mdHostsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="mdHostsTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="mdHostsTableController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
        return;
    }

    // setup resources.
    mdHostsBundle.init(loginBean, "ManualDiscovery");


    // and my bean
    mdHostsBean.initialize(loginBean, mdHostsSelectionModel );

    String fileNameFieldState = "";
    String mode = "new";
    String errStr = "";
    String subHeader="";
    String preloadLabel = mdHostsBundle.getString("mdHosts.preload.label.new");
    String preloadNowButtonLabel = mdHostsBundle.getString("mdHosts.button.loadNow.new");

    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        // save the file...
        mdHostsBean.clearAllErrorMessages();
        mdHostsBean.processDetailsPost(request,  out);

        // maintain the mode
        if (request.getParameter("newOrEdit") != null)
        {
            mode = request.getParameter("newOrEdit");
        }
    }
    else
    {
        String paramResults = "";

        // load the file - or show default new.
        if (request.getParameter("delTemplate") != null)
        {
            mdHostsBean.deleteFile(request,  out);

            if (mdHostsBean.hasErrorMessages())
            {
                paramResults = "?error=1";
            }

            out.print(" <script language=\"JavaScript\" type=\"text/javascript\">");
            out.print("parent.location.href=\"manualDiscoveryHost.jsp" + paramResults + "\"");
            out.print("</script> ");
            return;
        }

        if (request.getParameter("addSystems") != null)
        {
            mdHostsBean.addSystemsFromHostsFile();

            if (!mdHostsBean.hasErrorMessages())
            {
                paramResults = "?addSucceeded=true";
            }
            else
            {
                paramResults = "?error=1";
            }

            out.print(" <script language=\"JavaScript\" type=\"text/javascript\">");
            out.print("parent.location.href=\"manualDiscoveryHost.jsp" + paramResults + "\"");
            out.print("</script> ");
            return;
        }

        if (request.getParameter("newTemplate") != null)
        {
            mode = "new";
            mdHostsBean.clearAllErrorMessages();
        }
        else if (request.getParameter("editTemplate")!= null )
        {
            // for now always leave enabled - otherwise field is not in param list
            fileNameFieldState = "readonly";
            mode = "edit";
            mdHostsBean.clearAllErrorMessages();
        }
        else
        {
            return;
        }
    }


    if (mode.equalsIgnoreCase("new"))
    {
        subHeader = mdHostsBundle.getString("mdHosts.label.newHostFile");
            preloadLabel = mdHostsBundle.getString("mdHosts.preload.label.new");
            preloadNowButtonLabel = mdHostsBundle.getString("mdHosts.button.loadNow.new");
    }
    else if (mode.equalsIgnoreCase("edit"))
    {
        subHeader = mdHostsBundle.getString("mdHosts.label.editHostFile");
        preloadLabel = mdHostsBundle.getString("mdHosts.preload.label.edit");
        preloadNowButtonLabel = mdHostsBundle.getString("mdHosts.button.loadNow.edit");
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag loadBtnTag = new MxDefaultTag("loadBtn", preloadNowButtonLabel, "loadNow()");

    MxTag btnOkTag = new MxDefaultTag("btnOk", mdHostsBundle.getString("mdHosts.button.OK"), "doSave()");
    MxTag btnCancelTag = new MxDefaultTag("btnCancel", mdHostsBundle.getString("mdHosts.button.cancel"), "cancel()");

    buttons.addMxTag(btnOkTag);
    buttons.addMxTag(btnCancelTag);

%>


<html>
<head>
    <STYLE TYPE="text/css">
    <!--
        .indented{margin-left:12px;}
    -->
    </STYLE>
    <script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>
    <script language="JavaScript" type="text/javascript">
    <%
    if (mode.equals("edit"))
    {
        %>MxPortalWorkspaceSetHelpTopic("admin_discovery_manageHostsFiles_edit");<%
    }
    else
    {
        %>MxPortalWorkspaceSetHelpTopic("admin_discovery_manageHostsFiles_new");<%
    }
    %>

    function cancel()
    {
        MxPortalWorkspaceSetHelpTopic("admin_discovery_manageHostsFiles");
        location.href="<%= MxOptions.URL_BASE %>/home/MxBlank2.html";
    }

    function loadNow()
    {
        if (radioSelected("rNone"))
        {
            var contents = "# Title:    [title here]\n";
            contents += "# Author:  [author here]\n";
            contents += "\n";
            contents += "# Example:\n";
            contents += "##$IMXE_DEFAULT: Type = server\n";
            contents += "# 1.1.1.1    myServer1.mysite.com     myServer1\n";
            contents += "# 1.1.1.2    myServer2.mysite.com     myServer2\n";
            contents += "#\n";
            contents += "##$IMXE_DEFAULT: Type = desktop\n";
            contents += "# 1.1.1.3    myClient1.mysite.com     myClient1\n";
            contents += "# 1.1.1.4    myClient2.mysite.com     myClient2\n";
            document.getElementById("fileContents").value = contents;
        }
        else if (radioSelected("rMgmtSrv"))
        {
            // Since we're dealing with a multi-part form, use URL for settings
            var fileName = document.getElementById("fileName").value;
            var radioSource = document.getElementById("rMgmtSrv").value;
            document.ConfigForm.action = "manualDiscoveryHostDetails.jsp?loadNow=true&loadFromCMS=true&fileName=" + escape(fileName) + "&radioSource=" + escape(radioSource) + "&newOrEdit=<%= mode %>";
            document.ConfigForm.submit();
        }
        else // Load from client
        {
            // Since we're dealing with a multi-part form, use URL for settings
            var clientFileName = document.getElementById("selectFileBtn").value;
            if (clientFileName == "")
            {
                alert("<%= mdHostsBundle.getString("mdHosts.error.noClientFile") %>");
                return;
            }

            var fileName = document.getElementById("fileName").value;
            var radioSource = document.getElementById("rClient").value;
            var selectFileBtnValue = document.getElementById("selectFileBtn").value;
            document.ConfigForm.action = "manualDiscoveryHostDetails.jsp?loadNow=true&uploadFile=true&radioSource=" + escape(radioSource) + "&newOrEdit=<%= mode %>";
            document.ConfigForm.submit();
        }
    }

    function doSave()
    {
        var fileName = document.getElementById("fileName").value;
        document.ConfigForm.action = "manualDiscoveryHostDetails.jsp?saveIt=1&newOrEdit=<%= mode %>&fileName=" + escape(fileName);
        document.ConfigForm.submit();
        return true;
    }

    function checkDetailButtonStates()
    {
        if (document.getElementById("rClient").checked) enableBrowseButton(true);

        if (document.ConfigForm.fileName.value.length > 0)
        {
            ourButtonManager.enableButtonById('btnOk');
        }
        else
        {
            ourButtonManager.disableButtonById('btnOk');
        }
    }


    function enableBrowseButton(flag)
    {
        setElementEnabled("selectFileBtn", flag)
    }

    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% mdHostsTableView.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<body onLoad="checkDetailButtonStates()">
    <hr>
    <div class='subwindow-header'>
         <%= subHeader %><%if (mode.equals("edit")){%>: <%=mdHostsBean.getFileName(request) %><%}%>
    </div><BR>
    <% mdHostsBean.displayErrorMessages(out); %>
    <form action="javascript:doSave()" method="POST" name="ConfigForm" ENCTYPE="multipart/form-data">
        <%
        if (mode.equals("edit"))
        {
            out.println("<div style=\"display:none\">");
        }
        %>
        <div class="required_label"><%= mdHostsBundle.getString("mdAdd.label.required")%> *</div>
        <strong><%= mdHostsBundle.getString("mdHosts.fileName")%>:<span class="required">*</span></strong> <input type="text" <%= fileNameFieldState %> name="fileName" id="fileName" size="30" onMouseUp="checkDetailButtonStates()" onKeyUp="checkDetailButtonStates()" onChange="checkDetailButtonStates()" value="<%=mdHostsBean.getFileName(request) %>" maxlength="50" ><BR><BR>
        <%
        if (mode.equals("edit"))
        {
            out.println("</div>");
        }
        %>
        <strong><%= preloadLabel %>:</strong>
        <div class="indented">
            <input type="hidden" name="newOrEdit" value="<%= mode %>">
            <table>
            <tr>
                <td><input type="radio" onclick="enableBrowseButton(false);" name="radioSource" id="rNone" value="none" <%= mdHostsBean.getCheckStateFromAttributes (request, "radioSource", "none") %> checked><label for="rNone"><%= mdHostsBundle.getString("mdHosts.preload.empty")%></label>
                </td>
            </tr>
            <tr>
                <td><input type="radio" onclick="enableBrowseButton(false);" name="radioSource" id="rMgmtSrv" value="cms" <%= mdHostsBean.getCheckStateFromAttributes (request, "radioSource", "cms")%>><label for="rMgmtSrv"><%= mdHostsBundle.getString("mdHosts.preload.cms")%></label>:
                <select name = "cmsSort" size=1>
                    <option value="sortByIp" <%= mdHostsBean.getSelectedStateFromAttributes(request, "cmsSort", "sortByIp")%> selected><%= mdHostsBundle.getString("mdHosts.preload.cms.IP")%></option>
                    <option value="sortByName" <%= mdHostsBean.getSelectedStateFromAttributes (request, "cmsSort", "sortByName")%>><%= mdHostsBundle.getString("mdHosts.preload.cms.Name")%></option>
                    <option value="sortByTypeAndIp" <%= mdHostsBean.getSelectedStateFromAttributes (request, "cmsSort", "sortByTypeAndIp")%>><%= mdHostsBundle.getString("mdHosts.preload.cms.typeAndIp")%></option>
                    <option value="sortByTypeAndName" <%= mdHostsBean.getSelectedStateFromAttributes (request, "cmsSort", "sortByTypeAndName")%>><%= mdHostsBundle.getString("mdHosts.preload.cms.typeAndName")%></option>
                </select>
                </td>
            </tr>
            <tr>
                <td><input type="radio" onclick="enableBrowseButton(true);" name="radioSource" id="rClient" value="client" <%= mdHostsBean.getCheckStateFromAttributes (request, "radioSource", "client") %>><label for="rClient"><%= mdHostsBundle.getString("mdHosts.preload.client")%>:</label>
                    <input type="file" disabled style="width:250; height:24" name="selectFileBtn" id="selectFileBtn" value="<%= mdHostsBean.getParam(request, "selectFileBtn") %>">
                </td>
            </tr>
            </table>
        </div>


     <table style="margin-top:15px; margin-bottom:15px">
        <tr>
          <td>
            <% MxButton.dumpButton(loadBtnTag, out); %>
          </td>
        </tr>
    </table>
    <strong><%= mdHostsBundle.getString("mdHosts.contents") %>:</strong><br>
    <textarea name="fileContents" id="fileContents" wrap="off" cols="72" rows="15"><% mdHostsBean.getFileContents(request, response, out); %></textarea>

    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
     </form>

    <%
        if (!mode.equals("edit"))
        {
    %>
    <script>giveFocus("fileName");</script>
    <%
        }
    %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>



