<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.controllers.VCRepositoryController"%>
<%@ page import="com.hp.mx.core.nodemanager.MxNode" %>
<%@ page import="com.hp.mx.core.controllers.MxNodeController" %>
<%@ page import="com.hp.mx.exceptions.MxException" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.portal.settings.VCRepositorySetup"%>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.security.DetermineTrustStatus" %>
<%@ page import="javax.swing.table.AbstractTableModel"%>
<%@ page import="javax.swing.tree.TreePath" %>

<jsp:useBean id="vcRepositoryBean" class="com.hp.mx.portal.settings.VCRepositorySetup" scope="session"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="pspSelectionModelRepositories" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="pspTableViewRepositories" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="pspControllerRepositories" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="vcrResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="pspResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="initialPSPInstallBean" class="com.hp.mx.portal.taskandjob.InitialPSPInstall.InitialPSPInstallBean" scope="session" />
<jsp:useBean id="pspSelectionModel" class="javax.swing.tree.DefaultTreeSelectionModel" scope="session" />

<%!
    public int tableInit = 0;
%>

<%
    MxBean.jspInit(request, response);

    // do we need to abort?
    if (pspControllerRepositories.checkUrlForControllerMessages(request, out)) return;

    String editTask = request.getParameter("edit");

    // this will only happen if we're re-entering this page after the user
    // hits the Last Update button
    String rowToUpdate = request.getParameter("rowToUpdate");
    int onEnterSelectedDeviceKey = 0;
    if (rowToUpdate != null && !rowToUpdate.equals(""))
    {
        onEnterSelectedDeviceKey = vcRepositoryBean.getSelectedDeviceKey();
        MxNode dev = null;
        try
        {
            dev = MxNodeController.getDefaultControllerNoEx().getNodeByKey(onEnterSelectedDeviceKey);
        }
        catch (MxException ex)
        {
            dev = null;
        }
        if (dev != null)
        {
            DetermineTrustStatus.makeTrustRequest(dev);
            vcRepositoryBean.forceRepositoryUpdate(onEnterSelectedDeviceKey);
        }
    }

    // first time this page is displayed, we can initialize VCRepositorySetup
    tableInit = vcRepositoryBean.initialize(loginBean);

    // setup the display of the Repository Setup table model
    if (pspControllerRepositories.isFirstTime())
    {
        // set up the resource files
        vcrResourceSettings.init(loginBean, "VCRepositorySetup");
        pspResourceSettings.init(loginBean, "InitialPSPInstall");

        pspSelectionModelRepositories.setSelectionMode(MxTableSelectionModel.SINGLE_SELECTION);
        pspTableViewRepositories.setId("ID_MY_PSP_SETUP_TABLE");
        pspTableViewRepositories.setOnSelectionChange("mySelectionChanged");
        pspTableViewRepositories.setUrlHandler(request.getRequestURI());
    }

    AbstractTableModel tableModel = vcRepositoryBean.getVCRDevsTableModel();
    pspControllerRepositories.setTableModelWithSorting(tableModel);
    pspControllerRepositories.setSelectionModel(pspSelectionModelRepositories);
    pspControllerRepositories.setTableView(pspTableViewRepositories);

    int numDevs     = vcRepositoryBean.getNumDevs();
    MxDateAndTime curTime = new MxDateAndTime(loginBean.getLocale(), loginBean.getTimeZone());
%>

<html>
    <head>
        <title><%= pspResourceSettings.getString("panel2.title") %></title>
        </title>
        <STYLE TYPE="text/css">
        <!--
            .indented{margin-left:12px;}
        -->
        </STYLE>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript'> MxPortalWorkspaceSetHelpTopic("useTools_psp_install");</script>
        <script language='javascript' type='text/javascript'>


            // tell the MxTable to "refresh in place"
            function loadPage()
            {
                // tell the table to update its content
                MxTableRefreshInPlace('ID_MY_PSP_SETUP_TABLE');

                // set up help
            }
            // resize the MxTable to be flush with the right browser edge
            function myResize()
            {
                var w = Math.max(0, MxBrowserGetBodyWidth(-NETSCAPE_SCROLLBAR_WIDTH, 0));
                if (w > 600)
                    w = 600;
                else
                    w = w-10;

                MxTableSetWidth('ID_MY_PSP_SETUP_TABLE', w);
            }

            var selectedRow = 0;
            var supportPack = "";
            var repositoryName = "";
            var treeType = <%=VCRepositoryController.SWTREE_VERSION_LEAVES +
                           VCRepositoryController.SWTREE_TAG_NODES+VCRepositoryController.SWTREE_WINDOWS_SUPPORT_PACKS_ONLY%>;

            //
            // the function called to change the name of the repos on this page
            //
            function setRepName(reposname)
            {
                repositoryName = reposname;
            }

            function setSelectedSupportPack(supportPackName)
            {
                supportPack = supportPackName;
                enableNextButton(true);
            }

            //
            // the function called to perform table selection change, including
            // retrieval of new repository catalog
            //
            function mySelectionChanged(szIdTable, iRow, bSelected)
            {
                // tell our Bean about the current Device selected
                selectedRow = iRow;
                var iframe = document.getElementById("action");
                getSelectedCatalog();
            }

            //
            // the function called to get the currently selected catalog
            //
            function getSelectedCatalog()
            {
                var iframe = document.getElementById("catalogtree");
                iframe.contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/taskandjob/UpdateSystemSoftware/LoadingCatalogWait.jsp");

                var iframe = document.getElementById("action");
                var url = "RetrieveCatalog.jsp?treeType="+treeType+"&calledFrom=InstallPSP";
                iframe.contentWindow.document.location.replace(url);
            }

            //
            // Update display with new catalog. This function is called
            // by the Javascript that retrieves the catalog
            //
            function drawNewCatalog(status)
            {
                var iframe = document.getElementById("catalogtree");
                iframe.contentWindow.document.location.replace("InitialPSPInstallCatalogFrame.jsp?treeHeight=105&treeType="+treeType);
            }

            //
            // user has selected an item from the tree
            //
            function treeSelectionChanged(count)
            {
                enableNextButton(true);
            }

            //
            // check if Next button should be enabled
            function checkRequiredFields()
            {
                var enableButton = true;
                // check that a Support Pack has been selected
                if (supportPack == "")
                {
                    enableButton = false;
                }

                // if all passes, then enable the Next button
                // else, disable it
                enableNextButton(enableButton);
            }

            function enableNextButton(enable)
            {
                if (enable)
                    ourButtonManager.enableButtonById('nextBtn');
                else
                    ourButtonManager.disableButtonById('nextBtn');
            }

            function nextButtonFunction()
            {
                var force = document.getElementById("forceDowngrade").checked;
                var reboot = document.getElementById("reboot").checked;
                var iframe = document.getElementById("action");

                document.supportPackForm.submit();
                setReloadOnError(false);

                return true;
            }

        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% pspTableViewRepositories.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body onLoad='loadPage()' onResize='myResize()'>

    <!-- hidden <iframe> for actions -->
    <iframe id='action' name='action' style='display:none; width:100%; height:100'
            scrolling='no' marginwidth='0' frameborder='1' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
    </iframe>

    <%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {

        String supportPackName = null;
        if (pspSelectionModel.getSelectionCount() > 0)
        {
            TreePath path = pspSelectionModel.getSelectionPath();
            supportPackName = vcRepositoryBean.getComponentNameFromTreePath(path);
        }

        initialPSPInstallBean.setSupportPackName(supportPackName);
        %>
        <jsp:setProperty name="initialPSPInstallBean" property="installSSH" value="<%=request.getParameter(\"installSSH\")%>"/>
        <jsp:setProperty name="initialPSPInstallBean" property="forceDowngrade" value="<%=request.getParameter(\"forceDowngrade\")%>"/>
        <jsp:setProperty name="initialPSPInstallBean" property="reboot" value="<%=request.getParameter(\"reboot\")%>"/>
        <%
        if (initialPSPInstallBean.isSupportPackInfoValid())
        {
            // this API returns false if it is unable to get the SshClientIfc
            if (initialPSPInstallBean.setArgumentValues() == false)
            {
                %>
                <script language='javascript' type='text/javascript'>
                    alert('<%=pspResourceSettings.getString("NO_SSH_CLIENT")%>');
                    loadWizardCurrentStep();
                </script>
                <%
            }
            else
            {
                %>
                <script>loadWizardNextStep();</script>
                <%
            }
        }
        else
        {
        %>
            <script>loadWizardCurrentStep();</script>
        <%
        }
    }
    else
    {
    %>
        <script>
            setWizardStepText('<%= pspResourceSettings.getString("panel2.title") %>');
        </script>

        <%
        if (tableInit == VCRepositorySetup.STATUS_NO_DEVICES)
        {
        %>
            <div class="errorTextBold">
        <%
            out.println(pspResourceSettings.getString("panel2.noDevices"));
        %>
            </div>
        <%
        }
        else
        {
        // use the repository set in the data model, or get the
        // default for this user, if the data model is empty
        int index = 0;
        Integer repos = initialPSPInstallBean.getRepository();
        if (editTask == null || (editTask != null && !editTask.equals("1")) ||
            MxNodeController.getDefaultControllerNoEx().getNodeByKey(repos) != null)
        {
            if (rowToUpdate != null && !rowToUpdate.equals(""))
            {
                    index = vcRepositoryBean.getIndexFromDeviceKey(onEnterSelectedDeviceKey);
            }
            else if (repos != null)
            {
                index = vcRepositoryBean.getIndexFromDeviceKey(repos.intValue());
            }
            else
            {
                index = vcRepositoryBean.getDefaultSelectRowIndex();
            }
            if (index < 0)
                index = 0;

            vcRepositoryBean.selectRepositoryDeviceRow(index);
            pspSelectionModelRepositories.setSelectedIndex(index, true);
            %>

            <!-- <table> to display 'tip' and total Devices displayed -->
            <%= vcrResourceSettings.getString("table.instructionsShort") %><br><br>
            <div class="indented">
            <table border='0' cellpadding='0' cellspacing='0' style='width:600'>
                <tr>
                    <td id='totalDevs' style='width:50%' align='left' nowrap>
                        <a href="javascript:location.replace(location.href+'&rowToUpdate='+selectedRow)" title="<%= vcrResourceSettings.getString("table.lastRefreshToolTip") %>"><%= vcrResourceSettings.getString("table.lastRefresh") %></a>
                        <%= curTime.getCurrentDateTimeStringSIMFormat() %>
                    </td>
                </tr>
            </table>

            <%
            pspTableViewRepositories.dumpWholeTable(out);
            %>

            <script>MxTableSetHeight('ID_MY_PSP_SETUP_TABLE', 105);</script>
            <script>MxTableSetWidth('ID_MY_PSP_SETUP_TABLE', 600);</script>
            </div>

            <br>
            <%= pspResourceSettings.getString("panel2.selectSupportPack") %><b>&nbsp;<span id="repname"></span></b><br><br>

            <!-- <iframe> for catalog tree -->
            <iframe id='catalogtree' name='catalogtree' style='width:100%; height:140'
                     scrolling='no' marginwidth='12' frameborder='0' src='<%=MxOptions.URL_BASE%>/taskandjob/UpdateSystemSoftware/LoadingCatalogWait.jsp'>
            </iframe>

            <script>
            getSelectedCatalog()
            </script>

            <form id="supportPackForm" name="supportPackForm" action="InitialPSPInstallCPP2.jsp" method="post">
            <input type="checkbox" name="installSSH" id="installSSH" value="true" <jsp:getProperty name="initialPSPInstallBean" property="installSSH"/>><%=pspResourceSettings.getString("panel2.installSSH")%><br>
            <br>
            <input type="checkbox" name="forceDowngrade" id="forceDowngrade" value="true" <jsp:getProperty name="initialPSPInstallBean" property="forceDowngrade"/>><%= pspResourceSettings.getString("panel2.forceDowngrade") %><br>
            <input type="checkbox" name="reboot" id="reboot" value="true" <jsp:getProperty name="initialPSPInstallBean" property="reboot" /> ><%= pspResourceSettings.getString("panel2.reboot") %><br>
            </form>
            <script>
                setFormSubmitName("supportPackForm")
            </script>
            <%
        }
        else
        {
        %>
            <div class="errorTextBold">
        <%
            out.println("\n\n" + pspResourceSettings.getString("panel2.savedRepositoryNotFound"));
        %>
            </div>
        <%
        }
        %>

        <script language='javascript' type='text/javascript'>
            displayTaskWizardButtons(); // display Previous/Next
            checkRequiredFields(); // check if the Next button should be enabled
        </script>
    <%
    }
    }
    %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>
</html>
