<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="timeFiltersBean" class="com.hp.mx.portal.taskandjob.MxTimeFilters" scope="session"/>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTimeFiltersInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    // generate timeStamp for this TimeFilters instance
    String                     timeStamp = timeFiltersBean.getNewTimeStamp();
    MxTimeFiltersInstance      inst      = timeFiltersBean.initializeNewInstance(loginBean, timeStamp);
    MxTaskAndJobResourceBundle rb        = inst.getRB();

    // look for the time filter to reselect
    String  filterName      = request.getParameter("name");
    boolean validFilterName = inst.isValidTimeFilter(filterName);

    //manage filters button
    MxDefaultTag manageBtnTag = new MxDefaultTag("manageTimeFilters", rb.getString("MANAGE_FILTERS_BUTTON"), "openManageFilters()");
    manageBtnTag.setAttr(MxTag.DISABLED, "true");
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%= MxOptions.URL_BASE %>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/taskandjob/js/timeFilters.js'></script>
        <script language='javascript' type='text/javascript'>
            var sameTimeZone                      = <%= inst.inSameTimeZone() %>;
            // the Time Filter selected
            var selectedTimeFilterName            = '';
            var selectedDisplayableTimeFilterName = '';
            var selectedTimeFilterIndex           = 0;
            // if "use timeFilter" is checked
            var usingTimeFilter                   = false;
            // Manage Time Filters HelpID
            var helpID                            = '<%= inst.getTimeFilterHelpID() %>';
            ///////////////////////////////
            // removeInstance()
            ///////////////////////////////
            function removeInstance()
            {
                try
                {
                    document.getElementById("action").contentWindow.document.location.replace("<%= MxOptions.URL_BASE %>/taskandjob/removeTimeFiltersInstance.jsp?timeStamp=<%= timeStamp %>");
                }
                catch (e)
                {
                }
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='taskWizardInit()' onUnload='removeInstance()'>

        <table border='0' cellspacing='0' cellpadding='0' style='width:100%'>
            <tr>
                <td nowrap>
<%
    if (validFilterName == true)
    {
%>
                    <input type='checkbox' checked id='useTimeFilter' onClick='useTimeFilter()'>&nbsp;
<%
    }
    else
    {
%>
                    <input type='checkbox' id='useTimeFilter' onClick='useTimeFilter()'>&nbsp;
<%
    }
%>
                    <font id='useTimeFilterText'><%= rb.getString("USE_TIME_FILTER") %>:</font>
                </td>
                <td rowspan='2' nowrap>&nbsp;&nbsp;</td>
                <td rowspan='2' valign='bottom' style='width:100%' nowrap>
                    <% MxButton.dumpButton(manageBtnTag, out); %>
                </td>
            </tr>
            <tr>
                <td id='filters' nowrap>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    <select style='width:165' id='timeFilters' name='timeFilters' size='1' disabled onChange='selectFilter(SELECT_PAGE, <%= timeStamp %>)'>
<%
    filterName = inst.dumpTimeFilterList(out, filterName, MxTimeFiltersInstance.SELECT_PAGE);
%>
                    </select>
                </td>
            </tr>
        </table>

        <table id='miniGrid' border='0' cellspacing='0' cellpadding='0' style='visibility:hidden'>
            <tr>
                <td id='grid1' align='right' style='width:140' nowrap>
<%
    inst.dumpTimeFilterMiniGrid(MxTimeFiltersInstance.SELECT_PAGE, out, true);
%>
                </td>
                <td>&nbsp;</td>
                <td id='timeFilterPopup'><a href='javascript:displayPopupTimeFilter("<%= filterName %>")'><%= rb.getString("VIEW_FILTER") %></a></td>
            </tr>
        </table>

        <iframe id='selectTimeFilter' name='selectTimeFilter' style='width:100%; height:0; position:relative; visibility:hidden'
                scrolling='no' marginwidth='0' frameborder='0' src='<%= MxOptions.URL_BASE %>/home/MxBlank.html'>
        </iframe>
        <iframe id='action' name='action' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

        <script language='javascript' type='text/javascript'>
            // now that we have dumped the Time Filter List, we have a selected Time Filter
            // Name.  Save this value for the getSelectedTimeFilter() method
            selectedTimeFilterName            = '<%= inst.getSelectedTimeFilterName(MxTimeFiltersInstance.SELECT_PAGE) %>';
            selectedDisplayableTimeFilterName = '<%= inst.getDisplayableTimeFilterName(MxTimeFiltersInstance.SELECT_PAGE) %>';
            selectedTimeFilterIndex           = '<%= inst.getSelectedTimeFilterIndex(MxTimeFiltersInstance.SELECT_PAGE) %>';
<%
    if (validFilterName == true)
    {
%>
        useTimeFilter();
        selectFilter(SELECT_PAGE, <%= timeStamp %>); // May need to pause on this --> start with onLoad?
<%
    }
%>
            // now we can populate the "manage time filter" <iframe> with the JSP page.
            var iframe = parent.document.getElementById('manageFilters');
            if (iframe != null)
            {
                iframe.contentWindow.document.location.replace('/mxportal/taskandjob/manageTimeFilters.jsp?timeStamp=<%= timeStamp %>');
            }
            // and call the "pageLoaded()" method in our parent - if it exists
            if (parent.pageLoaded != null)
            {
                parent.pageLoaded();
            }
        </script>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
