// this value is TRUE when the "Delete Task/Job" dialog is showing
var deleteOpen = false;

/////////////////////////////////////////////////
// displayEmptyTable()
/////////////////////////////////////////////////
function displayEmptyTable(display, thePage)
{
    if (thePage == null)
    {
        return;
    }

    var td = null;

    if (display == true)
    {
        td = thePage.document.getElementById('tip');
        if (td != null)
        {
            td.style.visibility = 'hidden';
        }

        td = thePage.document.getElementById('total');
        if (td != null)
        {
            td.style.visibility = 'hidden';
        }

        td = thePage.document.getElementById('listDiv');
        if (td != null)
        {
            td.style.display    = 'none';
            td.style.visibility = 'hidden';
        }

        td = thePage.document.getElementById('textDiv');
        if (td != null)
        {
            td.style.visibility = 'visible';
        }

        td = thePage.document.getElementById('buttonDiv');
        if (td != null)
        {
            td.style.visibility = 'hidden';
        }
    }
    else
    {
        td = thePage.document.getElementById('tip');
        if (td != null)
        {
            td.style.visibility = 'visible';
        }

        td = thePage.document.getElementById('total');
        if (td != null)
        {
            td.style.visibility = 'visible';
        }

        td = thePage.document.getElementById('listDiv');
        if (td != null)
        {
            td.style.visibility = 'visible';
            td.style.display    = 'block';
        }

        td = thePage.document.getElementById('textDiv');
        if (td != null)
        {
            td.style.visibility = 'hidden';
        }

        td = thePage.document.getElementById('buttonDiv');
        if (td != null)
        {
            td.style.visibility = 'visible';
        }
    }
}
/////////////////////////////////////////////////
// selectTask()
/////////////////////////////////////////////////
function selectTask(timeStamp, userSelect)
{
    // if 'userSelect' == true, then allow the selectTask.jsp file
    // to reset the Session Timeout value
    if (userSelect == null)
    {
        userSelect = false;
    }
    // don't allow refresh of current Task Results - a new
    // one is being selected
    var iframe = document.getElementById('taskResults');
    var url    = '/mxportal/taskandjob/selectTask.jsp?taskAndJobTimeStamp=' + timeStamp + '&userSelect=' + userSelect;

    if (iframe.contentWindow.autoRefresh != null)
    {
        iframe.contentWindow.refreshOk = false;
    }

    iframe = document.getElementById('selectTask');
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// editSelectedTask()
/////////////////////////////////////////////////
function editSelectedTask(timeStamp)
{
    // once a user selects to RunNow a task - disable the
    // "RunNow" button
    ourButtonManager.disableButtonById('btnEdit');

    // tell MxTaskAndJob what Task is selected
    var iframe = document.getElementById('editTask');
    var url    = '/mxportal/taskandjob/editTask.jsp?taskAndJobTimeStamp=' + timeStamp;
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// displayTaskResults()
/////////////////////////////////////////////////
function displayTaskResults(timeStamp)
{
    // tell MxTaskAndJob what Task Results to show
    var iframe = parent.document.getElementById('taskResults');
    var url = '/mxportal/taskandjob/taskResults.jsp?taskAndJobTimeStamp=' + timeStamp;
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// runSelectedTask()
/////////////////////////////////////////////////
function runSelectedTask(timeStamp)
{
    // once a user selects to RunNow a task - disable the
    // "RunNow" button
    ourButtonManager.disableButtonById('btnRun');

    var iframe = document.getElementById('runTask');
    var url    = '/mxportal/taskandjob/runTask.jsp?taskAndJobTimeStamp=' + timeStamp;
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// deleteSelectedTask()
/////////////////////////////////////////////////
function deleteSelectedTask(timeStamp)
{
    // before we ask the user if they'd like to delete the job, we'll disable the
    // "delete" button so the user doesn't click it again
    this.deleteOpen = true;
    ourButtonManager.disableButtonById('btnDelete');

    var iframe = document.getElementById('deleteTask');
    var url    = '/mxportal/taskandjob/confirmDeleteTask.jsp?taskAndJobTimeStamp=' + timeStamp;
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// selectJob()
/////////////////////////////////////////////////
function selectJob(jobFormat, timeStamp, userSelect)
{
    // if 'userSelect' == true, then allow the selectJob.jsp file
    // to reset the Session Timeout value
    if (userSelect == null)
    {
        userSelect = false;
    }

    var iframe = null;
    var url    = null;

    if (jobFormat == JOB_FORMAT_BASIC)
    {
        iframe = document.getElementById('taskInstanceResults');
    }
    else
    {
        iframe = document.getElementById('jobResults');
    }

    if ((iframe != null) && (iframe.contentWindow.autoRefresh != null))
    {
        iframe.contentWindow.refreshOk = false;
    }

    // tell MxTaskAndJob what TaskJob is selected
    iframe = document.getElementById('selectJob');
    url    = '/mxportal/taskandjob/selectJob.jsp?jobFormat=' + jobFormat + '&taskAndJobTimeStamp=' + timeStamp + '&userSelect=' + userSelect;
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// displayTaskJobResults()
/////////////////////////////////////////////////
function displayJobResults(jobFormat, timeStamp)
{
    var iframe = null;
    var url    = '/mxportal/taskandjob/';

    if (jobFormat == JOB_FORMAT_BASIC)
    {
        iframe  = parent.parent.document.getElementById('taskInstanceResults');
        url    += 'taskInstanceResults.jsp';
    }
    else
    {
        iframe  = parent.document.getElementById('jobResults');
        url    += 'fullJobResults.jsp';
    }

    iframe.contentWindow.document.location.replace(url + "?taskAndJobTimeStamp=" + timeStamp);
}
/////////////////////////////////////////////////
// stopSelectedJob()
/////////////////////////////////////////////////
function stopSelectedJob(jobFormat, timeStamp)
{
    // disable the "stop" button
    ourButtonManager.disableButtonById('btnStop');

    var iframe = document.getElementById('stopJob');
    var url    = '/mxportal/taskandjob/confirmStopJob.jsp?taskAndJobTimeStamp=' + timeStamp;
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// deleteSelectedJob()
/////////////////////////////////////////////////
function deleteSelectedJob(jobFormat, timeStamp)
{
    // before we ask the user if they'd like to delete the job, we'll disable the
    // "delete" button so the user doesn't click it again
    this.deleteOpen = true;
    ourButtonManager.disableButtonById('btnDelete');

    var iframe = document.getElementById('deleteJob');
    var url    = '/mxportal/taskandjob/confirmDeleteJob.jsp?jobFormat=' + jobFormat + '&taskAndJobTimeStamp=' + timeStamp;
    iframe.contentWindow.document.location.replace(url);
}
