var WIZARD_PREV_BUTTON     = 0;
var WIZARD_CANCEL_BUTTON   = 1;
var WIZARD_NEXT_BUTTON     = 2;
var WIZARD_SCHEDULE_BUTTON = 3;
var WIZARD_RUN_NOW_BUTTON  = 4;
// used by displayTaskWizardButtons() function
var NO_SUBTITLE_UPDATE     = 5;
var SUBTITLE_UPDATE        = 6;

/////////////////////////////////////////////////
// inline code to ensure the ButtonManager exists
/////////////////////////////////////////////////

if (typeof(MxBrowserIsGecko) == 'undefined') {
    document.writeln('<' + 'script src="/mxhtml/js/MxBrowser.js" language="JavaScript" type="text/javascript">');
    document.writeln('<' + '/script>');
}

if (typeof(ButtonManager) == 'undefined') {
    document.writeln('<' + 'script src="/mxhtml/js/buttonManager.js" language="JavaScript" type="text/javascript">');
    document.writeln('<' + '/script>');
}

if (typeof(globalComponentInit) == 'undefined') {
    document.writeln('<' + 'script src="/mxhtml/js/global.js" language="JavaScript" type="text/javascript">');
    document.writeln('<' + '/script>');
}

/////////////////////////////////////////////////
// taskWizardInit()
/////////////////////////////////////////////////
function taskWizardInit()
{
    this.document.onkeypress = m_OnKeyDown;
    this.document.onkeydown  = m_OnKeyDown;
}

/////////////////////////////////////////////////
// getButtonObject()
/////////////////////////////////////////////////
function getButtonObject(buttonIdent)
{
    var button = null;

    switch (buttonIdent)
    {
        case WIZARD_PREV_BUTTON:
             button = this.document.getElementById("prevBtn");
             break;
        case WIZARD_CANCEL_BUTTON:
             button = this.document.getElementById("cancelBtn");
             break;
        case WIZARD_NEXT_BUTTON:
             button = this.document.getElementById("nextBtn");
             break;
        case WIZARD_SCHEDULE_BUTTON:
             button = this.document.getElementById("ScheduleBtn");
             break;
        case WIZARD_RUN_NOW_BUTTON:
             button = this.document.getElementById("runNowBtn");
             break;
    }

    return button;
}

/////////////////////////////////////////////////
// enableTaskWizardButton() - used by VPM 1.0
/////////////////////////////////////////////////
function enableTaskWizardButton(btn, enable)
{
    var button = getButtonObject(btn);

    if (button == null)
    {
        return;
    }

    if (enable == true)
    {
        ourButtonManager.enableButton(button);
    }
    else
    {
        ourButtonManager.disableButton(button);
    }
}

/////////////////////////////////////////////////
// displayTaskWizardButton()
/////////////////////////////////////////////////
function displayTaskWizardButton(btn, display)
{
    var button = getButtonObject(btn);
    if (button == null)
    {
        return;
    }

    //for GUIDO buttons, want to hide the div that contains the button
    var wrapper = ourButtonManager.getWrapperReference(button);

    if (display == true)
    {
        wrapper.style.visibility = "visible";
    }
    else
    {
        wrapper.style.visibility = "hidden";
    }
}

/////////////////////////////////////////////////
// isFirstTime()
/////////////////////////////////////////////////
function isFirstTime()
{
    // find the Task Wizard parent page
    var parentDoc = findTaskWizardParent(this);
    var myFirstTime = parentDoc.firstTime;
    parentDoc.firstTime = false;
    return myFirstTime;
}

/////////////////////////////////////////////////
// displayStepTextTable()
/////////////////////////////////////////////////
function displayStepTextTable()
{
    document.writeln("<table border='0' cellspacing='0' cellpadding='0'>");
    document.writeln("<tr>");
    document.writeln("<td nowrap>");
    document.writeln("<font id='wizStep' class='mx-subheader-nosep'>");
    document.writeln("</font>");
    document.writeln("</td>");
    document.writeln("</tr>");
    document.writeln("</table>");
}

/////////////////////////////////
// UrlParameter()
/////////////////////////////////
function UrlParameter(theName, theValue)
{
    this.name     = theName;
    this.value    = theValue;
    this.toString = function(){return this.name + "=" + this.value}
}

/////////////////////////////////////////////////
// storeWizardParameters()
/////////////////////////////////////////////////
function storeWizardParameters(searchString)
{
    // add the taskWizard parameter to the list
    var wizardParam = new UrlParameter("taskWizard", "1");

    taskWizardParams[parameterIndex++] = wizardParam;

    var nameValuePairs = new Array();
    var j              = 0;

    if ((searchString != null) && (searchString != ""))
    {
        var paramArray = searchString.split("&");

        for (var i = 0; i < paramArray.length; i++)
        {
            var nameValuePairArray = paramArray[i].split("=");

            if (nameValuePairArray[0] != "err")
            {
                var thisParam       = new UrlParameter(nameValuePairArray[0], encodeURIComponent(nameValuePairArray[1]));
                nameValuePairs[j++] = thisParam;
            }
        }
    }

    // loop through the parameters passed to the Run Tool Page
    for (i = 0; i < nameValuePairs.length; i++)
    {
        taskWizardParams[parameterIndex++] = nameValuePairs[i];
    }
}

/////////////////////////////////////////////////
// findTaskWizardParent()
/////////////////////////////////////////////////
function findTaskWizardParent(parentDoc)
{
    // if we find this constant, this is the parent page
    if (parentDoc.PARENT_PAGE != null)
    {
        return parentDoc;
    }

    // look one level up
    return findTaskWizardParent(parentDoc.parent);
}

/////////////////////////////////////////////////
// getLastWizardButtonClicked()
/////////////////////////////////////////////////
function getLastWizardButtonClicked()
{
    var parentDoc = findTaskWizardParent(this);
    return parentDoc.lastButtonClicked;
}

/////////////////////////////////////////////////
// getNumWizardParameters()
/////////////////////////////////////////////////
function getNumWizardParameters()
{
    // find the Task Wizard parent page
    var parentDoc = findTaskWizardParent(this);
    // call the function that actually saves the parameter
    return parentDoc.taskWizardParams.length;
}

/////////////////////////////////////////////////
// saveWizardParameter()
/////////////////////////////////////////////////
function saveWizardParameter(name, value)
{
    // find the Task Wizard parent page
    var parentDoc = findTaskWizardParent(this);
    // call the function that actually saves the parameter
    parentDoc.saveWizardParam(name, value);
}

/////////////////////////////////////////////////
// saveWizardParam()
/////////////////////////////////////////////////
function saveWizardParam(name, value)
{
    if ((name == null) || (name == ""))
    {
        return null;
    }

    // attempt to find this parameter "name" - if
    // found, update the "value"
    //
    // else add a new UrlParameter
    for (var i = 0; i < taskWizardParams.length; i++)
    {
        if (taskWizardParams[i].name == name)
        {
            taskWizardParams[i].value = value;
            return;
        }
    }

    // add the taskWizard parameter to the list
    var wizardParam = new UrlParameter(name, value);

    taskWizardParams[parameterIndex++] = wizardParam;
}

/////////////////////////////////////////////////
// getWizardParameter(name)
/////////////////////////////////////////////////
function getWizardParameter(name)
{
    // find the Task Wizard parent page
    var parentDoc = findTaskWizardParent(this);
    // call the function that actually saves the parameter
    return parentDoc.getWizardParam(name);
}

/////////////////////////////////////////////////
// getWizardParam(name)
/////////////////////////////////////////////////
function getWizardParam(name)
{
    if ((name == null) || (name == ""))
    {
        return null;
    }

    for (var i = 0; i < taskWizardParams.length; i++)
    {
        if (taskWizardParams[i].name == name)
        {
            return taskWizardParams[i].value;
        }
    }

    return null;
}

/////////////////////////////////////////////////
// removeWizardParameter(name)
/////////////////////////////////////////////////
function removeWizardParameter(name)
{
    // find the Task Wizard parent page
    var parentDoc = findTaskWizardParent(this);
    // call the function that actually saves the parameter
    parentDoc.removeWizardParam(name);
}

/////////////////////////////////////////////////
// removeWizardParam(name)
/////////////////////////////////////////////////
function removeWizardParam(nameToRemove)
{
    if ((nameToRemove == null) || (nameToRemove == ""))
    {
        return null;
    }

    var newParams = new Array();

    var i = 0;
    var j = 0;

    for ( ; i < taskWizardParams.length; )
    {
        if (taskWizardParams[i].name != nameToRemove)
        {
            newParams[j] = taskWizardParams[i];
            i++;
            j++;
        }
        else
        {
            i++;
            parameterIndex--;
        }
    }

    taskWizardParams = newParams;
}

/////////////////////////////////////////////////
// setWizardStepText()
/////////////////////////////////////////////////
function setWizardStepText(stepText)
{
    var parentDoc = findTaskWizardParent(this);
    var wizText   = parentDoc.document.getElementById("wizStep");

    wizText.innerHTML = parentDoc.step + "&nbsp;" + parentDoc.currTaskDisplayStep + ":&nbsp;" + stepText;
}

/////////////////////////////////////////////////
// checkCustomNextFunction()
/////////////////////////////////////////////////
function checkCustomNextFunction(controlID)
{
    //assume passed 'this', controlID is outer div for button, get button:
    var btnObj = ourButtonManager.getButtonChild(controlID);

    var returnValue = true;
    var parentDoc   = findTaskWizardParent(this);

    if (btnObj.getAttribute('id') == 'nextBtn')
    {
        // save that the "Next" button was clicked
        parentDoc.lastButtonClicked = WIZARD_NEXT_BUTTON;

        if (this.nextButtonFunction != null)
        {
            // call the defined function
            returnValue = this.nextButtonFunction();
        }
    }

    return returnValue;
}

/////////////////////////////////////////////////
// checkCustomScheduleFunction()
/////////////////////////////////////////////////
function checkCustomScheduleFunction(controlID)
{
    //assume passed 'this', controlID is outer div for button, get button:
    var btnObj = ourButtonManager.getButtonChild(controlID);

    var returnValue = true;
    var parentDoc   = findTaskWizardParent(this);

    if (btnObj.getAttribute('id') == 'scheduleBtn')
    {
        // save that the "Next" button was clicked
        parentDoc.lastButtonClicked = WIZARD_SCHEDULE_BUTTON;

        if (this.scheduleButtonFunction != null)
        {
            // call the defined function
            returnValue = this.scheduleButtonFunction();
        }
    }

    return returnValue;
}

/////////////////////////////////////////////////
// checkCustomPrevFunction()
/////////////////////////////////////////////////
function checkCustomPrevFunction(controlID)
{
    //assume passed 'this', controlID is outer div for button, get button:
    var btnObj = ourButtonManager.getButtonChild(controlID);

    var returnValue = true;
    var parentDoc   = findTaskWizardParent(this);

    if (btnObj.getAttribute('id') == 'prevBtn')
    {
        // save that the "Next" button was clicked
        parentDoc.lastButtonClicked = WIZARD_PREV_BUTTON;

        if (this.prevButtonFunction != null)
        {
            // call the defined function
            returnValue = this.prevButtonFunction();
        }
    }

    return returnValue;
}

/////////////////////////////////////////////////
// checkCustomRunNowFunction()
/////////////////////////////////////////////////
function checkCustomRunNowFunction(controlID)
{
    //assume passed 'this', controlID is outer div for button, get button:
    var btnObj = ourButtonManager.getButtonChild(controlID);

    var returnValue = true;
    var parentDoc   = findTaskWizardParent(this);

    if (btnObj.getAttribute('id') == 'runNowBtn')
    {
        // save that the "Next" button was clicked
        parentDoc.lastButtonClicked = WIZARD_RUN_NOW_BUTTON;

        if (this.runNowButtonFunction != null)
        {
            // call the defined function
            returnValue = this.runNowButtonFunction();
        }
    }

    return returnValue;
}

/////////////////////////////////////////////////
// updateWorkspaceSubTitle()
/////////////////////////////////////////////////
function updateWorkspaceSubTitle()
{
    var parentDoc = findTaskWizardParent(this);

    // if our current page is the first parameter page, then change the text to "verify target(s)"
    if (parentDoc.currTaskWizardStep == 1)
    {
        parentDoc.MxPortalWorkspaceSetSubtitleHtml(parentDoc.toolDescription);
    }
    else
    {
        // if we have moved off of the first step, then change the tool description to reflect the
        // currenly selected nodes
        //
        // get the selectedNodes string from the Target Selection Page
        //
        // first look for the target selection page in the "tsp" iframe - this is
        // for the case where tool do not show the target selection page
        var nodes = parentDoc.selectedNodes;

        if (nodes != null)
        {
            var html = null;

            if (nodes.indexOf(",") != -1)
            {
                html = parentDoc.targets + ":&nbsp;" + nodes;
            }
            else
            {
                html = parentDoc.target + ":&nbsp;" + nodes;
            }

            parentDoc.MxPortalWorkspaceSetSubtitleHtml(html);
        }
    }
}
/////////////////////////////////////////////////
// checkForTSPFunction()
/////////////////////////////////////////////////
function checkForTSPFunction(controlID)
{
    // assume passed 'this', controlID is outer div for button, get button:
    var btnObj = ourButtonManager.getButtonChild(controlID);

    var returnValue = true;

    if (this.customTSPFunction != null)
    {
        // call the defined function
        returnValue = this.customTSPFunction();
    }

    return returnValue;
}
/////////////////////////////////////////////////
// nextWizardPage()
/////////////////////////////////////////////////
function nextWizardPage(controlID)
{
    //assume passed 'this', controlID is outer div for button, get button:
    var btnObj = ourButtonManager.getButtonChild(controlID);

    // disable "Next" button so it is not clicked again
    ourButtonManager.disableButton(btnObj);

    var parentDoc = findTaskWizardParent(this);

    // if (parentControl.id == nextBtn) call nextButtonFunction()
    // if (parentControl.id == scheduleBtn) call scheduleButtonFunction
    //
    // if either of these function are not defined, then don't bother with them
    // if the return value of the function is zero, then reload the current page
    // otherwise, continue as normal with the default functionality
    var url   = null;
    var error = false;

    // if a "submitFormName" value has been set, submit this form instead
    // of performing this default functionality
    if (parentDoc.submitFormName != "")
    {
        var submit = document.getElementById(parentDoc.submitFormName);
        if (submit != null)
        {
            if (checkCustomNextFunction(controlID) == false)
            {
            }
            else if (checkCustomScheduleFunction(controlID) == false)
            {
            }
            else
            {
                submit.submit();
                parentDoc.scrollTop();
            }
        }
        // re-enable the "Next" button
        ourButtonManager.enableButton(btnObj);
        return;
    }

    // check for TSP custom function (to forcibly remove invalid targets)
    if (checkForTSPFunction(controlID) == false)
    {
        ourButtonManager.enableButton(btnObj);
        return;
    }
    // check for Next Button - if "false" returned, reload current page
    else if (checkCustomNextFunction(controlID) == false)
    {
        // reload page
        url   = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams() + "&err=1";
        error = true;
    }
    else if (checkCustomScheduleFunction(controlID) == false)
    // check for Schedule Button - if "false" returned, reload current page
    {
        // reload page
        url   = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams() + "&err=1";
        error = true;
    }
    else
    {
        // increment the wizard step/page number
        parentDoc.currTaskWizardStep++;
        parentDoc.currTaskDisplayStep++;

        // get the url page to load next and add params
        url = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams();
    }

    // if error == false, then we're continuing as normal
    // if error == true, then a custom button function returned false, if our
    // parent.reloadOnError = true, then we will reload the page as designed -
    // otherwise, we'll simply do nothing
    if ((error == false) || ((error == true) && (parentDoc.reloadOnError == true)))
    {
        updateWorkspaceSubTitle();
        location.replace(url);
        parentDoc.scrollTop();
    }
    else
    // else re-enable the "Next" button
    {
        ourButtonManager.enableButton(btnObj);
    }
}

/////////////////////////////////////////////////
// loadWizardNextStep()
/////////////////////////////////////////////////
function loadWizardNextStep(stepNumber)
{
    var parentDoc = findTaskWizardParent(this);
    var url       = "";

    // If the lastButtonClicked == "NEXT" or "SCHEDULE",
    // perform next step
    // If the lastButtonClicked == "RUN NOW"
    // perform run now step
    if (parentDoc.lastButtonClicked == WIZARD_RUN_NOW_BUTTON)
    {
        // save the parameters from the Default Parameters page
        // before sending to Task Controller - this may not be on the
        // Default Parameter Page, but there is no harm in calling this
        saveTaskDefaultParameters();

        // save the name of the current Task Wizard page.  This page will
        // be reloaded in case of an error
        saveWizardParameter("taskWizardPage", parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1]);

        url = parentDoc.PARENT_BASE_DIR + "/taskandjob/executeTask.jsp" + parentDoc.buildWizardParams();
    }
    else // if was NEXT or SCHEUDLE
    {
        // increment the wizard step/page number
        parentDoc.currTaskWizardStep++;

        if (stepNumber == null)
        {
            parentDoc.currTaskDisplayStep++;
        }
        else
        {
            parentDoc.currTaskDisplayStep = stepNumber;
        }

        // get the url page to load next and add params
        url = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams();

        // clear out "submitFormName" - only do this for "Next".  If user is "loading Current", then
        // keep the SubmitFormName intacked.  If the user is "doWizardRunNow",
        parentDoc.submitFormName = "";
    }

    updateWorkspaceSubTitle();
    location.replace(url);
}

/////////////////////////////////////////////////
// jumpToWizardStep()
/////////////////////////////////////////////////
function jumpToWizardStep(newStep, newStepNumber)
{
    // ensure that newStep is between '1' and 'parent.maxNumTaskPages'.
    if (newStep != null)
    {
        // get absolute value of newStep
        newStep = Math.abs(newStep);

        if ((newStep < 1) || (newStep > parent.maxNumTaskPages))
        {
            return false;
        }
        else
        {
            var parentDoc = findTaskWizardParent(this);

            parentDoc.currTaskWizardStep  = newStep;

            if (newStepNumber == null)
            {
                parentDoc.currTaskDisplayStep = newStep;
            }
            else
            {
                parentDoc.currTaskDisplayStep = newStepNumber;
            }

            // get the url page to load and add params
            var url = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams();

            updateWorkspaceSubTitle();
            location.replace(url);
        }
    }

    return true;
}

/////////////////////////////////////////////////
// getWizardPageNumber()
/////////////////////////////////////////////////
function getWizardPageNumber()
{
    var parentDoc = findTaskWizardParent(this);

    return parentDoc.currTaskWizardStep;
}

/////////////////////////////////////////////////
// getWizardStepNumber()
/////////////////////////////////////////////////
function getWizardStepNumber()
{
    var parentDoc = findTaskWizardParent(this);

    return parentDoc.currTaskDisplayStep;
}

/////////////////////////////////////////////////
// loadWizardPrevStep()
/////////////////////////////////////////////////
function loadWizardPrevStep(stepNumber)
{
    var parentDoc = findTaskWizardParent(this);
    var url       = "";

    // decrement the wizard step/page number
    parentDoc.currTaskWizardStep--;

    if (stepNumber == null)
    {
        parentDoc.currTaskDisplayStep--;
    }
    else
    {
        parentDoc.currTaskDisplayStep = stepNumber;
    }

    // get the url page to load next and add params
    url = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams() + "&prev=1";

    updateWorkspaceSubTitle();
    location.replace(url);
}

/////////////////////////////////////////////////
// prevWizardPage()
/////////////////////////////////////////////////
function prevWizardPage(controlID)
{
    //assume passed 'this', controlID is outer div for button, get button:
    var btnObj = ourButtonManager.getButtonChild(controlID);

    // disable "Prev" button so it is not clicked again
    ourButtonManager.disableButton(btnObj);

    var parentDoc = findTaskWizardParent(this);

    // if (parentControl.id == prevBtn) call prevButtonFunction()
    var url   = null;
    var error = false;

    // check for Prev Button - if "false" returned, reload current page
    if (checkCustomPrevFunction(controlID) == false)
    {
        // reload page
        url   = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams() + "&err=1";
        error = true;
    }
    else
    {
        // decrement the wizard step/page number
        parentDoc.currTaskWizardStep--;
        parentDoc.currTaskDisplayStep--;

        // get the url page to load next and add params
        url = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams() + "&prev=1";
    }

    // if error == false, then we're continuing as normal
    // if error == true, then a custom button function returned false, if our
    // parent.reloadOnError = true, then we will reload the page as designed -
    // otherwise, we'll simply do nothing
    if ((error == false) || ((error == true) && (parentDoc.reloadOnError == true)))
    {
        updateWorkspaceSubTitle();
        location.replace(url);
        parentDoc.scrollTop();
    }
    else
    // else re-enable the "Prev" button
    {
        ourButtonManager.enableButton(btnObj);
    }
}
/////////////////////////////////////////////////
// runNow()
/////////////////////////////////////////////////
function runNow(controlID)
{
    // assume passed 'this', controlID is outer div for button, get button:
    var btnObj = ourButtonManager.getButtonChild(controlID);

    // disable the "Run Now" button
    ourButtonManager.disableButton(btnObj);

    var parentDoc = findTaskWizardParent(this);

    var url   = null;
    var error = false;

    // if a "submitFormName" value has been set, submit this form instead
    // of performing this default functionality
    if (parentDoc.submitFormName != "")
    {
        var submit = document.getElementById(parentDoc.submitFormName);
        if (submit != null)
        {
            if (checkCustomRunNowFunction(controlID) == false)
            {
            }
            else
            {
                submit.submit();
            }
        }
        return;
    }

    // check for TSP custom function (to forcibly remove invalid targets)
    if (checkForTSPFunction(controlID) == false)
    {
        ourButtonManager.enableButton(btnObj);
        return;
    }
    // check for "runNow" Button - if "false" returned, reload current page
    else if (checkCustomRunNowFunction(controlID) == false)
    {
        // reload page
        url   = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams() + "&err=1";
        error = true;
    }
    else
    {
        // save the parameters from the Default Parameters page
        // before sending to Task Controller - this may not be on the
        // Default Parameter Page, but there is no harm in calling this
        saveTaskDefaultParameters();
        // save the name of the current Task Wizard page.  This page will
        // be reloaded in case of an error
        saveWizardParameter("taskWizardPage", parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1]);

        url = parentDoc.PARENT_BASE_DIR + "/taskandjob/executeTask.jsp" + parentDoc.buildWizardParams();
    }

    // if error == false, then we're continuing as normal
    // if error == true, then a custom button function returned false, if our
    // parent.reloadOnError = true, then we will reload the page as designed -
    // otherwise, we'll simply do nothing
    if ((error == false) || ((error == true) && (parentDoc.reloadOnError == true)))
    {
        location.replace(url);
    }
    else
    // else re-enable the "Run Now" button
    {
        ourButtonManager.enableButton(btnObj);
    }
}

/////////////////////////////////////////////////
// setReloadOnError()
/////////////////////////////////////////////////
function setReloadOnError(value)
{
    var parentDoc = findTaskWizardParent(this);
    parentDoc.reloadOnError = value;
}

/////////////////////////////////////////////////
// setFormSubmitName()
/////////////////////////////////////////////////
function setFormSubmitName(formName)
{
    var parentDoc = findTaskWizardParent(this);
    parentDoc.submitFormName = formName;
}

/////////////////////////////////////////////////
// loadWizardCurrentStep()
/////////////////////////////////////////////////
function loadWizardCurrentStep()
{
    var parentDoc = findTaskWizardParent(this);

    // get the url page to load next and add params
    var url = parentDoc.taskWizardPages[parentDoc.currTaskWizardStep - 1] + parentDoc.buildWizardParams();

    location.replace(url);
}

/////////////////////////////////////////////////
// ensureButtonManagerExists
/////////////////////////////////////////////////
function ensureButtonManagerExists()
{
    MxBrowserCssAdd('/mxhtml/css/default.css', null);
    MxBrowserCssAdd('/mxhtml/css/blue_theme.css', null);
    MxBrowserCssAdd('/mxhtml/css/print.css', 'print');
    MxBrowserCssAdd('/mxhtml/css/aural.css', 'aural');

    globalManagerCreate();
}

/////////////////////////////////////////////////
// displayTaskWizardButtons()
/////////////////////////////////////////////////
function displayTaskWizardButtons(updateSubtitle)
{
    ensureButtonManagerExists();

    var parentDoc = findTaskWizardParent(this);

    if (updateSubtitle == null)
    {
        updateSubtitle = SUBTITLE_UPDATE;
    }

    // HERE - need to add the "cancel" button

    // CANCEL take user back to Wizard first (#1) step
    // the default buttons that we show are:
    //   <PREV  NEXT>  CANCEL
    //
    // if this is the last parameter page, then we display:
    //   <PREV  CANCEL  SCHEDULE  RUN NOW
    //
    document.write("<table style='padding-top:5px' border='0' cellpadding='0' cellspacing='0' align='right'>");
    document.write("<tr>");

    // if our current wizard step is 1, then this is the first task wizard
    // page shown.  we should not display a "prev" button under this condition
    if (parentDoc.currTaskWizardStep != 1)
    {
        document.write("<td>");
        document.write(ourButtonManager.makeMxButton('prevBtn', parentDoc.prevButton, 'prevWizardPage(this)'));
        document.write("</td>");
        ourButtonManager.initButtonById('prevBtn');
   }

    // call displayCustomButtons() if the function is defined
    if (this.displayCustomButtons != null)
    {
        this.displayCustomButtons();
    }

    // if this is the last (Schedule Page ONLY) page, then we'll display the "Done" button
    if (parentDoc.currTaskWizardStep == parentDoc.taskWizardPages.length)
    {
        // DONE
        if (parentDoc.isToolScheduleable == true)
        {
            document.write("<td>");
            document.write(ourButtonManager.makeMxButton('doneBtn', parentDoc.doneButton, 'saveTasks(this)'));
            document.write("</td>");
            ourButtonManager.initButtonById('doneBtn');
        }
        else
        {
            document.write("<td>");
            document.write(ourButtonManager.makeMxButton('runNowBtn', parentDoc.runNowButton, 'runNow(this)'));
            document.write("</td>");
            ourButtonManager.initButtonById('runNowBtn');
        }
    }
    // if this is the last page before the schedule page, then we'll display the "Next" button as "Schedule" and "Run Now"
    //   TOOL MUST also be schedulable
    else if ((parentDoc.currTaskWizardStep == (parentDoc.taskWizardPages.length - 1)) && (parentDoc.isToolScheduleable == true))
    {
        // SCHEDULE & RUN NOW
        document.write("<td>");
        document.write(ourButtonManager.makeMxButton('scheduleBtn', parentDoc.scheduleButton, 'nextWizardPage(this)'));
        document.write("</td>");
        ourButtonManager.initButtonById('scheduleBtn');
        // if we are editing this Task, then the user cannot "Run Now" - they must visit the Schedule Page
        if (parentDoc.editMode == false)
        {
            document.write("<td>");
            document.write(ourButtonManager.makeMxButton('runNowBtn', parentDoc.runNowButton, 'runNow(this)'));
            document.write("</td>");
            ourButtonManager.initButtonById('runNowBtn');
        }
    }
    else
    {
        // NEXT
        document.write("<td>");
        document.write(ourButtonManager.makeMxButton('nextBtn', parentDoc.nextButton, 'nextWizardPage(this)'));
        document.write("</td>");
        ourButtonManager.initButtonById('nextBtn');
    }

    document.write("</tr>");
    document.write("</table>");

    // load the -- updateWorkspaceSubTitle();
    if (updateSubtitle == SUBTITLE_UPDATE)
    {
        var iframe = parentDoc.document.getElementById("action");
        var url    = parentDoc.PARENT_BASE_DIR + "/taskandjob/updateSubtitle.jsp?timeStamp=" + getWizardParameter('timeStamp');
        iframe.contentWindow.document.location.replace(url);
    }
}

/////////////////////////////////////////////////
// saveTaskDefaultParameters()
/////////////////////////////////////////////////
function saveTaskDefaultParameters()
{
    // save all parameters from the Default Parameter Page
    var i = 0;

    var paramElement = 'PARAM_' + i;
    var param        = document.getElementById(paramElement);

    while (param != null)
    {
        saveWizardParameter(paramElement, encodeURIComponent(param.value));

        paramElement = 'PARAM_' + ++i;
        param        = document.getElementById(paramElement);
    }

    // save an X-Window variable if present
    paramElement = 'XWindowLoc';
    param        = document.getElementById(paramElement);

    if (param != null)
    {
        saveWizardParameter(paramElement, encodeURIComponent(param.value));
    }
}

/////////////////////////////////////////////////
// saveIntervalTimeDays()
/////////////////////////////////////////////////
function saveIntervalTimeDays(displayError)
{
    var e = document.getElementById('timeDays');
    if ((e.value == '') && (displayError == true))
    {
        alert(errorTime);
        return false;
    }
    saveWizardParameter('intervalTime', e.value);

    // if we find AM/PM radio buttons, save that value
    e = document.getElementById('ampmDays');
    if (e != null)
    {
        saveWizardParameter("intervalAM", e.value);
    }
}

/////////////////////////////////////////////////
// saveIntervalTimeWeeks()
/////////////////////////////////////////////////
function saveIntervalTimeWeeks(displayError)
{
    var e = document.getElementById('DOW');
    saveWizardParameter('intervalDOW', e.value);

    e = document.getElementById('timeWeeks');
    if ((e.value == '') && (displayError == true))
    {
        alert(errorTime);
        return false;
    }
    saveWizardParameter('intervalTime', e.value);

    // if we find AM/PM radio buttons, save that value
    e = document.getElementById('ampmWeeks');
    if (e != null)
    {
        saveWizardParameter("intervalAM", e.value);
    }
}

/////////////////////////////////////////////////
// saveIntervalTimeMonths()
/////////////////////////////////////////////////
function saveIntervalTimeMonths(displayError)
{
    var e = document.getElementById('DOM');
    if (((e.value == '') || (isValidWholeNumber(e.value) == false) || (e.value <= 0) || (e.value > 31)) &&
         (displayError == true))
    {
        alert(errorDOM);
        return false;
    }
    saveWizardParameter('intervalDOM', e.value);

    e = document.getElementById('timeMonths');
    if ((e.value == '') && (displayError == true))
    {
        alert(errorTime);
        return false;
    }
    saveWizardParameter('intervalTime', e.value);

    // if we find AM/PM radio buttons, save that value
    e = document.getElementById('ampmMonths');
    if (e != null)
    {
        saveWizardParameter("intervalAM", e.value);
    }
}

/////////////////////////////////////////////////
// isValidWholeNumber()
/////////////////////////////////////////////////
function isValidWholeNumber(number)
{
    if (number == null)
    {
        return false;
    }

    for (var i = 0; i < number.length; i++)
    {
        var num = number.charAt(i);

        if (isNaN(num) == true)
        {
            return false;
        }
    }

    return true;
}

/////////////////////////////////////////////////
// savePeriodicSchedule()
/////////////////////////////////////////////////
function savePeriodicSchedule(displayError)
{
    var e = null;

    // all get an "Interval" value ("5" mins, "10" hours, etc)
    e = document.getElementById("interval");
    if (((e.value == '') || (isValidWholeNumber(e.value) == false) || (e.value <= 0)) && (displayError == true))
    {
        alert(errorInterval);
        return false;
    }
    saveWizardParameter("interval", e.value);

    // all get an "IntervalType" value ("minutes", "hours", etc)
    e = document.getElementById("intervalType");
    var intervalType = e.value;

    saveWizardParameter("intervalType", intervalType);

    switch (intervalType)
    {
        case '0':  // minutes
            // intervalType && interval
            break;
        case '1':  // hours
            // intervalType && interval
            break;
        case '2':  // days
            // intervalType && interval && TIME
            // DAYS - runs at TIME
            if (saveIntervalTimeDays(displayError) == false)
            {
                return false;
            }
            break;
        case '3':  // weeks
            // intervalType && interval && DOW && TIME
            // WEEKS - runs on DOW (Day of Week) at TIME
            if (saveIntervalTimeWeeks(displayError) == false)
            {
                return false;
            }
            break;
        case '4':  // months
            // intervalType && interval & DOM & TIME
            // MONTHS - runs on DOM (Date of Month) at TIME
            if (saveIntervalTimeMonths(displayError) == false)
            {
                return false;
            }
            break;
    }

    // all get a "Run Until" value (DATE  TIME)
    e = document.getElementById("runUntil");
    // only save the values if the checkbox is checked
    if (e.checked == true)
    {
        e = document.getElementById("runUntilDate");
        if ((e.value == '') && (displayError == true))
        {
            alert(errorDate);
            return false;
        }
        saveWizardParameter("runUntilDate", e.value);

        e = document.getElementById("runUntilTime");
        if ((e.value == '') && (displayError == true))
        {
            alert(errorTime);
            return false;
        }
        saveWizardParameter("runUntilTime", e.value);

        // if we find AM/PM radio buttons, save that value
        e = document.getElementById('ampmRunUntil');
        if (e != null)
        {
            saveWizardParameter("runUntilAM", e.value);
        }
    }
    else
    {
        removeWizardParameter("runUntilDate");
        removeWizardParameter("runUntilTime");
        removeWizardParameter("runUntilAM");
    }

    // all get a "Run a Maximum of X Times" value
    e = document.getElementById("maxRun");
    if (e.checked == true)
    {
        e = document.getElementById("maxRunValue");
        if (((e.value == '') || (isValidWholeNumber(e.value) == false) || (e.value <= 0)) && (displayError == true))
        {
            alert(errorMaxRun);
            return false;
        }
        saveWizardParameter("maxRuns", e.value);
    }
    else
    {
        removeWizardParameter("maxRuns");
    }
}

/////////////////////////////////////////////////
// saveOnceSchedule()
/////////////////////////////////////////////////
function saveOnceSchedule(displayError)
{
    saveWizardParameter("intervalType", "5"); // 5 == INTERVAL_RUNATTIME

    var e = document.getElementById('runOnceDate');
    if ((e.value == '') && (displayError == true))
    {
        alert(errorDate);
        return false;
    }
    saveWizardParameter('intervalDate', e.value);

    e = document.getElementById('runOnceTime');
    if ((e.value == '') && (displayError == true))
    {
        alert(errorTime);
        return false;
    }
    saveWizardParameter('intervalTime', e.value);

    // if we find AM/PM radio buttons, save that value
    e = document.getElementById('ampmRunOnce');
    if (e != null)
    {
        saveWizardParameter("intervalAM", e.value);
    }
}

/////////////////////////////////////////////////
// saveScheduleType()
/////////////////////////////////////////////////
function saveScheduleType(displayError)
{
    // determine the schedule type and save that parameter
    var param = document.getElementById('runPeriodicallyBtn');

    if ((param != null) && (param.checked == true))
    {
        saveWizardParameter("scheduleType", "periodical");
        return savePeriodicSchedule(displayError);
    }

    param = document.getElementById('runOnceBtn');

    if ((param != null) && (param.checked == true))
    {
        saveWizardParameter("scheduleType", "once");
        return saveOnceSchedule(displayError);
    }

    // there is a change that the "meetCriteriaBtn" and
    // "notMeetCriteria" button are not present on this
    // page.  Check for NULL for these controls
    param = document.getElementById('meetCriteriaBtn');

    if ((param != null) && (param.checked == true))
    {
        saveWizardParameter("scheduleType", "meetCriteria");
        return;
    }

    param = document.getElementById('notMeetCriteriaBtn');

    if ((param != null) && (param.checked == true))
    {
        saveWizardParameter("scheduleType", "notMeetCriteria");
        return;
    }

    param = document.getElementById('manualBtn');

    if ((param != null) && (param.checked == true))
    {
        saveWizardParameter("scheduleType", "manual");
        return;
    }
}

/////////////////////////////////////////////////
// saveTaskName()
/////////////////////////////////////////////////
function saveTaskName(displayError)
{
    var param = document.getElementById('taskName');

    if (param != null)
    {
        if ((param.value == '') && (displayError == true))
        {
            alert(errorTaskName1);
            return false;
        }

        if ((checkForInvalidCharacters(param.value) == false) && (displayError == true))
        {
            alert(errorTaskName2 + "\n" + errorTaskName3);
            return false;
        }

        saveWizardParameter('taskName', encodeURIComponent(param.value));
    }
}

/////////////////////////////////////////////////
// saveRunOnStartup() - MERGE?
/////////////////////////////////////////////////
function saveRunOnStartup()
{
    var param = document.getElementById('runOnStartup');

    if ((param != null) && (param.disabled == false) && (param.checked == true))
    {
        saveWizardParameter('runOnStartup', 'true');
    }
    else
    {
        removeWizardParameter('runOnStartup');
    }
}

/////////////////////////////////////////////////
// saveTaskDisabled()
/////////////////////////////////////////////////
function saveTaskDisabled()
{
    var param = document.getElementById('disableTask');

    if ((param != null) && (param.checked == true))
    {
        saveWizardParameter('disableTask', 'true');
    }
    else
    {
        removeWizardParameter('disableTask');
    }
}

/////////////////////////////////////////////////
// saveTaskRunNow()
/////////////////////////////////////////////////
function saveTaskRunNow()
{
    var param = document.getElementById('runNow');

    if ((param != null) && (param.disabled == false) && (param.checked == true))
    {
        saveWizardParameter('runNow', 'true');
    }
    else
    {
        removeWizardParameter('runNow');
    }
}

/////////////////////////////////////////////////
// saveScheduleTimeFilter()
/////////////////////////////////////////////////
function saveScheduleTimeFilter()
{
    var selectedFilter = getSelectedTimeFilter();

    if (selectedFilter != null)
    {
        saveWizardParameter('filterName', encodeURIComponent(selectedFilter));
    }
    else
    {
        removeWizardParameter('filterName');
    }
}

/////////////////////////////////////////////////
// saveScheduleTaskParams()
/////////////////////////////////////////////////
function saveScheduleTaskParams(displayError)
{
    // save Task Name
    if (saveTaskName(displayError) == false)
    {
        return false;
    }
    // determine the schedule type and save that parameter
    if (saveScheduleType(displayError) == false)
    {
        return false;
    }
    // save any selected Time Filter
    saveScheduleTimeFilter();
    // save if this Task should als "Run on Startup"
    saveRunOnStartup();
    // save if this Task should also "Run Now"
    saveTaskRunNow();
    // save if this Task should also be "Disabled"
    saveTaskDisabled();
    // if the "Owner" dropdown is present, grab the Owner value
    // if it is different than our current User, then pass to the
    // saveTask() method
    saveTaskOwnerChange();
}

/////////////////////////////////////////////////
// saveTaskOwnerChange()
/////////////////////////////////////////////////
function saveTaskOwnerChange()
{
    var select = document.getElementById('owner');

    if (select == null)
    {
        return;
    }

    saveWizardParameter('owner', select.value);
}

/////////////////////////////////////////////////
// saveTasks()
/////////////////////////////////////////////////
function saveTasks(controlID)
{
    //assume passed 'this', controlID is outer div for button, get button:
    var btnObj = ourButtonManager.getButtonChild(controlID);

    // disable the "Done" button
    ourButtonManager.disableButton(btnObj);

    var parentDoc = findTaskWizardParent(this);

    // Since this function is called from the ScheduleTask page, the Default
    // Parameters Page will need to save the Params before continuing on.  This
    // is done when the user clicks the "Schedule" button instead of the "Run Now"
    // button
    if (saveScheduleTaskParams(true) == false)
    {
        ourButtonManager.enableButton(btnObj);
        return;
    }

    // execute the Tool - create an MxRunnableTask
    var url = parentDoc.PARENT_BASE_DIR + "/taskandjob/saveTask.jsp" + parentDoc.buildWizardParams();

    location.replace(url);
}

/////////////////////////////////////////////////
// displayNotScheduled()
/////////////////////////////////////////////////
function displayNotScheduled()
{
    clearScheduleDisplays();
    closeManageFilters();
    // enable the "run on startup option"
    enableRunWhenCMSStarts(true);
    enableRunNow(true);
}
/////////////////////////////////////////////////
// clearScheduleDisplays()
/////////////////////////////////////////////////
function clearScheduleDisplays()
{
    // attempt to unload time filter
    var iframe = document.getElementById('displayTimeFilters');
    if ((iframe != null) && (iframe.contentWindow.removeInstance != null))
    {
        iframe.contentWindow.removeInstance();
    }

    var td = null;

    for (var i = 1; i <= NUM_REFINEMENT_CELLS; i++)
    {
        td = document.getElementById("refine" + i);

        if (td != null)
        {
            td.innerHTML = "";
        }
    }

    // set the "refine schedule" text to disabled
    document.getElementById("refine").className = "disabled-text";
}

/////////////////////////////////////////////////
// enableRunWhenCMSStarts()
/////////////////////////////////////////////////
function enableRunWhenCMSStarts(enable)
{
    enableControl(enable, "runOnStartup", "runOnStartupText");
}

/////////////////////////////////////////////////
// enableRunNow()
/////////////////////////////////////////////////
function enableRunNow(enable)
{
    enableControl(enable, "runNow", "runNowText");
}

/////////////////////////////////////////////////
// enableDisableTask()
/////////////////////////////////////////////////
function enableDisableTask(enable)
{
    enableControl(enable, "disableTask", "disableTaskText");
}

/////////////////////////////////////////////////
// enableControl()
/////////////////////////////////////////////////
function enableControl(enable, controlID, textID)
{
    var control = document.getElementById(controlID);
    var text    = document.getElementById(textID);

    if (control != null)
    {
        control.disabled = (enable != true);
    }

    if (text != null)
    {
        text.className   = (enable == true) ? "enabled-text" : "disabled-text";
    }
}
