var TIME_FILTER_SELECTED       = 'green';
var TIME_FILTER_NOT_SELECTED   = 'white';

var BLANK_PAGE                 = 0;
var SELECT_PAGE                = 1;
var MANAGE_PAGE                = 2;

var TIME_AM                    = 0;
var TIME_PM                    = 1;

var HOURS_IN_DAY               = 24;
var DAYS_IN_WEEK               = 7;

var EDIT_MODE_NEW              = 0;
var EDIT_MODE_EDIT             = 1;
var EDIT_MODE_COPY             = 2;

// when the Manage Time Filter page opens (displays) it will
// save the current helpID and restore it when the Manage Time Filters
// page is closed (hidden)
var savedHelpURL               = '';

// this value is TRUE when the "Delete" dialog is showing
var deleteOpen                 = false;

// this value is TRUE when the "Edit" dialog is showing
var questionOpen               = false;

// this value is TRUE when the "Error" dialog is showing
var errorOpen                  = false;

/////////////////////////////////////////////////
// closeQuestionWindow()
/////////////////////////////////////////////////
function closeQuestionWindow()
{
    // if the "delete" dialog is showing, close it when a new selection is made
    if (this.questionOpen == true)
    {
        this.questionOpen = false;
    }
}
/////////////////////////////////////////////////
// closeErrorWindow()
/////////////////////////////////////////////////
function closeErrorWindow()
{
    // if the "error" dialog is showing, close it when a new selection is made
    if (this.errorOpen == true)
    {
        this.errorOpen = false;
    }
}
/////////////////////////////////////////////////
// checkEditMode()
//
// if "editMode" == null or false, return false
// we cannot edit the time filter when not "editing"
// or when viewing a pop-up filter
/////////////////////////////////////////////////
function checkEditMode()
{
    if (this.editMode == null)
    {
        return false;
    }

    if (this.editMode == false)
    {
        return false;
    }

    return true;
}
/////////////////////////////////////////////////
// toggleColor()
/////////////////////////////////////////////////
function toggleColor(e)
{
    if (checkEditMode() == false)
    {
        return;
    }

    e.style.backgroundColor = (e.style.backgroundColor == TIME_FILTER_SELECTED) ? TIME_FILTER_NOT_SELECTED : TIME_FILTER_SELECTED;
}
/////////////////////////////////////////////////
// toggleColumn()
/////////////////////////////////////////////////
function toggleColumn(column)
{
    if (checkEditMode() == false)
    {
        return;
    }

    // 7 rows per column
    for (var i = 0; i < 7; i++)
    {
        toggleColor(document.getElementById(i + '_' + column));
    }
}
/////////////////////////////////////////////////
// toggleRow()
/////////////////////////////////////////////////
function toggleRow(row)
{
    if (checkEditMode() == false)
    {
        return;
    }

    // 24 colums per row
    for (var i = 0; i < 24; i++)
    {
        toggleColor(document.getElementById(row + '_' + i));
    }
}
/////////////////////////////////////////////////
// toggleTime()
/////////////////////////////////////////////////
function toggleTime(time)
{
    if (checkEditMode() == false)
    {
        return;
    }

    // if AM - then columns 0 - 11
    var columnStart = 0;
    var columnEnd   = 11;

    // if PM - then columns 12 - 23
    if (time == TIME_PM)
    {
        columnStart = 12;
        columnEnd   = 23;
    }

    for (var i = columnStart; i <= columnEnd; i++)
    {
        toggleColumn(i);
    }
}
/////////////////////////////////////////////////
// drawTimeFilterTableRET()
/////////////////////////////////////////////////
function drawTimeFilterTableRET(filterName)
{
    var url = '/mxportal/taskandjob/displayTimeFilter.jsp';

    if ((filterName != null) && (filterName != ""))
    {
        url += '?name=' + encodeURIComponent(filterName);
    }

    var table = "<iframe id='displayTimeFilters' name='displayTimeFilters' style='width:100%; height:80; \
                 position:relative; visibility:visible' scrolling='no' marginwidth='0' frameborder='0' \
                 src=" + url + "></iframe>";

    return table;
}
/////////////////////////////////////////////////
// drawTimeFilterTable()
/////////////////////////////////////////////////
function drawTimeFilterTable(filterName)
{
    var output = drawTimeFilterTableRET(filterName);
    document.writeln(output);
}
/////////////////////////////////////////////////
// useTimeFilter()
/////////////////////////////////////////////////
function useTimeFilter()
{
    // checkbox
    var cb     = document.getElementById('useTimeFilter');
    // selection box
    var sel    = document.getElementById('timeFilters');
    var table  = document.getElementById('miniGrid');

    if (cb.checked == true)
    {
        usingTimeFilter = true;

        sel.disabled = false;
        ourButtonManager.enableButtonById('manageTimeFilters');
        table.style.visibility  = 'visible';
    }
    else
    {
        usingTimeFilter = false;

        // if the manage page is open ,close it
        var iframe = parent.document.getElementById('manageFilters');

        if (iframe.style.visibility == 'visible')
        {
            openManageFilters();
        }

        sel.disabled = true;
        ourButtonManager.disableButtonById('manageTimeFilters');
        table.style.visibility = 'hidden';
    }
}
/////////////////////////////////////////////////
// selectFilter()
/////////////////////////////////////////////////
function selectFilter(page, timeStamp)
{
    var select    = document.getElementById('timeFilters');
    var selection = select.value;
    var ok        = true;

    // if the Manage <iframe> is hidden - select the same Time Filter on
    // that page - do this only if we are being called from the Select Page
    if (page == SELECT_PAGE)
    {
        iframe = parent.document.getElementById('manageFilters');

        if (iframe.style.visibility == 'hidden')
        {
            if (iframe.contentWindow.setFilterSelection != null)
            {
                iframe.contentWindow.setFilterSelection(selection);
            }
        }
    }
    else if (page == MANAGE_PAGE)
    {
        deleteOpen = false;
        closeQuestionWindow();
        closeErrorWindow();
        ok = okToProceed();

        if (ok == true)
        {
            // disable buttons, the newly selected time filter will enable those buttons that are
            // applicable for the time filter
            ourButtonManager.disableButtonById('newFilter');
            ourButtonManager.disableButtonById('editFilter');
            ourButtonManager.disableButtonById('copyFilter');
            ourButtonManager.disableButtonById('deleteFilter');
        }
    }

    var iframe = document.getElementById('selectTimeFilter');
    var url    = '/mxportal/taskandjob/selectTimeFilter.jsp?selection=' + selection + '&page=' + page + "&timeStamp=" + timeStamp;

    if (ok == true)
    {
        if (iframe != null)
        {
            iframe.contentWindow.document.location.replace(url);
        }
    }
    // if ok == false and we're on the MANAGE page, reselect the previous time filter name
    else if ((ok == false) && (page == MANAGE_PAGE))
    {
        select.value = this.selectedTimeFilterIndex;
    }
}
/////////////////////////////////////////////////
// deleteFilter()
/////////////////////////////////////////////////
function deleteFilter(timeStamp)
{
    // before we ask the user if they'd like to delete the time filter, we'll disable the
    // "delete" button so the user doesn't click it again
    this.deleteOpen = true;
    ourButtonManager.disableButtonById('deleteFilter');

    var iframe = document.getElementById('deleteTimeFilter');
    var url    = '/mxportal/taskandjob/confirmDeleteFilter.jsp?timeStamp=' + timeStamp;
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// drawTimeFilterIFrame()
/////////////////////////////////////////////////
function drawTimeFilterIFrame()
{
    document.writeln("<iframe id='manageFilters' name='manageFilters' style='width:100%; height:400;");
    document.writeln("position:relative; visibility:hidden' scrolling='no' marginwidth='0' frameborder='0'");
    document.writeln("src='/mxportal/home/MxBlank.html'></iframe>");
}
/////////////////////////////////////////////////
// getSelectedTimeFilter()
/////////////////////////////////////////////////
function getSelectedTimeFilter()
{
    // if the "use timeFilter" checkbox is not checked, return null
    // this will be the indication that a Time Filter has not been
    // selected
    var filterName = null;
    var iframe     = document.getElementById('displayTimeFilters');

    if (iframe == null)
    {
        return filterName;
    }

    var checkbox = iframe.contentWindow.document.getElementById('useTimeFilter');

    if ((iframe.contentWindow != null) &&
        (checkbox.disabled == false) &&
        (iframe.contentWindow.usingTimeFilter == true))
    {
        filterName = iframe.contentWindow.selectedTimeFilterName;
    }

    return filterName;
}
/////////////////////////////////////////////////
// getSelectedDisplayableTimeFilter()
/////////////////////////////////////////////////
function getSelectedDisplayableTimeFilter()
{
    // if the "use timeFilter" checkbox is not checked, return null
    // this will be the indication that a Time Filter has not been
    // selected
    var filterName = null;
    var iframe     = document.getElementById('displayTimeFilters');

    if (iframe == null)
    {
        return filterName;
    }

    var checkbox = iframe.contentWindow.document.getElementById('useTimeFilter');

    if ((iframe.contentWindow != null) &&
        (checkbox.disabled == false) &&
        (iframe.contentWindow.usingTimeFilter == true))
    {
        filterName = iframe.contentWindow.selectedDisplayableTimeFilterName;
    }

    return filterName;
}
/////////////////////////////////////////////////
// closeManageFilters()
/////////////////////////////////////////////////
function closeManageFilters()
{
    var iframe = document.getElementById('manageFilters');
    iframe.style.visibility = 'hidden';
}
/////////////////////////////////////////////////
// openManageFilters()
/////////////////////////////////////////////////
function openManageFilters()
{
    // get the iframe of the 'manage' window
    var iframe = parent.document.getElementById('manageFilters');

    if (iframe.style.visibility == 'hidden')
    {
        // we only ever open from the SELECT_PAGE
        iframe.contentWindow.savedHelpURL = MxPortalWorkspaceGetHelpUrl();
        MxPortalWorkspaceSetHelpTopic(helpID);

        iframe.style.visibility = 'visible';
    }
    else
    {
        // call the function from the <iframe> point of view
        if (iframe.contentWindow.editMode == true)
        {
            if (iframe.contentWindow.okToProceed() == false)
            {
                return;
            }
        }

        iframe.contentWindow.closeTimeFilter();
        iframe.contentWindow.deleteOpen = false;
        iframe.contentWindow.closeQuestionWindow();
        iframe.contentWindow.closeErrorWindow();

        // we could close from SELECT_PAGE or MANAGE_PAGE, but
        // we're only restoring the helpID
        MxPortalWorkspaceSetHelpUrl(iframe.contentWindow.savedHelpURL);

        iframe.style.visibility = 'hidden';
    }
}
/////////////////////////////////////////////////
// saveFilter()
/////////////////////////////////////////////////
function saveFilter(leaveOpen, timeStamp)
{
    // save the name - make sure it is not blank
    var edit = document.getElementById('filterName');
    var name = edit.value;

    if (name == '')
    {
        alert(emptyNameErrorText);
        return false;
    }

    // build a number for each week
    var days      = new Array(DAYS_IN_WEEK);
    var hourIndex = 1;
    var hour      = 0;
    var hourURL   = "";

    for (var i = 0; i < DAYS_IN_WEEK; i++)
    {
        hourIndex = 1;
        hour      = 0;

        for (var j = 0; j < HOURS_IN_DAY; j++)
        {
            var td = document.getElementById(i + '_' + j);

            if (td.style.backgroundColor == 'green')
            {
                hour = hour | hourIndex;
            }

            hourIndex = hourIndex << 1;
        }

        days[i]  = hour;
        hourURL += '&day' + i + '=' + hour;
    }

    // send to url
    var url = '/mxportal/taskandjob/saveTimeFilter.jsp?name=' + encodeURIComponent(name) + hourURL;

    if (leaveOpen == true)
    {
        url += "&open=true";
    }

    url += ("&timeStamp=" + timeStamp);

    var iframe = document.getElementById('saveTimeFilter');
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// newTimeFilter()
/////////////////////////////////////////////////
function newTimeFilters(editMode, timeStamp)
{
    if (okToProceed() == false)
    {
        return;
    }

    var iframe = document.getElementById('newTimeFilter');
    var url    = '/mxportal/taskandjob/newTimeFilter.jsp?editMode=' + editMode + '&timeStamp=' + timeStamp;
    iframe.contentWindow.document.location.replace(url);
}
/////////////////////////////////////////////////
// displayPopupTimeFilter()
/////////////////////////////////////////////////
function displayPopupTimeFilter(tf)
{
    var windowWidth  = 600;
    var windowHeight = (this.sameTimeZone == true) ? 240 : 260;
    var left         = (screen.width - windowWidth) / 2;
    var top          = (screen.height - windowHeight) / 2;

    var url = "/mxportal/taskandjob/timeFilterPopup.jsp";

    if (tf != null)
    {
        url += "?tf=" + encodeURIComponent(tf);
    }

    window.open(url, "timeFilter", "top=" + top + ",left=" + left + ",width=" + windowWidth + ",height=" + windowHeight, true);
}
