<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="timeFiltersBean" class="com.hp.mx.portal.taskandjob.MxTimeFilters" scope="session"/>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTimeFiltersInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String                     timeStamp = request.getParameter("timeStamp");
    MxTimeFiltersInstance      inst      = (MxTimeFiltersInstance)timeFiltersBean.getInstance(timeStamp);
    MxTaskAndJobResourceBundle rb        = inst.getRB();

    // build buttons for this page
    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag applyBtnTag  = new MxDefaultTag("applyBtn", rb.getString("APPLY_BUTTON"), "saveFilter(true, "+ timeStamp + " )");
    MxTag okBtnTag     = new MxDefaultTag("okBtn", rb.getString("OK_BUTTON"), "saveFilter(false, " + timeStamp + ")");
    MxTag cancelBtnTag = new MxDefaultTag("cancelBtn", rb.getString("CANCEL_BUTTON"), "closePage()");

    applyBtnTag.setAttr(MxTag.DISABLED, "true");
    okBtnTag.setAttr(MxTag.DISABLED, "true");

    buttons.addMxTag(applyBtnTag);
    buttons.addMxTag(okBtnTag);
    buttons.addMxTag(cancelBtnTag);

    MxButtons vertButtons = new MxButtons();
    vertButtons.clearMxTags();

    MxTag newBtnTag    = new MxDefaultTag("newFilter", rb.getString("NEW_BUTTON"), "newTimeFilters(EDIT_MODE_NEW, " + timeStamp + ")");
    MxTag editBtnTag   = new MxDefaultTag("editFilter", rb.getString("EDIT_BUTTON"), "newTimeFilters(EDIT_MODE_EDIT, " + timeStamp + ")");
    MxTag copyBtnTag   = new MxDefaultTag("copyFilter", rb.getString("COPY_BUTTON"), "newTimeFilters(EDIT_MODE_COPY, " + timeStamp + ")");
    MxTag deleteBtnTag = new MxDefaultTag("deleteFilter", rb.getString("DELETE_BUTTON"), "deleteFilter(" + timeStamp +")");

    editBtnTag.setAttr(MxTag.DISABLED, "true");
    deleteBtnTag.setAttr(MxTag.DISABLED, "true");

    vertButtons.addMxTag(newBtnTag);
    vertButtons.addMxTag(editBtnTag);
    vertButtons.addMxTag(copyBtnTag);
    vertButtons.addMxTag(deleteBtnTag);

    vertButtons.setVerticalAligned(true);
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/taskandjob/js/timeFilters.js'></script>
        <script language='javascript'>
            var emptyNameErrorText                = '<%= rb.getString("ERROR_NAME_5") %>';
            // are we in edit mode?
            var editMode                          = false;
            // the Time Filter selected
            var selectedTimeFilterName            = '';
            var selectedDisplayableTimeFilterName = '';
            var selectedTimeFilterIndex           = 0;
            /////////////////////////////////////////////////
            // scrollTop()
            /////////////////////////////////////////////////
            function scrollTop()
            {
                // for the schedule task page
                parent.parent.scrollTo(0, 0);
                // for other developers using Time Filter selection
                parent.scrollTo(0, 0);
            }
            /////////////////////////////////////////////////
            // closeTimeFilter()
            /////////////////////////////////////////////////
            function closeTimeFilter(leaveOpen)
            {
                // disable the control
                document.getElementById('filterName').readOnly = true;

                // disallow editing the grid
                document.getElementById('bigGridTable').className = '';
                editMode = false;

                // disable the Apply and OK buttons
                ourButtonManager.disableButtonById('applyBtn');
                ourButtonManager.disableButtonById('okBtn');

                selectFilter(MANAGE_PAGE, <%= timeStamp %>);

                // scroll the page to the top
                if ((leaveOpen == null) || (leaveOpen == false))
                {
                    scrollTop();
                }
            }
            /////////////////////////////////////////////////
            // setFilterSelection()
            /////////////////////////////////////////////////
            function setFilterSelection(filterIndex)
            {
                var select   = document.getElementById('timeFilters');
                select.value = filterIndex;

                selectFilter(MANAGE_PAGE, <%= timeStamp %>);
            }
            /////////////////////////////////////////////////
            // okToProceed()
            /////////////////////////////////////////////////
            function okToProceed()
            {
                var reply = true;

                if (editMode == true)
                {
                    reply = confirm("<%= rb.getString("LOSE_CHANGES") %>");

                    if (reply == true)
                    {
                        closeTimeFilter(); // doesn't really close - just prepares a close
                    }
                }

                return reply;
            }
            /////////////////////////////////////////////////
            // closePage()
            /////////////////////////////////////////////////
            function closePage()
            {
                if (okToProceed() == false)
                {
                    return;
                }

                openManageFilters();
                deleteOpen = false;
                closeQuestionWindow();
                closeErrorWindow();
            }
            /////////////////////////////////////////////////
<%
    inst.dumpDeletableFilterArray(out);
%>
            /////////////////////////////////////////////////
            // checkBuiltIns()
            /////////////////////////////////////////////////
            function checkBuiltIns(selection)
            {
                var builtIn = builtIns[selection];

                ourButtonManager.enableButtonById('newFilter');
                ourButtonManager.enableButtonById('copyFilter');

                if (builtIn == false)
                {
                    ourButtonManager.enableButtonById('editFilter');
                    ourButtonManager.enableButtonById('deleteFilter');
                }
                else
                {
                    ourButtonManager.disableButtonById('editFilter');
                    ourButtonManager.disableButtonById('deleteFilter');
                }
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='taskWizardInit()' onUnload='closeQuestionWindow()'>

        <hr>

        <font class='mx-subheader-nosep'>
            <%= rb.getString("FILTERS_TITLE") %>
        </font>

        <br>
        <br>

        <table border='0' cellpadding='0' cellspacing='0' style='width:100%'>
            <tr>
                <td id='filters' rowspan='2' valign='top' nowrap>
                    <select style='width:165' id='timeFilters' size='11' onClick='selectFilter(MANAGE_PAGE, <%= timeStamp %>)'>
<%
    inst.dumpTimeFilterList(out, null, MxTimeFiltersInstance.MANAGE_PAGE);
%>
                    </select>
                </td>
                <td colspan='3' nowrap>&nbsp;</td>
                <td colspan='2' id='timeFilterName' style='visibility:visible' nowrap>
                    <font id='filterNameText'><b><%=rb.getString("FILTER_NAME")%>:</b></font>
                    <input type='text' style='width:150' id='filterName' readonly
                           value='<%= inst.getDisplayableTimeFilterName(MxTimeFiltersInstance.MANAGE_PAGE) %>'>
                </td>
            </tr>
            <tr>
                <td nowrap>&nbsp;&nbsp;&nbsp;</td>
                <td valign='top' nowrap>
                    <div style="width:100px">
<%
    vertButtons.dumpButtons(out);
%>
                    </div>
                </td>
                <td nowrap>&nbsp;&nbsp;&nbsp;</td>
                <td colspan='2' id='fullTimeFilterGrid' style='width:100%' nowrap>
<%
    inst.drawTimeFilterFullGrid(MxTimeFiltersInstance.MANAGE_PAGE, out);
%>
                </td>
            </tr>
            <tr>
                <td id='grid1' rowspan='2' align='center' valign='top' nowrap>
<%
    inst.dumpTimeFilterMiniGrid(MxTimeFiltersInstance.MANAGE_PAGE, out, false);
%>
                </td>
                <td colspan='3' rowspan='2'>&nbsp;</td>
                <td rowspan='2' nowrap align='left' valign='top'>
                    <table border='0' cellpadding='0' cellspacing='3'>
                       <tr>
                           <td class='legend-box' style='width:15px; height:15px; background:green' nowrap>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                           <td nowrap>&nbsp;=&nbsp;<%= rb.getString("SELECTED") %>&nbsp;&nbsp;</td>
                       </tr>
                       <tr>
                           <td class='legend-box' style='width:15px; height:15px; background:white' nowrap>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                           <td nowrap>&nbsp;=&nbsp;<%= rb.getString("NOT_SELECTED") %></td>
                       </tr>
                    </table>
                </td>
                <td style='width:100%'>
                    <table border='0' cellspacing='0' cellpadding='5' style='width:100%'>
                        <tr>
                            <td>&nbsp;</td>
                            <td>
<%
    inst.dumpTimeZoneMessage(out);
%>
                            </td>
                        </tr>
                        <tr><td></td></tr>
                        <tr><td></td></tr>
                        <tr><td></td></tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td nowrap>
                    <div style="margin-top:15px">
<%
    buttons.dumpButtons(out);
%>
                    </div>
                </td>
            </tr>
        </table>

        <iframe id='selectTimeFilter' style='width:100%; height:0; position:relative; visibility:hidden'
                scrolling='no' marginwidth='0' frameborder='1' src='<%= MxOptions.URL_BASE %>/home/MxBlank.html'>
        </iframe>
        <iframe id='newTimeFilter' style='width:100%; height:0; position:relative; visibility:hidden'
                scrolling='no' marginwidth='0' frameborder='1' src='<%= MxOptions.URL_BASE %>/home/MxBlank.html'>
        </iframe>
        <iframe id='saveTimeFilter' style='width:100%; height:0; position:relative; visibility:hidden'
                scrolling='no' marginwidth='0' frameborder='1' src='<%= MxOptions.URL_BASE %>/home/MxBlank.html'>
        </iframe>
        <iframe id='deleteTimeFilter' style='width:100%; height:0; position:relative; visibility:hidden'
                scrolling='no' marginwidth='0' frameborder='1' src='<%= MxOptions.URL_BASE %>/home/MxBlank.html'>
        </iframe>

        <script language='javascript' type='text/javascript'>
            var iframe    = parent.document.getElementById('displayTimeFilters');
            var selection = null;
            var select    = null;

            if ((iframe != null) && (iframe.contentWindow != null))
            {
                select = iframe.contentWindow.document.getElementById('timeFilters');

                if (select != null)
                {
                    selection = select.value;
                    setFilterSelection(selection);
                }
            }
            else
            {
                // the <iframe> may not be present because an appropriate option is not selected.
                // In this case we should select the selected Time Filter from our drop-down
                select = document.getElementById('timeFilters');

                if (select != null)
                {
                    selection = select.value;
                    setFilterSelection(selection);
                }
            }
        </script>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
