<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxJobData"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);

    // if there are no Jobs to be selected from the current Task, then we will not attempt
    // to call "displayTaskJobResults()" in the onLoad= of the <body>
    String  onLoad    = "";

    // if this is a user initiated selection, then use sessionReset.js
    // else use AutoRefreshingSessionReset.js
    String  userSelect   = request.getParameter("userSelect");
    String  sessionReset = "/SessionReset.js";

    if (userSelect.equalsIgnoreCase("false") == true)
    {
        sessionReset = "/AutoRefreshingSessionReset.js";
    }

    String  jobFormat  = request.getParameter("jobFormat");
    int     format     = Integer.parseInt(jobFormat);

    // select the job
    boolean success   = inst.selectJob();

    if (success == true)
    {
        onLoad = "setJobInfo(), displayJobResults(" + jobFormat + ", " + taskAndJobTimeStamp + ")";
    }
    else
    {
        onLoad = "hideJobResults()";
    }

    // get the state the "Task Results" buttons should be in
    // we'll set the button states after this TaskJob is selected
    boolean btnStates[] = inst.getButtonStateForSelectedJob();
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='<%=sessionReset%>'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/allTasks.js'></script>
        <script language='javascript' type='text/javascript'>
            // function to update the selected task infor on the allTasks.jsp page
            function setJobInfo()
            {
                // set the button states for the Selected Job - do after we update
                // the selected Job info
                if (<%=btnStates[0]%> == true)
                {
                    parent.ourButtonManager.enableButtonById('btnStop');
                }
                else
                {
                    parent.ourButtonManager.disableButtonById('btnStop');
                }

                if (<%=btnStates[1]%> == true)
                {
                    parent.ourButtonManager.enableButtonById('btnDelete');
                }
                else
                {
                    parent.ourButtonManager.disableButtonById('btnDelete');
                }

                // now that we have successfully selected a job,
                // we can show the 'taskInstanceResults' <iframe>
                var iframe = null;

                if (<%=format%> == JOB_FORMAT_BASIC)
                {
                    iframe = parent.parent.document.getElementById('taskInstanceResults');
                }
                else
                {
                    iframe = parent.document.getElementById('jobResults');
                }

                iframe.style.visibility = 'visible';
            }
            // hide the job results window
            function hideJobResults()
            {
                // now that we have successfully selected a job,
                // we can show the 'taskInstanceResults' <iframe>
                var iframe = null;

                if (<%=format%> == JOB_FORMAT_BASIC)
                {
                    iframe = parent.parent.document.getElementById('taskInstanceResults');
                }
                else
                {
                    iframe = parent.document.getElementById('jobResults');
                }

                iframe.style.visibility = 'hidden';
                iframe.style.height     = 0;
                iframe.contentWindow.document.location.replace('<%=MxOptions.URL_BASE%>/home/MxBlank.html');
            }
        </script>
    </head>

    <body onLoad='<%=onLoad%>'>
    </body>
</html>
