<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<%@ page import="com.hp.mx.html.core.MxButton"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>
<%@ page import="com.hp.mx.utilities.InvalidCharCheck"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    // if "edit" is found on the URL, then we are editing an existing
    // Task - else we are creating a new Task
    String edit      = request.getParameter("edit");
    String taskName  = request.getParameter("taskName");
    String taskID    = request.getParameter("taskID");
    String retry     = request.getParameter("retry");
    String timeStamp = request.getParameter("timeStamp");

    String mxParams    = null;
    String schedParams = null;
    // we do TimeFilter sepearate because of "Nights & Weekends", which
    // messes up the split('&') call to store wizard params
    String timeFilter  = null;

    // get our Task Wizard Instance object
    MxTaskWizardInstance inst = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    // if we don't have an instance, return
    if (inst == null)
    {
        return;
    }

    MxTaskAndJobResourceBundle rb    = inst.getRB();
    InvalidCharCheck           check = new InvalidCharCheck();

    // if we are editing, set the GLOBAL selection to that of the Task
    // we are editing
    //
    // else - leave the GLOBAL selection to what it is
    if ((retry != null) || (edit == null))
    {
        inst.saveSelectedNodes();
    }
    else
    {
        // create a TaskAndJobInstance, select the "TaskID" - get the needed info
        MxTaskAndJobInstance taj = new MxTaskAndJobInstance(timeStamp);
        taj.initializeAllTasks(loginBean, taskID);

        // if the Tool for this Task defines CPP's, then don't bother with any MxParams
        // otherwise, add the PARAM_#'s to the Wizard Parameter Array
        if (inst.toolHasCPPs() == false)
        {
            mxParams = taj.getSelectedTaskMxParams();
        }

        schedParams = taj.getSelectedTaskScheduleOptions();
        timeFilter  = taj.getSelectedTaskScheduleTimeFilter();
    }

    // are targets required for this Tool?  This is only true for Web Launch Tools.
    // If not, then don't set the targetsOptional flag
    boolean targetsRequired = inst.toolAcceptsTargets();
    // do we have any nodes selected?
    boolean nodesSelected   = (inst.getNumNodesSelected() > 0);
    // does this tool have a HelpURL?  If so, don't set any helpID - the portal sets the HelpURL
    boolean hasHelpURL      = (inst.getToolHelpURL() != null);
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/targetSelection.js'></script>
        <script language='javascript' type='text/javascript'>
            // set the help topic html file
            if (<%= hasHelpURL %> == false)
            {
                MxPortalWorkspaceSetHelpTopic('<%= inst.getToolHelpID() %>');
            }
            //////////////////////////////////////////////
            // resource strings for taskWizard.js
            //////////////////////////////////////////////
            var step                  = "<%=rb.getString("STEP")%>";
            var targets               = "<%=rb.getString("TARGETS")%>";
            var target                = "<%=rb.getString("TARGET")%>";
            var prevButton            = "<%=rb.getString("PREV_BUTTON")%>";
            var doneButton            = "<%=rb.getString("DONE_BUTTON")%>";
            var runNowButton          = "<%=rb.getString("RUN_NOW_BUTTON")%>";
            var scheduleButton        = "<%=rb.getString("SCHEDULE_BUTTON")%>";
            var nextButton            = "<%=rb.getString("NEXT_BUTTON")%>";
            ///////////////////////////////
            var PARENT_PAGE           = 1;
            var PARENT_BASE_DIR       = '<%=MxOptions.URL_BASE%>';
            // by default, we will reload the current page with "err=1" on the URL
            // if a custom button function returns false.  If reloadOnError has
            // been set to false, then we will do nothing when the custom button
            // function returns false
            var reloadOnError         = true;
            // CPP's may wish to POST their pages for parameter validation instead
            // of moving onto the next page to do their validation, or even validating
            // their parameters in their Custom Button Function: the CPP may have
            // sensitive data that shouldn't be passed on the URL.
            //
            // Blank by default, the Task Wizard will only perform the SUBMIT function if this has
            // been defined.  The Task Wizard will clear this value in the WizardNextStep() function.
            // Any following CPP will need to set this value again for that CPP.  The Task Wizard
            // will leave this value if the WizardCurrentStep() function is called.
            var submitFormName        = '';
            // Last button clicked.  This is set by the Task Wizard when one of its buttons are
            // clicked.  The developer of CPP's will only need to call "loadWizardNextStep()" in
            // order to either move the Task Wizard only the Next page (CPP or Schedule page), or to
            // complete the "Run Now" command if it was the "Run Now" button that was clicked.
            var lastButtonClicked     = WIZARD_NEXT_BUTTON;
            // This var is set to "true" when this page loads.  The associated isFirstTime() API
            // will return TRUE or FALSE.  TRUE if this page (function) has been called for the
            // first time, FALSE otherwise.  CPP's can queue off of this return value to determine
            // whether or not they should re-init their session java beans.
            var firstTime             = true;
            ///////////////////////////////
            // save the Tool Name and Description
            ///////////////////////////////
            var toolName              = "<%=check.transformHTML(inst.getToolName())%>";
            var toolDescription       = "<%=check.transformHTML(inst.getToolDescription())%>";
            var selectedNodes         = "";
            var toolTargetsEvents     = <%= inst.getToolTargetsEvents() %>;
            ///////////////////////////////
            // Task Wizard variables
            ///////////////////////////////
            var taskWizardPages       = new Array();
            var taskWizardParams      = new Array();
            var parameterIndex        = 0;
            // dump the Task Wizard Page Array
<%
    inst.dumpTaskWizardPageArray(out);
%>
            var currTaskWizardStep    = 1;
            var currTaskDisplayStep   = 1;
            var maxNumTaskPages       = taskWizardPages.length;
            var isToolScheduleable    = <%=inst.isToolSchedulable()%>;
            var editMode              = <%=edit != null%>;
            // store the URL params sent to this page
            var paramsToStore         = '<%=request.getQueryString()%>';
<%
    if (mxParams != null)
    {
%>
        paramsToStore += "<%=mxParams%>";
<%
    }
%>
    // Do the same for schedule options
<%
    if (schedParams != null)
    {
%>
        paramsToStore += "<%=schedParams%>";
<%
    }
%>
            storeWizardParameters(paramsToStore);
<%
    if (timeFilter != null)
    {
%>
        saveWizardParameter("filterName", encodeURIComponent("<%=timeFilter%>"));
<%
    }
%>
            /////////////////////////////////////////////////
            // buildWizardParams()
            /////////////////////////////////////////////////
            function buildWizardParams()
            {
                var params = '';

                for (var i = 0; i < taskWizardParams.length; i++)
                {
                    if (i == 0)
                    {
                        params += '?' + taskWizardParams[i].name + '=' + taskWizardParams[i].value;
                    }
                    else
                    {
                        params += '&' + taskWizardParams[i].name + '=' + taskWizardParams[i].value;
                    }
                }

                return params;
            }
            ///////////////////////////////
            // displayWizardFirstPage()
            ///////////////////////////////
            function displayWizardFirstPage()
            {
                // if we are loading the targetSelection page, then
                // set the "Next" button to "Run Now" and (later) "Schedule"
                // if there are no Custom or Default Parameter Pages to display

                // need to check against the current step number we are on
                // Target Selection Page may not always be 1 of X(4), it may be 3 of X(4)
                // Therefore, the Next, Run Now & Schedule button decision will need work
                switch (maxNumTaskPages)
                {
                    case 0:
                        // this is for WLA that specify "accepts-targets=false"
                        break;
                    case 1:
                        // This is the only page to display: display "Run Now"
                        // NO CPP, NO DPP, NO Schedule
                        saveWizardParameter("btn2Text", encodeURIComponent(runNowButton));
                        saveWizardParameter("btn2Function", "runNow(this)");
                        break;
                    case 2:
                        // SCHEDULABLE
                        if (<%= inst.isToolSchedulable() %> == true)
                        {
                            // If the Task is Scheduleable: display "schedule" and "Run Now"
                            // NO CPP, NO DPP - Schedule page always LAST
                            saveWizardParameter("btn1Text", encodeURIComponent(scheduleButton));
                            saveWizardParameter("btn1Function", "nextWizardPage(this)");

                            // if "editMode", don't show this button
                            if (editMode == false)
                            {
                                saveWizardParameter("btn2Text", encodeURIComponent(runNowButton));
                                saveWizardParameter("btn2Function", "runNow(this)");
                            }
                        }
                        // NOT SCHEDULABLE
                        else
                        {
                            if (taskWizardPages[0].indexOf('targetSelection') != -1)
                            {
                                // We are FIRST of 2 pages, display NEXT
                                saveWizardParameter("btn2Text", encodeURIComponent(nextButton));
                                saveWizardParameter("btn2Function", "nextWizardPage(this)");
                            }
                            else
                            {
                                // We are SECOND of 2 pages, display PREV and RUN NOW
                                saveWizardParameter("btn3Text", encodeURIComponent(prevButton));
                                saveWizardParameter("btn3Function", "prevWizardPage(this)");

                                saveWizardParameter("btn2Text", encodeURIComponent(runNowButton));
                                saveWizardParameter("btn2Function", "runNow(this)");
                            }
                        }
                        break;
                    default:
                        // We are here if there are >= 3 pages to display
                        // if target selection page is FIRST
                        if (taskWizardPages[0].indexOf('targetSelection') != -1)
                        {
                            // display NEXT
                            saveWizardParameter("btn2Text", encodeURIComponent(nextButton));
                            saveWizardParameter("btn2Function", "nextWizardPage(this)");
                        }
                        // else
                        else
                        {
                            // if target selection won't be first page, always display a PREV button
                            saveWizardParameter("btn3Text", encodeURIComponent(prevButton));
                            saveWizardParameter("btn3Function", "prevWizardPage(this)");

                            // if SCHEDULABLE
                            if (<%= inst.isToolSchedulable() %> == true)
                            {
                                // if JUST PRIOR TO LAST PAGE
                                if (taskWizardPages[maxNumTaskPages - 2].indexOf('targetSelection') != -1)
                                {
                                    // display PREV, SCHEDULE & RUN NOW
                                    saveWizardParameter("btn1Text", encodeURIComponent(scheduleButton));
                                    saveWizardParameter("btn1Function", "nextWizardPage(this)");

                                    saveWizardParameter("btn2Text", encodeURIComponent(runNowButton));
                                    saveWizardParameter("btn2Function", "runNow(this)");
                                }
                                // else
                                else
                                {
                                    // display PREV & NEXT
                                    saveWizardParameter("btn2Text", encodeURIComponent(nextButton));
                                    saveWizardParameter("btn2Function", "nextWizardPage(this)");
                                }
                            }
                            // else
                            else
                            {
                                // if LAST PAGE
                                if (taskWizardPages[maxNumTaskPages - 1].indexOf('targetSelection') != -1)
                                {
                                    // display PREV & RUN NOW
                                    saveWizardParameter("btn2Text", encodeURIComponent(runNowButton));
                                    saveWizardParameter("btn2Function", "runNow(this)");
                                }
                                // else
                                else
                                {
                                    // display PREV & NEXT
                                    saveWizardParameter("btn2Text", encodeURIComponent(nextButton));
                                    saveWizardParameter("btn2Function", "nextWizardPage(this)");
                                }
                            }
                        }
                        break;
                }

                var iframe = null;
                var url    = null;

                // if "targetsRequired" == false, then set the "targetsRequired" URL
                // parameter for the Target Selection Page
                if (<%=targetsRequired%> == false)
                {
                    saveWizardParameter("targetsRequired", "false");
                    // load the target selection page into the "tsp" iframe - we
                    // need to perform its actions
                    iframe = document.getElementById("tsp");
                    url    = "<%=MxOptions.URL_BASE%>/taskandjob/targetSelection.jsp" + buildWizardParams() + "&no-show=1";
                    iframe.contentWindow.location.replace(url);
                    // in this case, the "no-show" selection page will call loadFirstPage when it is complete
                }
                else
                {
                    loadFirstPage();
                }
            }
            ///////////////////////////////
            // loadFirstPage()
            ///////////////////////////////
            function loadFirstPage()
            {
                document.getElementById("wizardPageFrame").contentWindow.location.replace(taskWizardPages[currTaskWizardStep - 1] + buildWizardParams());
            }
            ///////////////////////////////
            // scrollTop()
            ///////////////////////////////
            function scrollTop()
            {
                scrollTo(0, 0);
            }
            ///////////////////////////////
            // saveScreenDimensions()
            ///////////////////////////////
            function saveScreenDimensions()
            {
                var params = "width=" + screen.width + "&height=" + screen.height + "&timeStamp=<%=timeStamp%>";
                var url    = "<%=MxOptions.URL_BASE%>/taskandjob/saveScreen.jsp?" + params;
                var iframe = document.getElementById('action');

                iframe.contentWindow.document.location.replace(url);
            }
            ///////////////////////////////
            // removeInstance()
            ///////////////////////////////
            function removeInstance()
            {
                document.getElementById("action").contentWindow.document.location.replace("<%= MxOptions.URL_BASE %>/taskandjob/removeTaskWizardInstance.jsp?timeStamp=<%= timeStamp %>");
            }
            ///////////////////////////////
            // myOnLoad()
            ///////////////////////////////
            function myOnLoad()
            {
                taskWizardInit();
                saveScreenDimensions();
                displayWizardFirstPage();
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='myOnLoad()' onUnload='removeInstance()'>

        <script language='javascript' type='text/javascript'>
            MxPortalWorkspaceSetSubtitleHtml(toolDescription);
            displayStepTextTable();
        </script>

        <br>
        <br>

        <iframe id='wizardPageFrame' name='wizardPageFrame' style='position:relative; visibility:visible; width:100%; height:1300'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        <iframe id='action' name='action' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        <iframe id='tsp' name='tsp' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
