<%--
/*-------------------------------------------------------------------------
---- Copyright 1997, 2003 Hewlett-Packard Corporation
---------------------------------------------------------------------------
----
---- Title: EnterEventComments.jsp
----
---- Package:  www.ui.jsp
----
---- Description: Built a browser frame for the user to view/edit comments
----                    associated with selected events.
----
----------------------------------------------------------------------------
---- Date: 5/1/2003
---------------------------------------------------------------------------
---- $ProjectName: $
---- $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/EnterEventComments.jsp,v 1.32 2005/05/31 23:53:43 farley Exp $
----------------------------------------------------------------------------*/
--%>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="selectionBean" class="com.hp.mx.portal.core.MxObjSelections" scope="session"/>
<jsp:useBean id="resourceBean" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%@ page import="com.hp.mx.portal.list.*" %>

<%@ include file="EventCommonAPI.jsp" %>

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);
    resourceBean.init(loginBean,"ViewEvents");

    String  oldComment = "";

    MxObjList selectedEventNodes = getSelectedEventNodes( selectionBean );

    if ( selectedEventNodes.size() == 1 )
    {
        AlertController myController = getMyAlertController();
        MxObj oneSelectionObj = selectedEventNodes.get( 0 );
        int nOneSelectionID = oneSelectionObj.getAsId( MxObj.TYPE_EVENT );

        AlertObject alertDataObj = myController.getAlert( nOneSelectionID );
        oldComment = alertDataObj.getComments();
        if ( oldComment == null )
            oldComment = "";
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    buttons.addMxTag(new MxDefaultTag("okButtonID", resourceBean.getString("ViewEvents.ButtonOK"),
                                      "enterCommentsClicked('" +
                                      resourceBean.getString("ViewEvents.TextLimitWarningMsg") + "')"));
    buttons.addMxTag(new MxDefaultTag("cancelButtonID", resourceBean.getString("ViewEvents.ButtonCancel"),
                                      "cancelEnterEventComments()"));
%>

<html>

    <head>
        <link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>
        <script src="../javascript/EventScript.js"></script>
        <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
        <script language="JavaScript" type="text/javascript">

        function isMaxTextLengthOK( element, maxTextLimit, textLimitWarningMsg )
        {
            var actualTextLength = eval("document.getElementById( element ).value.length");
            var deltaTextLength = actualTextLength - maxTextLimit;

            if ( actualTextLength > maxTextLimit )
            {
                alert( textLimitWarningMsg );
                return false;
            }

            return true;
        }

        function enterCommentsClicked(textLimitWarningMsg)
        {
            if ( isMaxTextLengthOK('newEventCommentsID', 1000, textLimitWarningMsg ) == false )
                return false;

            MxPortalWorkspaceSetHelpTopicEx( "monitor_nav_eventView" );
            var enteredComments = eval("document.getElementById( \"newEventCommentsID\" ).value" );
            parent.enterComments(enteredComments);
        }

        function cancelEnterEventComments()
        {
            parent.document.getElementById("<%=MxSystemsListRenderer.ID_EDIT_EVENT_SPACE%>").contentWindow.document.location.replace("EmptyFrame.jsp?iframe=true");
            MxPortalWorkspaceSetHelpTopic( "monitor_nav_eventView" );
        }

        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body onLoad="OnLoadForEnterEventCommentSpace()" onResize="OnResizeForNewEditEventSpace()" onUnload="OnUnloadForNewEditEventSpace()">
        <div class="NewEditEventSpace" id="NewEditEventSpaceID">
            <br>
            <hr>

            <table border="0" cellpadding="0" cellspacing="0" style="width:100%">
                <tr>
                    <td style="width:2%" nowrap><font class="subwindow-header">
                    <%= resourceBean.getString("ViewEvents.SubTitleEnterComments") %>&nbsp;</font></td>
                </tr>
            </table>

            <br><br>

            <div align="center">
                <textarea id ="newEventCommentsID" style="width:100%" name="newEventCommentsText" rows=10><%= oldComment %></textarea>
            </div>

            <br>

            <div style="margin-top:15px">
                <% buttons.dumpButtons(out); %>
            </div>

        </div>

<script>
    MxPortalRefreshStatusOverview();
</script>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>
</html>
