<%--
/*-------------------------------------------------------------------------
---- Copyright 1997, 2003 Hewlett-Packard Corporation
---------------------------------------------------------------------------
----
---- Title: PrintPreviewEventList.jsp
----
---- Package:  www.ui.jsp
----
---- Description: Display selected event(s) for viewing/printing
----
----------------------------------------------------------------------------
---- Date: 5/1/2003
---------------------------------------------------------------------------
---- $ProjectName: $
---- $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/PrintPreviewEventList.jsp,v 1.11 2005/03/01 03:16:33 farley Exp $
----------------------------------------------------------------------------*/
--%>

<%@ page import="com.hp.mx.portal.core.*,
com.hp.mx.portal.ui.*"
%>

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);
%>



<html>
<head>

<style type="text/css">

body
{
    font-family:        "arial,sans-serif";
    font-size:          10pt;
}

.subwindow-header
{
    font-family:        arial,sans-serif;
    font-size:          11pt;
    font-weight:        bold;
    color:              #006699;
}


.table-header
{
    border:             0;
    width:              100%;
}


td
{
    font-family:        "arial,sans-serif";
    font-size:          10pt;
    padding-left:       5px;
}

th
{
    font-family:        "arial,sans-serif";
    font-size:          9pt;
    font-weight:        bold;
    padding-left:       5px;
    padding-right:      5px;
    padding-top:        0px;
    padding-bottom:     0px;
    text-align:         left;
    color:              #003366;
    background-color:   #CCCCCC;
    white-space:        nowrap;
}

</style>



<script>

//********************************************************************************************************
//  Global javascript variables
//********************************************************************************************************

var appletWindow;
var tdWidthPercentages;
var tdWidthPixels;
var isIEBrowser = false;




//********************************************************************************************************
//  Global Constants -  DO NOT CHANGE
//********************************************************************************************************

// The numbers are derive from AleretSeverity class.
var ALERT_STATUS_UNKNOWN       = 0;
var ALERT_STATUS_NORMAL        = 1;        // Same as "OK"  See AlertSeverity class.
var ALERT_STATUS_WARNING       = 2;
var ALERT_STATUS_MINOR         = 3;
var ALERT_STATUS_MAJOR         = 4;
var ALERT_STATUS_CRITICAL      = 5;
var ALERT_STATUS_INFORMATIONAL = 100;





function displaySubTitle()
{
    var urlParam = document.URL;
    var subIndex = urlParam.lastIndexOf( "=" );

    if ( subIndex >= 0 )
    {
        var indexLength = urlParam.length -  subIndex;
        var subTitle = urlParam.substr( subIndex + 1, indexLength - 1 );
        var filteredSubTitle = subTitle.replace( "%20", " " );

        document.write( filteredSubTitle );
    }
    else
    {
        document.write( "Default Title" )
    }
}

function displayColumnHeadLables()
{
    var columnHeader = "";
    appletWindow = window.opener;
    var eventListApplet = null;
    if ( appletWindow.document.getElementById("vlApplet") != null )
    {
        isIEBrowser = true;
        eventListApplet = appletWindow.document.getElementById("vlApplet");
    }
    else
    {
        isIEBrowser = false;
        eventListApplet = appletWindow.document.getElementById("vlApplet2");
    }

    var wbemTableModel = eventListApplet.getTableModel();
    var eventAppletJTable = eventListApplet.getQueryResultsTable();
    var tableColumnModel = eventAppletJTable.getColumnModel();
    var columnCount = tableColumnModel.getColumnCount();

    document.writeln( "<tr>" );

    for ( visualIndex = 0; visualIndex < columnCount; visualIndex++ )
    {
        // get the column header string shown on the browser(visual).
        var tableColumn = tableColumnModel.getColumn( visualIndex );
        var header_tableCellRenderer = tableColumn.getHeaderRenderer();
        columnHeader = header_tableCellRenderer.getText();

        document.writeln( "<th>" + columnHeader + "</th>" );
    }

    document.writeln( "</tr>" );
}

function displayStatusIcon( status )
{
    var imgTag = "<img src=\"../../mxportal/images/";
    var statusIconType = status;

    if ( isIEBrowser == false )
        statusIconType = status.intValue();

    switch( statusIconType )
    {
        case ALERT_STATUS_UNKNOWN:
            imgTag = imgTag + "unknown_11.gif";
            break;

        case ALERT_STATUS_NORMAL:
            imgTag = imgTag + "normal_11.gif";
            break;

        case ALERT_STATUS_WARNING:
            imgTag = imgTag + "warning_11.gif";
            break;

        case ALERT_STATUS_MINOR:
            imgTag = imgTag + "minor_11.gif";
            break;

        case ALERT_STATUS_MAJOR:
            imgTag = imgTag + "major_11.gif";
            break;

        case ALERT_STATUS_CRITICAL:
            imgTag = imgTag + "critical_11.gif";
            break;

        case ALERT_STATUS_INFORMATIONAL:
            imgTag = imgTag + "info_11.gif";
            break;

        default:
            imgTag = imgTag + "unknown_11.gif";
            break;
    }

    imgTag = imgTag + "\" />";

    document.writeln( "<td align=center>" + imgTag + "</td>" );
}

function determineTDWidthPercentages()
{
    var eventListApplet = null;

    if ( isIEBrowser == true )
        eventListApplet = appletWindow.document.getElementById("vlApplet");
    else eventListApplet = appletWindow.document.getElementById("vlApplet2");

    var eventAppletJTable = eventListApplet.getQueryResultsTable();
    var tableColumnModel = eventAppletJTable.getColumnModel();
    var columnCount = tableColumnModel.getColumnCount();
    var totalColumnWidth = tableColumnModel.getTotalColumnWidth();

    tdWidthPercentages = new Array( columnCount );
    tdWidthPixels = new Array( columnCount );

    for ( visualIndex = 0; visualIndex < columnCount; visualIndex++ )
    {
        var tableColumn = tableColumnModel.getColumn( visualIndex );
        tdWidthPixels[visualIndex] = tableColumn.getWidth();
        var percentage = ( tdWidthPixels[visualIndex] / totalColumnWidth ) * 100;
        tdWidthPercentages[visualIndex] = Math.round( percentage );

        if ( tdWidthPercentages[visualIndex] == 16 )
        {
            var internalDBColumnName = eventAppletJTable.getColumnName( visualIndex );
            if ( internalDBColumnName == "notices.generated" )
            {
                tdWidthPixels[visualIndex] = tdWidthPixels[visualIndex] + 11;
            }
        }
    }
}


function displaySelectedEventList()
{
    var strLength = 0;
    var eventListApplet = null;

    if ( isIEBrowser == true )
        eventListApplet = appletWindow.document.getElementById("vlApplet");
    else eventListApplet = appletWindow.document.getElementById("vlApplet2");

    var eventAppletJTable = eventListApplet.getQueryResultsTable();
    var tableColumnModel = eventAppletJTable.getColumnModel();
    var columnCount = tableColumnModel.getColumnCount();

    determineTDWidthPercentages();

    var numOfRowsSelected = eventAppletJTable.getSelectedRowCount();
    var bIsAnyRowsSelected = eventListApplet.getAllSelectedRows();

    for( i = 0; i < numOfRowsSelected; i++ )
    {
        var currentRow = eventListApplet.getSelectedRowByIndex( i );
        var dataToLong;

        document.writeln( "<tr>" );

        for ( visualIndex = 0; visualIndex < columnCount; visualIndex++ )
        {
            strLength = 0;

            // get the individual RENDERED data for that cell(row,col) position
            var unrenderedData = eventAppletJTable.getValueAt( currentRow, visualIndex );
            var renderedData = unrenderedData;

            var internalDBColumnName = eventAppletJTable.getColumnName( visualIndex );
            if ( internalDBColumnName == "notices.NoticeSeverity" )
            {
                displayStatusIcon( unrenderedData );
                continue;
            }
            else if ( (internalDBColumnName == "notices.State") ||
                      (internalDBColumnName == "notices.NoticeType") ||
                      (internalDBColumnName == "notices.generated" ) ||
                      (internalDBColumnName == "devices.ProductType") )
            {
                var data_tableCellRenderer = eventAppletJTable.getCellRenderer(currentRow, visualIndex );
                renderedData = data_tableCellRenderer.convertToRenderedData( unrenderedData );
            }
            else if ( (renderedData == null) ||
                      (renderedData == "") ||
                      (renderedData == " ") )
            {
                renderedData = "&nbsp;";
            }

            if ( renderedData != "&nbsp;" )
            {
                if ( isIEBrowser == true )
                    strLength = renderedData.length;
                else strLength = renderedData.length();
            }

            if ( (strLength * 11) > tdWidthPixels[visualIndex] )
            {
                var maxCharLimit = Math.round( tdWidthPixels[visualIndex] / 11 );
                renderedData = renderedData.substr( 0, maxCharLimit );
                renderedData = renderedData + "...";
            }

            document.writeln( "<td width=" + tdWidthPercentages[visualIndex] +
                                "% >" + renderedData + "</td>" );
        }

        document.writeln( "</tr>" );
    }
}
</script>
</head>


<body>

    <table class="table-header">
        <tr>
            <td class="subwindow-header">
                <script>
                    displaySubTitle();
                </script>
            </td>
        </tr>

        <tr>
            <td>
                <br>
                <table border=1 cellpadding=0 cellspacing=0
                                width=100%>
                    <script>
                        displayColumnHeadLables();
                        displaySelectedEventList();
                    </script>
                </table>
            </td>
        </tr>

    </table>

</body>

</html>
