<%--
/*-------------------------------------------------------------------------
---- Copyright 1997, 2003 Hewlett-Packard Corporation
---------------------------------------------------------------------------
----
---- Title: ViewEventDetails.jsp
----
---- Package:  www.ui.jsp
----
---- Description: View the event in details checking the first for the
----                    privilege before viewing.  It uses the various display
----                    handlers to render the view based upon the event type.
----
----------------------------------------------------------------------------
---- Date: 5/1/2003
---------------------------------------------------------------------------
---- $ProjectName: $
---- $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/ViewEventDetails.jsp,v 1.31 2005/07/30 15:00:31 klee Exp $
----------------------------------------------------------------------------*/
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.nodemanager.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="ViewEventDetailsRes" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%@ include file="EventCommonAPI.jsp" %>

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);

    ViewEventDetailsRes.init(loginBean,"ViewEventDetails");
%>

<html>
    <head>
        <link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>
        <script src="../javascript/EventScript.js"></script>
        <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

        <title>Generic Title from ViewEventDetails</title>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    <script language="JavaScript" type="text/javascript">

    var g_bPageLoaded = false;
    function myOnLoad()
    {
        if (g_bPageLoaded)
        {
            MxPortalRefreshStatusOverview();
        }
    }

    </script>

    </head>

    <body onLoad="OnLoadForViewEventDetailsSpace(), myOnLoad()" onResize="OnResizeForNewEditEventSpace()"  onUnload="OnUnloadForNewEditEventSpace()">
        <div class="NewEditEventSpace" id="NewEditEventSpaceID">
            <br>
            <hr>

<%
    String errorAlert = "A_OK";
    int alertID = 0;

    // get all the resources for this page
    ResourceBundle bundle = ViewEventDetailsRes.getBundle();

    alertID = Integer.parseInt( request.getParameter( "alertId" ) );
    if ( alertID == 0 )
        errorAlert = ( String ) bundle.getObject( "ViewEventDetails.NoEventHasBeenSelected" );
    else if ( alertID == -1 )
        errorAlert = ( String ) bundle.getObject( "ViewEventDetails.TooManyEventsSelected" );

    if ( errorAlert.equals( "A_OK" ) == false )
    {
%>
        <jsp:forward page="EmptyFrame.jsp">
            <jsp:param name="errorAlertMsg" value='<%= errorAlert %>' />
        </jsp:forward>
<%
    }

    int returnCode = viewEventDetails( alertID, out, session, loginBean, bundle );
    if ( returnCode != 0 )
    {
        if ( returnCode == g_NotEnoughPrivilege )
            errorAlert = ( String ) bundle.getObject( "ViewEventDetails.NotEnoughPrivilege" );
        else if ( returnCode == g_EventHasBeenDeleted )
            errorAlert = ( String ) bundle.getObject( "ViewEventDetails.EventHasBeenDeleted" );
        else errorAlert = ( String ) bundle.getObject( "ViewEventDetails.DeviceAssociatedWithEventBeenDeleted" );
%>
        <jsp:forward page="EmptyFrame.jsp">
            <jsp:param name="errorAlertMsg" value='<%= errorAlert %>' />
        </jsp:forward>
<%
    }
    else
    {
        String printEventDetailsButtonStr = ( String ) bundle.getObject( "ViewEventDetails.ButtonViewPrintableReport" );
        String closeEventDetailsButtonStr = ( String ) bundle.getObject( "ViewEventDetails.ButtonCloseEventDetails" );
        displayEventDetailsPrintButton( out, printEventDetailsButtonStr, closeEventDetailsButtonStr, alertID );
    }
%>
        </div>

<%

    if ( returnCode == 0 )
    {
%>
<script>
    g_bPageLoaded = true;
</script>
<%
    }
%>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>
</html>
