<%--
/*-------------------------------------------------------------------------
---- Copyright 1997, 2003 Hewlett-Packard Corporation
---------------------------------------------------------------------------
----
---- Title: ViewEvents.jsp
----
---- Package:  www.ui.jsp
----
---- Description: Event View display page loader
----
----------------------------------------------------------------------------
---- Date: 5/1/2003
---------------------------------------------------------------------------
---- $ProjectName: $
---- $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/ViewEvents.jsp,v 1.91 2005/07/30 15:00:31 klee Exp $
----------------------------------------------------------------------------*/
--%>
<jsp:useBean id="devViewRes" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.security.*" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.portal.list.MxSystemsListInstance" %>
<%@ page import="com.hp.mx.portal.list.MxSystemsListRenderer" %>
<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);
    devViewRes.init(loginBean,"com.hp.mx.portal.applet.view.WbemViewLoader");

    MxSystemsListRenderer listRenderer = new MxSystemsListRenderer(request, response,
                                                                   loginBean, out,
                                                                   true);

    String szViewId = request.getParameter("viewid");
%>
<link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
<script src="../javascript/EventScript.js"></script>
<script language="JavaScript" type="text/javascript">

/* *******************************************
 * Global Definitions
 *********************************************/
var WIDTH_MARGIN = 18;
var HEIGHT_MARGIN = 10;

//**********************************************************************************************
//  Functions for handling resizing and dealing with events edit buttons.
//**********************************************************************************************

function resetHelpContext()
{
    // if the page is being used for selection only as a component to other
    // pages then we do not need to set the help context.
    if (<%=listRenderer.m_bSelectionOnly%>)
        return;

    MxPortalWorkspaceSetHelpTopic("monitor_nav_eventView");
}

function myOnLoad()
{
    resetHelpContext();
    myOnResize();
    tableOnLoad();
    tableIsInitialized();

    // This call is here to tell the task wizard when the table is done laoding
    // so that it can display the select all check box at the appropriate time
    // The nodeListDoneLoading() function is on the selectionMenu.jsp file - one (1) level up.
    if (parent.nodeListDoneLoading != null)
    {
        parent.nodeListDoneLoading();
    }
}

function myOnResize()
{
    document.body.style.overflow = "hidden";
    resizeTableWidth();
    resizeTableHeight();
    document.body.style.overflow = "auto";
}

function resizeTableWidth()
{
    var workspaceWidth = MxDomGetBodyWidth() - WIDTH_MARGIN;

    MxDomSetWidth(document.getElementById("<%=listRenderer.ID_TABLE_ELEMENT%>"), workspaceWidth);
    MxTableSetWidth('<%=MxSystemsListInstance.ID_SYSTEM_LIST_TABLE%>', workspaceWidth - WIDTH_MARGIN);
}

function resizeTableHeight()
{
    var tempElement;
    var usedHeight = 0;
    var workspaceHeight = MxDomGetBodyHeight();

    tempElement = document.getElementById("<%=listRenderer.ID_TOP_BUTTON_ROW%>");
    if (tempElement != null)
        usedHeight += MxDomGetHeight(tempElement);

    tempElement = document.getElementById("<%=listRenderer.ID_SELECT_QUERY_ROW%>");
    if (tempElement != null)
        usedHeight += MxDomGetHeight(tempElement);

    tempElement = document.getElementById("<%=listRenderer.ID_STATUS_SUMMARY_PANEL%>");
    if (tempElement != null)
        usedHeight += MxDomGetHeight(tempElement);

    tempElement = document.getElementById("<%=listRenderer.ID_BOTTOM_BUTTON_ROW%>");
    if (tempElement != null)
        usedHeight += MxDomGetHeight(tempElement);

    var availableHeight = Math.max(0, workspaceHeight - usedHeight - HEIGHT_MARGIN);

    var tableScrollHeight = MxTableGetScrollHeight('<%=MxSystemsListInstance.ID_SYSTEM_LIST_TABLE%>');
    if (tableScrollHeight > availableHeight)
    {
        MxTableSetHeight('<%=MxSystemsListInstance.ID_SYSTEM_LIST_TABLE%>', availableHeight);
    }
    else if (tableScrollHeight < availableHeight)
    {
        MxTableSetHeight('<%=MxSystemsListInstance.ID_SYSTEM_LIST_TABLE%>', tableScrollHeight);
    }
}

function tableIsInitialized()
{
    if (!MxTableIsEmpty("<%=MxSystemsListInstance.ID_SYSTEM_LIST_TABLE%>"))
    {
        ourButtonManager.enableButtonById("<%=listRenderer.ID_PRINT_BUTTON%>");
    }

    if (!<%=listRenderer.m_bSuppressCustomize%>)
    {
       var customizeButton = "<a href='javascript:customizeButtonClicked()'>";
       customizeButton = customizeButton + "<%=devViewRes.get("Customize")%>" + "</a></td>";
       document.getElementById("<%=listRenderer.ID_CUSTOMIZE_BUTTON%>").innerHTML = customizeButton;
    }

    MxPortalManageMenuRefreshSelections();
}

function doEventTypeDrillDown(noticeId)
{
    document.getElementById("<%=listRenderer.ID_EDIT_EVENT_SPACE%>").contentWindow.document.location.replace("/ui/jsp/ViewEventDetails.jsp?alertId=" +
        noticeId + "&iframe=true");
}

function MyDrillDown(szDrillDownType, deviceId)
{
    document.getElementById("<%=listRenderer.ID_TABLE_ACTION_IFRAME%>").contentWindow.document.location.replace(
        "/mxportal/drilldown/MxDrillDown.jsp?drillDownType=" +
        szDrillDownType + "&deviceId=" + deviceId);
}

function customizeButtonClicked()
{
    document.location.replace("<%=MxOptions.URL_BASE%>/home/customColumn.jsp?queryID=<%=szViewId%>");
}

function selectionCleared(bIsUpdate)
{
    if (!<%=listRenderer.m_bSelectionOnly%>)
    {
        enableEventButtons( false );
    }
    else
    {
        // The enableApplyButton() function is on the targetSelection.jsp file - two (2) levels up.
        if (parent.parent.enableApplyButton != null)
        {
            parent.parent.enableApplyButton(false);
        }
    }
    if (!bIsUpdate)
    {
        closeEventDetailSpace();
    }
    MxPortalManageMenuRefreshSelections();
}

function selectionMade()
{
    if (!<%=listRenderer.m_bSelectionOnly%>)
    {
        if (<%=listRenderer.m_bHasEventModPriv%>)
        {
            enableEventButtons( true );
        }
    }
    else
    {
        // The enableApplyButton() function is on the targetSelection.jsp file - two (2) levels up.
        if (parent.parent.enableApplyButton != null)
        {
            parent.parent.enableApplyButton(true);
        }
    }
    closeEventDetailSpace();
    MxPortalManageMenuRefreshSelections();
}

function closeEventDetailSpace()
{
    var editEventSpaceCurrentURL = document.getElementById("<%=listRenderer.ID_EDIT_EVENT_SPACE%>").contentWindow.document.location.href;
    if ( (editEventSpaceCurrentURL.indexOf( "EmptyFrame.jsp?iframe=true" ) == -1))
    {
        document.getElementById("<%=listRenderer.ID_EDIT_EVENT_SPACE%>").contentWindow.document.location.replace("EmptyFrame.jsp?iframe=true");
    }
}

function my_MxPortalWorkspaceCreateUrl(szTitle, szSubTitle, szDrillDownURL)
{
    MxPortalWorkspaceCreateUrlEx(szTitle, szSubTitle, szDrillDownURL);
}

function clearEventsWork(clearEventsTimeStamp)
{
    document.getElementById("<%=listRenderer.ID_TABLE_ACTION_IFRAME%>").contentWindow.document.location.replace(
        "MxTableViewActions.jsp?systemListTimeStamp=" + clearEventsTimeStamp + "&clearEvents=true");
}

function deleteEventsWork(deleteEventsTimeStamp)
{
    document.getElementById("<%=listRenderer.ID_TABLE_ACTION_IFRAME%>").contentWindow.document.location.replace(
        "MxTableViewActions.jsp?systemListTimeStamp=" + deleteEventsTimeStamp + "&deleteEvents=true");
}

function enterCommentsWork(commentsToAdd, enterCommentsTimeStamp)
{
    document.getElementById("<%=listRenderer.ID_TABLE_ACTION_IFRAME%>").contentWindow.document.location.replace(
        "MxTableViewActions.jsp?systemListTimeStamp=" + enterCommentsTimeStamp + "&enterComments=true" +
        "&commentToAdd=" + encodeURIComponent(commentsToAdd));
    document.getElementById("<%=listRenderer.ID_EDIT_EVENT_SPACE%>").contentWindow.document.location.replace("EmptyFrame.jsp?iframe=true");
}

function assignEventsToWork(assignee, assignEventToTimeStamp)
{
    var strLen = assignee.length;
    var keepGoing = 1;
    var i = 0;

    while ( i < strLen && keepGoing == 1 )
    {
        var oneChar = assignee.charAt( i );

        switch( oneChar )
        {
          case "`":
          case "~":
          case "@":
          case "#":
          case "$":
          case "%":
          case "^":
          case "&":
          case "*":
          case "(":
          case ")":
          case "-":
          case "_":
          case "+":
          case "=":
          case "|":
                    keepGoing = 0;
                    break;
          default: i++
        }
    }

    if ( keepGoing == 0 )
    {
       alert( "<%=devViewRes.get("InvalidCharEntered")%>" );
    }
    else
    {
    document.getElementById("<%=listRenderer.ID_TABLE_ACTION_IFRAME%>").contentWindow.document.location.replace(
        "MxTableViewActions.jsp?systemListTimeStamp=" + assignEventToTimeStamp + "&assignEvents=true" +
        "&assignee=" + encodeURIComponent(assignee));
    document.getElementById("<%=listRenderer.ID_EDIT_EVENT_SPACE%>").contentWindow.document.location.replace("EmptyFrame.jsp?iframe=true");
    }
}

function tablePrintWork(timeStamp)
{
        reportWindow = window.open("MxTableViewPrinter.jsp?systemListTimeStamp=" + timeStamp + "&printable=yes", "MxTableViewPrinterWindow", "menubar=1, titlebar=1, toolbar=1, scrollbars=1, resizable=1");
        reportWindow.focus();
}

function disableEventButtons()
{
    if (!<%=listRenderer.m_bSelectionOnly%>)
    {
        var anyButton = document.getElementById("<%=listRenderer.ID_CLEAR_BUTTON%>");

        if ( anyButton )
        {
           ourButtonManager.disableButtonById("<%=listRenderer.ID_CLEAR_BUTTON%>");
           ourButtonManager.disableButtonById("<%=listRenderer.ID_DELETE_BUTTON%>");
           ourButtonManager.disableButtonById("<%=listRenderer.ID_ASSIGN_TO_BUTTON%>");
           ourButtonManager.disableButtonById("<%=listRenderer.ID_ENTER_COMMENT%>");
        }
        ourButtonManager.disableButtonById("<%=listRenderer.ID_PRINT_BUTTON%>");
    }
}

function myOnUnload()
{
    document.getElementById("ID_TABLE_ACTION_IFRAME").contentWindow.document.location.replace("/ui/jsp/removeInstance.jsp?systemListTimeStamp=" + thisTimeStamp);
}

</script>

<%
    listRenderer.dumpWholeSystemsListPage();
%>
