<%-- xeHdr.jsp - template for unregistered JSP pages
    Created by: John DeNardo
    $ProjectName: j:/maple/coreWap.pj $
    $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/XeHdr.jsp,v 1.25 2005/01/15 03:04:21 farley Exp $
--%>

<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page errorPage="handleJspError.jsp" %>

<jsp:useBean id="XEUtil" class="com.hp.mx.portal.applet.utilities.XeJspUtil" scope="session" />

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);
%>

<HTML>
<HEAD>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
<%
    long stTime = System.currentTimeMillis();
    DebugOutput.log(XEUtil.getDebugSubsystem(), 5, "JSP Page start "+stTime);

    String PageName = "ui/jsp/resources/" + request.getParameter("PageName");
    DebugOutput.log(XEUtil.getDebugSubsystem(), 5, "JSP Page name to include is "+PageName+ " at time "+(System.currentTimeMillis()-stTime));
    Locale locale = XEUtil.getUserSession().getSessionsLocale();

    // get the PageName.properties bundle
    ResourceBundle bundle = ResourceBundle.getBundle(PageName,locale);
    DebugOutput.log(XEUtil.getDebugSubsystem(), 10, "JSP loaded bundle for "+PageName+" locale "+locale+" at "+(System.currentTimeMillis()-stTime));

    // get all the resources for this page and put them into the session object
    boolean isLoaded = false;
    if (session.getAttribute(PageName+".isPageLoaded") != null)
    {
        isLoaded = true;
    }

    for (Enumeration e = bundle.getKeys();e.hasMoreElements();)
    {
        String key = (String)e.nextElement();
        if (isLoaded == false || key.startsWith("Main.") || key.startsWith("AppLoader"))
        {
            String value = bundle.getString(key);
            session.setAttribute(key,value);
        }
    }

    session.setAttribute(PageName+".isPageLoaded", "true");

    /** User check based on UserClass no longer valid, so note it if we have one **/
    String reqUser = (String) session.getAttribute("Main.User");
    if (reqUser!=null)
    {
        String includeJsp = (String)session.getAttribute("Main.IncludeBody");
        DebugOutput.log(XEUtil.getDebugSubsystem(), 0, "XEHDR: JSP " + includeJsp + " (" + PageName + ") using old user class: " + reqUser);
        session.removeAttribute("Main.User"); // remove so this does not use a cached pages info...
    }

    // clear out any old ids, just in case
    if (session.getAttribute("Main.Help") != null)
    {
         session.removeAttribute("Main.Help");
    }

    // GET INCLUDE FILE INFORMATION
    String includeBody = request.getParameter("IncludeBody");

    if (includeBody==null)
    {
       includeBody = (String) session.getAttribute("Main.IncludeBody");
    }

    String includeHead = request.getParameter("IncludeHead");
    if (includeHead==null)
    {
       includeHead = (String) session.getAttribute("Main.IncludeHead");
    }

    if (includeHead != null && includeHead.trim().length() == 0)
    {
        includeHead = null;
    }

    // GET Title FILE INFORMATION
    String title = request.getParameter("title");
    if (title == null || title.trim().length() == 0)  //vyp 12/10/01.
    {
       title = (String) session.getAttribute("Main.Title");
    }

    if (title == null || title.trim().length() == 0)
    {
        title = "";
    }
    DebugOutput.log(XEUtil.getDebugSubsystem(), 10, "JSP include head "+includeHead+" body " + includeBody+" title "+title+ " at "+(System.currentTimeMillis()-stTime) );

    // clear out session vars used by the XEhdr....
    if (session.getAttribute("Main.Title") != null)
    {
         session.removeAttribute("Main.Title");
    }

    if (session.getAttribute("Main.IncludeBody") != null)
    {
         session.removeAttribute("Main.IncludeBody");
    }

    if (session.getAttribute("Main.IncludeHead") != null)
    {
         session.removeAttribute("Main.IncludeHead");
    }
%>
    <TITLE><%= title %></TITLE>
    <LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>
<%
    // tell the request that it is being processed by the xe hdr =, used later for a security check by other pages
    request.setAttribute("fromXeHdr", "true");
    if (includeHead!=null)
    {
       try
       {

%>
       <jsp:include page="<%= includeHead %>" flush="true"/>
<%
       }
       catch (Exception ex)
       {
          DebugOutput.log(XEUtil.getDebugSubsystem(), 2, "JSP exception on loading header "+includeHead+" ex "+ex );
       }
   }
   if ( (includeBody.compareToIgnoreCase("ViewDevices.jsp") != 0) && (includeBody.compareToIgnoreCase( "ViewEvents.jsp" ) != 0) )
   {
%>
</HEAD>
        <BODY>
<%
   }
        //////////////////////////////////////////////////////////////////////////
        // Insert Content file
        //////////////////////////////////////////////////////////////////////////
       try
       {
    DebugOutput.log(XEUtil.getDebugSubsystem(), 5, "JSP before include "+(System.currentTimeMillis()-stTime));

        %>
        <!-- including body, body is <%= includeBody %> -->
         <jsp:include page="<%= includeBody %>" flush="true"/>
<%
       }
       catch (Exception ex)
       {
          DebugOutput.log(XEUtil.getDebugSubsystem(), 2, "JSP exception on loading body "+includeBody+" ex "+ex );
       }
%>
        </body>
</HTML>
<%
    DebugOutput.log(XEUtil.getDebugSubsystem(), 2, "JSP page took "+(System.currentTimeMillis()-stTime)+" ms to load");
%>
