<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<xsl:template name="Head">
		<head>
			<link href="/mxportal/bladeime/skin/css/default.css" type="text/css" rel="stylesheet"/>
			<link href="/mxportal/bladeime/skin/css/blue_theme.css" type="/text/css" rel="stylesheet"/>
			<link href="/mxportal/bladeime/skin/css/mxportalEx.css" type="/text/css" rel="stylesheet"/>
			<script language="Javascript" src="/mxportal/bladeime/skin/js/tableManager.js" type="text/javascript">Table manipulation script</script>
			<script language="Javascript" src="/mxportal/bladeime/skin/js/global.js" type="text/javascript">Global script</script>
			<script language="Javascript" src="/mxportal/bladeime/skin/js/Skin.js" type="text/javascript">Skinnable view scripts</script>
		</head>
	</xsl:template>
	<xsl:template name="Attribute">
		<tr>
			<td nowrap="">
				<xsl:value-of select="./Name"/>
				<xsl:text>&#160;&#160;&#160;</xsl:text>
			</td>
			<td nowrap="">
				<xsl:choose>
					<xsl:when test="./@displayAsProgress='true'">
						<xsl:if test="./Value!='NotAvailable'">
							<img height="13" width="13" border="0">
								<xsl:attribute name="title"><xsl:value-of select="./Value"/></xsl:attribute>
								<xsl:attribute name="src"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="./Value"/><xsl:text>.gif</xsl:text></xsl:attribute>
							</img>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="./@displayAsImage='true'">
							<img>
								<xsl:attribute name="title"><xsl:value-of select="./@titleStatus"/></xsl:attribute>
								<xsl:attribute name="src"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="./Value"/><xsl:text>.gif</xsl:text></xsl:attribute>
							</img>
						</xsl:when>
							<xsl:when test="./@displayAsURL='true'">
								<a style="CURSOR: pointer;">
									<xsl:attribute name="href"><xsl:value-of select="./@URL"/></xsl:attribute>
									<xsl:value-of select="./Value"/>
								</a>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="./Value"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="PowerSupplyUnit">
	  <tr> 
			<xsl:for-each select="//PowerSupplyUnit">
				<xsl:if test="./BayNumber!='-1'">
					<tr>
						<td width="30">&#160;
								</td>
						<td>
								<xsl:call-template name="Section">
									<xsl:with-param name="sectionName">
										<xsl:text>Power Supply Unit</xsl:text>
									</xsl:with-param>
									<xsl:with-param name="sectionNameDisplay"><xsl:value-of select="//I18N/L10NPowerSupplyUnit"/></xsl:with-param>
								</xsl:call-template>
						</td>
					</tr>
				</xsl:if>
			</xsl:for-each>
 	 </tr>
	</xsl:template>
	<xsl:template name="renderDevice">
		<xsl:param name="render">0</xsl:param>
		<td class="deviceCell" valign="top" align="middle">
			<xsl:attribute name="rowspan">
				<xsl:value-of select="SlotsUsed/YDirection*1"/>
			</xsl:attribute>
			<xsl:attribute name="colspan">
				<xsl:value-of select="SlotsUsed/XDirection*2"/>
			</xsl:attribute>
			<xsl:attribute name="width">
				<xsl:value-of select="SlotsUsed/XDirection*2*11"/>
			</xsl:attribute>
			<xsl:attribute name="height">
				<xsl:choose>
					<xsl:when test="SlotsUsed/YDirection=1">
						<xsl:text>60</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>120</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
			<xsl:attribute name="id">
				<xsl:text>Bay </xsl:text><xsl:value-of select="SlotNumber"/>
			</xsl:attribute>
			<xsl:choose>
				<xsl:when test="Common/DrillDownURL!=''">
					<xsl:attribute name="drillDownUrl">
						<xsl:value-of select="Common/DrillDownURL"/>
					</xsl:attribute>
					<xsl:attribute name="style">
						<xsl:text>
							{ cursor: hand; cursor: pointer; }
						</xsl:text>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="style">
						<xsl:text>cursor:default</xsl:text>
					</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:attribute name="title">
				<xsl:choose>
					<xsl:when test="./@type!='Empty'">
						<xsl:value-of select="//I18N/L10NBay"/>
							<xsl:text>&#160;</xsl:text>
								<xsl:choose>
									<xsl:when test="SlotNumber=9999">
										<xsl:text>B</xsl:text>
									</xsl:when>
									<xsl:otherwise>
										<xsl:choose>
											<xsl:when test="SlotNumber=0">
												<xsl:text>A</xsl:text>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="SlotNumber"/>
											</xsl:otherwise>
										</xsl:choose>	
									</xsl:otherwise>
								</xsl:choose>
						<xsl:text>, </xsl:text>
						<xsl:value-of select="Common/Name"/>
						<xsl:text>, </xsl:text>
						<xsl:value-of select="Common/Product"/>
					</xsl:when>
					<xsl:when test="./@location!='Rear'">
						<xsl:value-of select="//I18N/L10NEmptyBay"/>
					</xsl:when>
					<xsl:when test="./@location='Rear' and (./SlotNumber='0' or ./SlotNumber='9999')">
						<xsl:value-of select="//I18N/L10NEmptyBay"/>
					</xsl:when>
				</xsl:choose>
			</xsl:attribute>
			<xsl:attribute name="background"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="Image/Front"/></xsl:attribute>
			<table cellspacing="0" cellpadding="0" border="0">
				<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>5</xsl:text></xsl:attribute>
				<tbody>
					<xsl:choose>
						<xsl:when test="$render='bottomhalf'">
							<xsl:if test="Image/Status!=''">
								<tr>
									<td valign="bottom">
										<div style="PADDING-LEFT: 3px; PADDING-TOP: 1px">
											<img height="13" alt="" width="13" border="0">
												<xsl:attribute name="title"><xsl:value-of select="Image/titleStatus"/></xsl:attribute>
												<xsl:attribute name="src"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="Image/Status"/><xsl:text>.gif</xsl:text></xsl:attribute>
											</img>
										</div>
									</td>
								</tr>
							</xsl:if>
							<xsl:if test="./@type!='Empty'">
								<tr>
									<td valign="bottom">
										<input type="checkbox" devid="bay" rowselector="yes">
											<xsl:attribute name="name"><xsl:text>SelectDevice</xsl:text></xsl:attribute>
											<xsl:attribute name="id"><xsl:value-of select="SlotNumber"/></xsl:attribute>
											<xsl:attribute name="value"><xsl:value-of select="Common/NodeId"/></xsl:attribute>
										</input>
									</td>
								</tr>
							</xsl:if>
						</xsl:when>
						<xsl:otherwise>
							<xsl:if test="./@type!='Empty'">
								<tr>
									<td valign="top">
										<input type="checkbox" devid="bay" rowselector="yes">
											<xsl:attribute name="name"><xsl:text>SelectDevice</xsl:text></xsl:attribute>
											<xsl:attribute name="id"><xsl:value-of select="SlotNumber"/></xsl:attribute>
											<xsl:attribute name="value"><xsl:value-of select="Common/NodeId"/></xsl:attribute>
										</input>
									</td>
								</tr>
							</xsl:if>
							<xsl:if test="Image/Status!=''">
								<tr>
									<td valign="center">
										<div style="PADDING-LEFT: 3px; PADDING-TOP: 1px">
											<img height="13" alt="" width="13" border="0">
												<xsl:attribute name="title"><xsl:value-of select="Image/titleStatus"/></xsl:attribute>
												<xsl:attribute name="src"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="Image/Status"/><xsl:text>.gif</xsl:text></xsl:attribute>
											</img>
										</div>
									</td>
								</tr>
							</xsl:if>
						</xsl:otherwise>
					</xsl:choose>
				</tbody>
			</table>
		</td>
	</xsl:template>
	<xsl:template name="renderFrontView">
		<td>
			<!--<xsl:value-of select="//I18N/L10NFrontView"/>-->
			<table class="systemStatusTable" cellspacing="0" cellpadding="0" align="center" border="0">
			<xsl:attribute name="powerZone"><xsl:value-of select="Common/PowerZone"/></xsl:attribute>
				<xsl:attribute name="id"><xsl:value-of select="@Name"/><xsl:text>3</xsl:text></xsl:attribute>
				<tbody>
					<tr>
						<td>
							<table cellspacing="0" cellpadding="0" border="0">
								<xsl:attribute name="height"><xsl:choose><xsl:when test="@type='e-class'"><xsl:text>65</xsl:text></xsl:when><xsl:otherwise><xsl:text>129</xsl:text></xsl:otherwise></xsl:choose></xsl:attribute>
								<xsl:attribute name="width"><xsl:choose><xsl:when test="@type='e-class'"><xsl:text>444</xsl:text></xsl:when><xsl:otherwise><xsl:text>242</xsl:text></xsl:otherwise></xsl:choose></xsl:attribute>
								<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>4</xsl:text></xsl:attribute>
								<tbody>
									<xsl:choose>
										<xsl:when test=" @type='e-class'">
											<tr>
												<xsl:for-each select="Device[@location='Front']">
													<xsl:call-template name="renderDevice">
														<xsl:with-param name="render">
															<xsl:text>tophalf</xsl:text>
														</xsl:with-param>
													</xsl:call-template>
												</xsl:for-each>
											</tr>
										</xsl:when>
										<xsl:otherwise>
											<tr>
												<xsl:for-each select="Device[@location='Front' and SlotNumber = 0]">
													<xsl:call-template name="renderDevice">
														<xsl:with-param name="render">
															<xsl:text>tophalf</xsl:text>
														</xsl:with-param>
													</xsl:call-template>
												</xsl:for-each>
												<xsl:for-each select="Device[@location='Front']">
													<xsl:if test="SlotNumber &gt; 0 and SlotNumber &lt; 9">
														<xsl:call-template name="renderDevice">
															<xsl:with-param name="render">
																<xsl:text>tophalf</xsl:text>
															</xsl:with-param>
														</xsl:call-template>
													</xsl:if>
												</xsl:for-each>
												<xsl:for-each select="Device[@location='Front' and SlotNumber = 9999]">
													<xsl:call-template name="renderDevice">
														<xsl:with-param name="render">
															<xsl:text>tophalf</xsl:text>
														</xsl:with-param>
													</xsl:call-template>
												</xsl:for-each>
											</tr>
											<tr>
												<xsl:for-each select="Device[@location='Front' and SlotNumber &gt; 8]">
													<xsl:if test="SlotNumber != 9999">
														<xsl:call-template name="renderDevice">
															<xsl:with-param name="render">
																<xsl:text>bottomhalf</xsl:text>
															</xsl:with-param>
														</xsl:call-template>
													</xsl:if>
												</xsl:for-each>
											</tr>
										</xsl:otherwise>
									</xsl:choose>
								</tbody>
							</table>
						</td>
					</tr>
				</tbody>
			</table>
		</td>
	</xsl:template>
	<xsl:template name="renderPU">
		<xsl:param name="repeat">0</xsl:param>
		<xsl:param name="render">0</xsl:param>
		<td style="cursor:default" class="deviceCell" valign="top" align="middle">
			<xsl:attribute name="id"><xsl:text>Bay </xsl:text><xsl:value-of select="PowerSupplyUnit/BayNumber"/></xsl:attribute>
			<xsl:if test="Common/DrillDownURL!=''">
				<xsl:attribute name="onclick"><xsl:text>drillDown('</xsl:text><xsl:value-of select="Common/DrillDownURL"/><xsl:text>')</xsl:text></xsl:attribute>
			</xsl:if>
			<xsl:if test="number($repeat) = 2">
				<!-- Display tool tip only if ur rendering front view -->
				<xsl:attribute name="title"><xsl:choose>
					<xsl:when test="BayNumber!='-1'">
						<!-- Device is present -->
						<xsl:value-of select="//I18N/L10NBay"/><xsl:text>&#160;</xsl:text><xsl:value-of select="BayNumber"/>
					</xsl:when>
					<xsl:otherwise><!-- Device is absent -->
						<xsl:choose>
							<xsl:when test="../@iloPresent='No'">
							<xsl:value-of select="//I18N/L10NILOUpdateMessage"/>
							</xsl:when>
							<xsl:otherwise>
							<xsl:value-of select="//I18N/L10NEmptyBay"/>
							</xsl:otherwise></xsl:choose></xsl:otherwise></xsl:choose></xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="number($repeat) = 2">
					<xsl:attribute name="background"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="Image/Front"/><xsl:text>.gif</xsl:text></xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="background"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="Image/Rear"/><xsl:text>.gif</xsl:text></xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<table cellspacing="0" cellpadding="0" border="0">
				<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>5</xsl:text></xsl:attribute>
				<tbody>
					<tr>
						<td valign="bottom">
							<div style="PADDING-LEFT: 3px; PADDING-TOP: 3px">
								<img height="13" alt="" width="13" border="0">
									<xsl:if test="number($repeat) = 2">
										<xsl:attribute name="title">
											<xsl:choose>
												<xsl:when test="Image/Status='NoStatus'">
													<xsl:value-of select="//I18N/L10NEmptyBay"/>
												</xsl:when>
												<xsl:otherwise>
													<xsl:choose>
														<xsl:when test="../@iloPresent='No'">
															<xsl:value-of select="//I18N/L10NILOUpdateMessage"/>
														</xsl:when>
														<xsl:otherwise>
															<xsl:value-of select="Image/titleStatus"/>
														</xsl:otherwise>
													</xsl:choose>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:attribute>
									</xsl:if>
									<xsl:choose>
										<xsl:when test="number($repeat) = 2">
											<xsl:attribute name="src">
												<xsl:text>/mxportal/bladeime/skin/images/</xsl:text>
													<xsl:value-of select="Image/Status"/>
												<xsl:text>.gif</xsl:text>
											</xsl:attribute>
										</xsl:when>
										<xsl:otherwise>
											<xsl:attribute name="src">
												<xsl:text>/mxportal/bladeime/skin/images/NoStatus.gif</xsl:text>
											</xsl:attribute>
										</xsl:otherwise>
									</xsl:choose>
								</img>
							</div>
						</td>
					</tr>
				</tbody>
			</table>
		</td>
	</xsl:template>
	
	<xsl:template name="renderRearView">
		<td>
			<xsl:value-of select="//I18N/L10NRearView"/>
			<table class="systemStatusTable" cellspacing="0" cellpadding="0" align="center" border="0">
			<xsl:attribute name="powerZone"><xsl:value-of select="Common/PowerZone"/></xsl:attribute>
				<xsl:attribute name="id"><xsl:value-of select="@Name"/><xsl:text>3</xsl:text></xsl:attribute>
				<tbody>
					<tr>
						<td>
							<table cellspacing="0" cellpadding="0" border="0">
								<xsl:attribute name="height">
									<xsl:choose>
										<xsl:when test="@type='e-class'">
											<xsl:text>65</xsl:text>
										</xsl:when>
										<xsl:otherwise>
											<xsl:text>129</xsl:text>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:attribute>
								<xsl:attribute name="width">
									<xsl:choose>
										<xsl:when test="@type='e-class'">
											<xsl:text>444</xsl:text>
										</xsl:when>
										<xsl:otherwise>
											<xsl:text>242</xsl:text>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:attribute>
								<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>4</xsl:text></xsl:attribute>
								<tbody>
									<xsl:choose>
										<xsl:when test=" @type='e-class'">
											<tr>
												<xsl:for-each select="Device[@location='Rear']">
													<xsl:call-template name="renderDevice">
														<xsl:with-param name="render">
															<xsl:text>tophalf</xsl:text>
														</xsl:with-param>
													</xsl:call-template>
												</xsl:for-each>
											</tr>
										</xsl:when>
										<xsl:otherwise>
											<tr>
												<xsl:for-each select="Device[@location='Rear' and SlotNumber = 9999]">
													<xsl:call-template name="renderDevice">
														<xsl:with-param name="render">
															<xsl:text>tophalf</xsl:text>
														</xsl:with-param>
													</xsl:call-template>
												</xsl:for-each>
												<xsl:for-each select="Device[@location='Rear']">
													<xsl:if test="SlotNumber &gt; 0 and  SlotNumber &lt; 9">
														<xsl:call-template name="renderDevice">
															<xsl:with-param name="render">
																<xsl:text>tophalf</xsl:text>
															</xsl:with-param>
														</xsl:call-template>
													</xsl:if>
												</xsl:for-each>
												<xsl:for-each select="Device[@location='Rear' and SlotNumber = 0]">
													<xsl:call-template name="renderDevice">
														<xsl:with-param name="render">
															<xsl:text>tophalf</xsl:text>
														</xsl:with-param>
													</xsl:call-template>
												</xsl:for-each>
											</tr>
											<tr>
												<xsl:for-each select="Device[@location='Rear' and SlotNumber = 17]">
													<xsl:call-template name="renderDevice">
														<xsl:with-param name="render">
															<xsl:text>tophalf</xsl:text>
														</xsl:with-param>
													</xsl:call-template>
												</xsl:for-each>
												<xsl:for-each select="Device[@location='Rear' and SlotNumber = 18]">
													<xsl:call-template name="renderDevice">
														<xsl:with-param name="render">
															<xsl:text>tophalf</xsl:text>
														</xsl:with-param>
													</xsl:call-template>
												</xsl:for-each>
											</tr>
										</xsl:otherwise>
									</xsl:choose>
								</tbody>
							</table>
						</td>
					</tr>
				</tbody>
			</table>
		</td>
	</xsl:template>
	<xsl:template name="Section">
		<xsl:param name="sectionName">0</xsl:param>
		<xsl:param name="sectionNameDisplay">0</xsl:param>
		<tr>
			<td align="left">
				<table cellspacing="0" cellpadding="0" border="0" id="table5">
					<tbody>
						<tr>
							<td align="left">
								<b>
									<xsl:value-of select="$sectionNameDisplay"/>
								</b>
							</td>
						</tr>
						<tr>
							<td align="center" colspan="">
								<div style="margin-top:-1px;padding:4px;">
									<xsl:attribute name="id"><xsl:value-of select="$sectionName"/></xsl:attribute>
									<table class="window-border-table-small" cellspacing="0" cellpadding="0" border="0">
										<xsl:attribute name="id"><xsl:value-of select="$sectionName"/><xsl:text>1</xsl:text></xsl:attribute>
										<tbody>
											<tr>
												<td align="middle">
													<div style="PADDING-RIGHT: 10px; MARGIN-TOP: -1px; PADDING-LEFT: 10px;  PADDING-TOP: 2px">
														<table cellspacing="0" cellpadding="0" border="0">
															<xsl:attribute name="id"><xsl:value-of select="$sectionName"/><xsl:text>2</xsl:text></xsl:attribute>
															<tbody>
																<tr>
																	<td valign="top" nowrap="">
																		<table class="pad1x10" cellspacing="0" cellpadding="0" border="0">
																			<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>6</xsl:text></xsl:attribute>
																			<xsl:for-each select=".//Attribute[@Section=$sectionName and (@location='Both' or @location='EnclosureView')]">
																				<xsl:call-template name="Attribute"/>
																			</xsl:for-each>
																		</table>
																	</td>
																</tr>
															</tbody>
														</table>
													</div>
												</td>
											</tr>
										</tbody>
									</table>
								</div>
							</td>
						</tr>
					</tbody>
				</table>
			</td>
		</tr>
	</xsl:template>
</xsl:stylesheet>
