<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<%@ page import="com.hp.mx.portal.core.MxAction"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobMessages"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskScheduleParams"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    // the current JSP displayed is sent to this page.  If we
    // encounter an error, then reload the given page
    String currentTaskWizardPage = request.getParameter("taskWizardPage");

    // build parameter array
    int    success        = MxTaskWizardInstance.NO_SAVE_ERROR;
    int    len            = inst.getParameterLen();
    String paramStrings[] = new String[len];

    for (int i = 0; i < len; i++)
    {
        paramStrings[i] = request.getParameter("PARAM_" + i);
    }

    MxTaskScheduleParams params = new MxTaskScheduleParams(loginBean);

    // if the length (len) of the parameters is zero (0), don't set the value
    // in MxTaskScheduleParams; leave that internal value set to null
    if (len > 0)
    {
        params.setMxParameterStrings(paramStrings);
    }

    // check to make sure that the XWindowLoc contains valid characters
    if (params.setXWindowLoc(request.getParameter("XWindowLoc")) == false)
    {
        success = MxTaskWizardInstance.X_WINDOW_LOC_ERROR;
    }

    // execute the task - will save the TaskID.  The Job List will call
    // the getNewTaskID() function, which only returns the value once
    // and highlight that Job
    if (success == MxTaskWizardInstance.NO_SAVE_ERROR)
    {
        success = inst.executeTask(params);
    }

    StringBuffer script = new StringBuffer(500);

    if (success != MxTaskWizardInstance.NO_SAVE_ERROR)
    {
        // if (currentTaskWizardPage == null, then display an error page instead
        // of jumpToWizardStep() or location.replace(currentTaskWizardPage)
        if (currentTaskWizardPage == null)
        {
            // display page that state "The tool 'tool name' has been launched."
            StringBuffer url = new StringBuffer(100);
            url.append(MxOptions.URL_BASE);
            url.append("/taskandjob/errorTaskWizard.jsp?timeStamp=");
            url.append(timeStamp);

            script.append("document.location.replace('");
            script.append(url.toString());
            script.append("');");
        }
        else
        {
            MxTaskAndJobMessages msg = inst.getMessages();
            // forward back to parameter page - if parameter.jsp finds PARAM_x, it will populate those
            // fields and display the error (exception) message to the user
            //
            // add error message first
            script.append("alert(\"");

            if (success == MxTaskWizardInstance.X_WINDOW_LOC_ERROR)
            {
                MxTaskAndJobResourceBundle rb = inst.getRB();
                script.append(rb.getString("ERROR_XWINDOW_1") + " " + rb.getString("ERROR_TASK_NAME_3"));
            }
            else
            {
                script.append(msg.getMessage());
            }

            script.append("\");");

            // add the action to perform
            if ((success == MxTaskWizardInstance.LIST_SAVE_ERROR) || (success == MxTaskWizardInstance.NODE_SAVE_ERROR))
            {
                // if the error is LIST_ERROR or NODE_ERROR, jump back to the
                // first step of the tool (usually the TSP)
                script.append("jumpToWizardStep(1);");
            }
            else
            {
                script.append("location.replace(\"");
                script.append(currentTaskWizardPage);
                script.append("?err=1&");
                script.append(request.getQueryString());
                script.append("\");\n");
            }
        }
    }
    else
    {
        if (inst.getToolType() == MxTaskWizardInstance.TOOL_TYPE_WEBLAUNCH)
        {
            // if it was successful - get/set the JobID so that that Job is selected on the Job List
            script.append( inst.getWebLaunchScriptToLaunch() );
            // if this script contains "window.open", then also append
            // "MxPortalActionStart('VIEW_JOBS..." so the portal page does not
            // sit at the "Run Now" page
            if (script.indexOf("window.open") != -1)
            {
                // display page that state "The tool 'tool name' has been launched."
                StringBuffer url = new StringBuffer(100);
                url.append(MxOptions.URL_BASE);
                url.append("/taskandjob/webLaunched.jsp?toolName=");
                url.append(inst.getToolName());

                script.append("parent.document.location.replace('");
                script.append(url.toString());
                script.append("');");
            }
        }
        else
        {
            // else - let's just show the Task Instance Results for this job
            // - NEED to keep it refreshing until it is complete.  Hide the jobList.
            // It's possible that we did not get a JobID for this tool execution; if
            // true, then don't send the "select" parameter
            script.append("MxPortalActionStart('VIEW_JOBS'");
            // this call removes the newJobID from the MxTaskWizardInstance
            String newJobID = inst.getNewJobID();

            if (newJobID.equals("") == false)
            {
                script.append(", 'hidden=1&select=");       // start addition url params
                script.append(newJobID);
                script.append("'");                         // end additional url params
            }

            script.append(");");
        }
    }
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript'>
            var nodes     = "<%=inst.getSelectedNodesString()%>";
            var html      = null;
            var parentDoc = findTaskWizardParent(this);

            if (<%=success%> == <%=MxTaskWizardInstance.NO_SAVE_ERROR%>)
            {
                if (nodes != "")
                {
                    // set the selected nodes in the tool description area
                    if (nodes.indexOf(",") != -1)
                    {
                        html = parentDoc.targets + ":&nbsp;" + nodes;
                    }
                    else
                    {
                        html = parentDoc.target + ":&nbsp;" + nodes;
                    }

                    MxPortalWorkspaceSetSubtitleHtml(html);
                }
            }

            <%=script.toString()%>

        </script>
    </head>
</html>
